// gprod.cpp		ver.0.072
//copyright 1998-2006 Beer[Tsutsumi Hiroyuki]

#include	"gprod.h"

#define	VER		"ver.0.072"
#define	DATE	"2006. 2.16"

int	main()
{
	if(!(tr=BTranslatorRoster::Default()))return(1);
	gprod	app;
	app.Run();
	return(0);
}
//------------------------------------------------
gprod::gprod():BApplication("application/x-vnd.Beer-gprod")
{
#if	B_BEOS_VERSION>=0x0520
	app_info	ai;	be_app->GetAppInfo(&ai);
	BPath	ap(&ai.ref),dp;
	ap.GetParent(&dp);
	BPath	lp(dp);
	lp.Append("Language/Dictionaries");
	lp.Append("gpro");
	be_locale.LoadLanguageFile(lp.Path());
#endif

	vcanvas.Set(0,0,0,0);
	BRect	frame;
	frame.Set(100,100,499,399);
	w=new gprodwindow(frame);
	fp=NULL;		//file-panel
}

void gprod::RefsReceived(BMessage *msg)
{
	entry_ref	eref;
	msg->FindRef("refs",&eref);
	load(eref);
	fp=NULL;		//file-panel
}

void gprod::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case B_SIMPLE_DATA:{
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){
				canvasok=false;
				for(int i=0;i<files;i++){
					entry_ref	eref;
					msg->FindRef("refs",i,&eref);
					load(eref);
					if(canvasok)break;
				}
			}
		}break;
		case B_SAVE_REQUESTED:{
			if(canvas!=BRect(0,0,0,0)){
				entry_ref	dir;
				const char	*name;
				msg->FindRef("directory",&dir);
				msg->FindString("name",&name);
				save(dir,name);
			}
			fp=NULL;		//file-panel
		}break;
		case B_CANCEL:{
			fp=NULL;		//file-panel
		}break;
		default:{
			BApplication::MessageReceived(msg);
		}break;
	}
}

void gprod::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"Gprod "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.eonet.ne.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
} 

void gprod::load(entry_ref &eref)
{
	BFile	f(&eref,O_RDONLY|O_BINARY);
	char	ss[8];
	int	l;
	struct stat	fst;
	f.GetStat(&fst);
	//load header
	char	hd[16];
	f.Read(hd,16);
	if(strncmp(hd,"gprod_01",8))return;
	int	cw=B_BENDIAN_TO_HOST_INT16(*((uint16*)(hd+8)));
	int	ch=B_BENDIAN_TO_HOST_INT16(*((uint16*)(hd+10)));
	//set new-canvas
	canvasok=false;
	BMessage	mes('fine');
	mes.AddRect("bounds",BRect(0,0,cw-1,ch-1));
	BMessenger(w->v).SendMessage(&mes);		//w->PostMessage(&mes,w->v);
	while(!canvasok)snooze(1);
	//load color-def(toriaezu)
	f.Read(ss,8);
	l=B_BENDIAN_TO_HOST_INT16(*((uint16*)(ss+6)));
	uchar	cc=*(ss+5);
	char	*cd=new char[l];
	f.Read(cd,l);
	for(int i=0;i<cc;i++){
		cx[i]=0;
		for(int j=0;j<64;j++){
			if(B_BENDIAN_TO_HOST_INT32(*((uint32*)cd+i))!=pal[j])continue;
			cx[i]=j;break;
		}
	}
	delete cd;
	//load pattern-def(toriaezu)
	f.Read(ss,8);
	l=B_BENDIAN_TO_HOST_INT16(*((uint16*)(ss+6)));
	uchar	pc=*(ss+5);
	char	*pd=new char[l];
	f.Read(pd,l);
	for(int i=0;i<pc;i++){
		px[i]=0;
		for(int j=0;j<16;j++){
			int	jj;
			for(jj=0;jj<16;jj++){
				if(B_BENDIAN_TO_HOST_INT16(*((uint16*)pd+16*i+jj))!=pat[j][jj])break;
			}
			if(jj<16)continue;
			px[i]=j;break;
		}
	}
	delete pd;
	//load font-name(set font-no-conv-tbl)
	f.Read(ss,8);
	l=B_BENDIAN_TO_HOST_INT16(*((uint16*)(ss+6)));
	uchar	fc=*(ss+5);
	char	*fd=new char[l];
	f.Read(fd,l);
	char	*fp,*sp;
	fp=fd;
	for(int i=0;i<fc;i++){
		fx[i]=dfn;
		sp=fp+strlen(fp)+1;
		for(int j=0;j<fontc;j++){
			if(strcmp(ft[j].fam,fp))continue;
			if(strcmp(ft[j].sty,sp))continue;
			fx[i]=j;break;
		}
		fp=sp+strlen(sp)+1;
	}
	delete fd;
	//load data
	char	*dt;
	dt=new char[8];
	f.Read(dt,8);
	if(strncmp(dt,"data",4))return;
	objs=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+4)));
	delete dt;
	for(int i=0;i<objs;i++){
		uchar	type;
		f.Read(&type,1);
		if(type==RECT)obj[i]=new obj_rect();
		if(type==ELLIPSE)obj[i]=new obj_ellipse();
		if(type==TEXT)obj[i]=new obj_text();
		if(type==BITMAP)obj[i]=new obj_bitmap();
		if(type==LINE)obj[i]=new obj_line();
		if(type==POLY)obj[i]=new obj_polygon();
		if(type==CURVE)obj[i]=new obj_curve();
		if(type==SHAPE)obj[i]=new obj_shape();
		obj[i]->read(f);
	}
	//redraw
	BMessenger(w->v).SendMessage('edrd');		//w->PostMessage('edrd',w->v);
}

void gprod::save(entry_ref &dir,const char *name)
{
	uchar	cc,pc,fc;
	for(int i=0;i<udfc;i++)udf[i]=0;
	for(int i=0;i<objs;i++)obj[i]->chk_usedef();
	cc=0;for(int i=0;i<64;i++)cx[i]=(udf[i]&0x01)?cc++:255;
	pc=0;for(int i=0;i<16;i++)px[i]=(udf[i]&0x02)?pc++:255;
	fc=0;for(int i=0;i<fontc;i++)fx[i]=(udf[i]&0x80)?fc++:-1;
	BFile	f;
	BDirectory(&dir).CreateFile(name,&f,false);
	int	l;
	//save header
	char	*p;
	char	hd[16];
	memset(hd,0,16);
	strcpy(hd,"gprod_01");
	*((uint16*)(hd+8))=B_HOST_TO_BENDIAN_INT16(canvas.IntegerWidth()+1);
	*((uint16*)(hd+10))=B_HOST_TO_BENDIAN_INT16(canvas.IntegerHeight()+1);
	f.Write(hd,16);
	//save color-def
	l=4*cc;
	char	*cd=new char[8+l];
	memset(cd,0,8+l);
	strcpy(cd,"col");
	*((uint16*)(cd+6))=B_HOST_TO_BENDIAN_INT16(l);
	*((uchar*)(cd+5))=cc;
	p=cd+8;
	for(int i=0;i<64;i++)if(udf[i]&0x01){
		*((uint32*)p)=B_HOST_TO_BENDIAN_INT32(pal[i]);
		p+=4;
	}
	f.Write(cd,8+l);
	delete cd;
	//save pattern-def
	l=32*pc;
	char	*pd=new char[8+l];
	memset(pd,0,8+l);
	strcpy(pd,"pat");
	*((uint16*)(pd+6))=B_HOST_TO_BENDIAN_INT16(l);
	*((uchar*)(pd+5))=pc;
	p=pd+8;
	for(int i=0;i<16;i++)if(udf[i]&0x02){
		for(int j=0;j<16;j++){
			*((uint16*)p)=B_HOST_TO_BENDIAN_INT16(pat[i][j]);
			p+=2;
		}
	}
	f.Write(pd,8+l);
	delete pd;
	//save font-name
	char	*fd=new char[8+128*fc];
	memset(fd,0,8+128*fc);
	p=fd+8;
	for(int i=0;i<fontc;i++)if(udf[i]&0x80){
		p+=sprintf(p,"%s",ft[i].fam)+1;
		p+=sprintf(p,"%s",ft[i].sty)+1;
	}
	l=p-(fd+8);
	strcpy(fd,"font");
	*((uchar*)(fd+5))=fc;
	*((uint16*)(fd+6))=B_HOST_TO_BENDIAN_INT16(l);
	f.Write(fd,8+l);
	delete fd;
	//save data
	char	*dt;
	dt=new char[8];
	memset(dt,0,8);
	strcpy(dt,"data");
	*((uint16*)(dt+4))=B_HOST_TO_BENDIAN_INT16(objs);
	f.Write(dt,8);
	delete dt;
	for(int i=0;i<objs;i++)obj[i]->write(f);
	//set mime
	BAppFileInfo	fi(&f);
	fi.SetType("image/x-vnd.Beer-gprod");
}
//------------------------------------------------
gprodwindow::gprodwindow(BRect frame):BWindow(frame,"gprod "VER,B_DOCUMENT_WINDOW,0)
{
	mb=NULL;
	ft=NULL;	fx=NULL;	udf=NULL;
	get_translator_for_output();
	setupfonts();

	BRect	viewframe,sbvframe,sbhframe,selectframe,toolframe;
	selectframe.Set(0,0,399,32);
	selectframe.OffsetTo(0,20);				//menu=20
	sv=new selectview(selectframe);
	AddChild(sv);

	toolframe.Set(0,0,20,299-20-32);
	toolframe.OffsetTo(0,20+32);			//menu=20
	tv=new toolview(toolframe);
	AddChild(tv);

	viewframe.Set(0,0,frame.Width()-B_V_SCROLL_BAR_WIDTH-20,frame.Height()-B_H_SCROLL_BAR_HEIGHT-20-32);
	viewframe.OffsetTo(toolframe.right+1,selectframe.bottom+1);
	v=new gprodview(viewframe);
	AddChild(v);
	setupmenus();
	sbvframe.Set(0,0,B_V_SCROLL_BAR_WIDTH,viewframe.Height());
	sbvframe.OffsetTo(viewframe.right+1,viewframe.top);
	sbv=new BScrollBar(sbvframe,"scrollv",(BView*)v,0,0,B_VERTICAL);
	AddChild(sbv);
	sbhframe.Set(0,0,viewframe.Width(),B_H_SCROLL_BAR_HEIGHT);
	sbhframe.OffsetTo(viewframe.left,viewframe.bottom+1);
	sbh=new BScrollBar(sbhframe,"scrollh",(BView*)v,0,0,B_HORIZONTAL);
	AddChild(sbh);
	FrameResized(frame.Width(),frame.Height());
	Show();
	SetPulseRate(100000);
}

bool gprodwindow::QuitRequested()
{
	xlator	*xl;
	for(int i=0;xl=(xlator*)xlt.ItemAt(i);i++)delete xl;
	if(ft)delete ft;
	if(fx)delete fx;
	if(udf)delete udf;
	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);	//be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void gprodwindow::Zoom(BPoint rec_position,float rec_width,float rec_height)
{
	int	w,h;
	w=vcanvas.IntegerWidth()+20+(int)B_V_SCROLL_BAR_WIDTH;		//+toolview+scrollbar
	h=vcanvas.IntegerHeight()+20+32+(int)B_H_SCROLL_BAR_HEIGHT;	//+menu+selectview+scrollbar
	if(w<400)w=399;
	if(h<300)h=299;
	SetSizeLimits(399,w,299,h);
	if((Bounds().IntegerWidth()==w)&&(Bounds().IntegerHeight()==h)){w=399;h=299;}
	ResizeTo(w,h);
}

void gprodwindow::FrameResized(float width,float height)
{
	float	rv,rh;
	rv=vcanvas.Height()-sbv->Bounds().Height();
	rh=vcanvas.Width()-sbh->Bounds().Width();
	sbv->SetRange(0,rv>0?rv:0);
	sbh->SetRange(0,rh>0?rh:0);
	sbv->SetProportion(sbv->Bounds().Height()/vcanvas.Height());
	sbh->SetProportion(sbh->Bounds().Width()/vcanvas.Width());
	sbv->SetSteps(5,sbv->Bounds().Height());
	sbh->SetSteps(5,sbh->Bounds().Width());

	tv->ResizeTo(tv->Bounds().Width(),height);
	sv->ResizeTo(width,sv->Bounds().Height());
}

void gprodwindow::DispatchMessage(BMessage *msg,BHandler *handler)
{
//	static int32	mask=0;
	while(1){
		if(handler!=v)break;
		if((msg->what!=B_MOUSE_DOWN)&&(msg->what!=B_MOUSE_UP)&&(msg->what!=B_MOUSE_MOVED))break;
		float	f1,f2;
		int32	l;
		int64	ll;
		BPoint	p;
		if(!msg->FindInt32("be:cursor_needed",&l))break;	//anti-noise
		if(!msg->FindInt32("_msg_what_",&l))break;			//drag-now
//msg->PrintToStream();
		inp.flags=0;
		if((!msg->FindFloat("be:tablet_x",&f1))&&(!msg->FindFloat("be:tablet_y",&f2))){inp.x=f1;inp.y=f2;inp.flags|=TABLET_XY;}
		if((!msg->FindFloat("be:tablet_tilt_x",&f1))&&(!msg->FindFloat("be:tablet_tilt_y",&f2))){inp.tilt_x=f1;inp.tilt_y=f2;inp.flags|=TABLET_TILT_XY;}
		if(!msg->FindFloat("be:tablet_pressure",&f1)){inp.pressure=f1;inp.flags|=TABLET_PRESSURE;}
		if(!msg->FindInt32("be:tablet_eraser",&l)){inp.eraser=l;inp.flags|=TABLET_ERASER;}
		if(!msg->FindInt32("modifiers",&l)){inp.modifiers=l;inp.flags|=MODIFIERS;}
		if(!msg->FindInt32("buttons",&l)){inp.buttons=l;inp.flags|=BUTTONS;}
		if(!msg->FindInt64("when",&ll)){inp.when=ll;inp.flags|=WHEN;}
		if(!msg->FindPoint("be:view_where",&p)){inp.where=p;inp.flags|=WHERE;}
//		if(!msg->FindPoint("where",&p)){inp.where=p;inp.flags|=WHERE;}
//		if(!msg->FindPoint("screen_where",&p)){inp.where=p;inp.flags|=WHERE;}//zeta only
		if(!msg->FindInt32("be:transit",&l)){inp.transit=l;inp.flags|=TRANSIT;}
//		if(inp.flags&TRANSIT){
//			if(l==0){mask=inp.buttons;inp.buttons=0;}
//			if(l==1){if(inp.buttons&mask)inp.buttons=0;else mask=0;}
//			if(l!=1){inp.buttons=0;inp.flags|=BUTTONS;}
//if((l==0)||(l==2))printf("transit=%d (%d,%d)\n",l,(int)inp.where.x,(int)inp.where.y);
//		}
//printf("dispat:flag=%02x\n",inp.flags);
		break;
	}
	BWindow::DispatchMessage(msg,handler);
}

void gprodwindow::setupfonts()
{
	font	ftd;
	be_plain_font->GetFamilyAndStyle(&ftd.fam,&ftd.sty);

	font_family	fontf;
	font_style	fonts;
	fontc=0;
	int fc=count_font_families();
	for(int i=0;i<fc;i++){
		get_font_family(i,&fontf);
		fontc+=count_font_styles(fontf);
	}
	ft=new font[fontc];
	fx=new int[fontc];
	udfc=max(64,fontc);
	udf=new uchar[udfc];
	mf=new BMenu(_T("Font"));	//font family-style
	int	no=0;
	for(int i=0;i<fc;i++){
		get_font_family(i,&fontf);
		int sc=count_font_styles(fontf);
		for(int j=0;j<sc;j++){
			get_font_style(fontf,j,&fonts);
			strcpy(ft[no].fam,fontf);
			strcpy(ft[no].sty,fonts);
			char	s[130];
			sprintf(s,"%s(%s)",fontf,fonts);
			BMessage	*mes=new BMessage('Vchg');mes->AddInt16("fon",no);
			BMenuItem	*mi=new BMenuItem(s,mes);
//			mi->SetTarget((BHandler*)v);
			if((!strcmp(ftd.fam,fontf))&&(!strcmp(ftd.sty,fonts))){dfn=no;mi->SetMarked(true);}
			mf->AddItem(mi);
			no++;
		}
	}
	mf->SetRadioMode(true);
}

void gprodwindow::setupmenus()
{
//	BMenuBar	*mb;
	BMenu		*m,*mm;
	BMenuItem	*mi;
	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mm=new BMenu(_T("New"));
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,399,299));
	  mi=new BMenuItem("400x300",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,639,479));
	  mi=new BMenuItem("640x480",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,799,599));
	  mi=new BMenuItem("800x600",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	 m->AddItem(mm);
	 mi=new BMenuItem(_T("Open"),new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
/*
	 mi=new BMenuItem("close",new BMessage('ficl'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("save",new BMessage('fiow'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
*/
	 mi=new BMenuItem(_T("Save as"),new BMessage('finw'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	m=new BMenu(_T("Edit"));
/*
	 mi=new BMenuItem("undo",new BMessage('edun'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
*/
	 mi=new BMenuItem(_T("Delete"),new BMessage('edde'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	mb->AddItem(m);

	mf->SetTargetForItems((BHandler*)v);
	mb->AddItem(mf);

	static int	sc[]={
		50,75,100,125,150,200,250,300,400,	0
	};
	m=new BMenu(_T("Scale"));
	 for(int i=0;sc[i];i++){
	 	mes=new BMessage('Vchg');mes->AddFloat("scale",(float)sc[i]/100);
	 	char	s[8];
	 	sprintf(s,"%3d%%",sc[i]);
	 	mi=new BMenuItem(s,mes);
	 	mi->SetTarget((BHandler*)v);
	 	if(sc[i]==100)mi->SetMarked(true);
	 	m->AddItem(mi);
	 }
	 m->SetRadioMode(true);
	mb->AddItem(m);

	AddChild(mb);
}

void gprodwindow::markmenu(const char *menu,const char *item)
{
	if(mb==NULL)return;
	int	c=mb->CountItems();
	for(int i=0;i<c;i++){
		BMenu	*m=mb->SubmenuAt(i);
		if(strcmp(m->Name(),menu))continue;
		int	ic=m->CountItems();
		for(int j=0;j<ic;j++){
			BMenuItem	*mi=m->ItemAt(j);
			if(*item==0)mi->SetMarked(false);
			if(strcmp(mi->Label(),item))continue;
//printf("found: [%s]-[%s]\n",m->Name(),mi->Label());
			mi->SetMarked(true);
		}
	}
}

void gprodwindow::get_translator_for_output()
{
	BBitmap 			*tbm=new BBitmap(BRect(0,0,7,7),B_RGB_32_BIT);
	BBitmapStream		*instrm=new BBitmapStream(tbm);
	translator_info		*inf;
	const translation_format	*frm;
	int32				infs,frms;
	tr->GetTranslators(instrm,NULL,&inf,&infs);
	for(int i=0;i<infs;i++){
		tr->GetOutputFormats(inf[i].translator,&frm,&frms);
		for(int j=0;j<frms;j++){
//printf("%c%c%c%c %4.2f %4.2f\n",frm[j].type>>24,frm[j].type>>16,frm[j].type>>8,frm[j].type,frm[j].quality,frm[j].capability);
			if(frm[j].type=='bits')continue;		//standard bitmap
			if(frm[j].type=='mhi!')continue;		//progressive bitmap
			xlator	*xl=new xlator;
			xl->type=frm[j].type;
			xl->id=inf[i].translator;
			strcpy(xl->name,frm[j].name);
			strcpy(xl->mime,frm[j].MIME);
			if(frm[j].type=='TGA ')xlt.AddItem((void*)xl,0);else xlt.AddItem((void*)xl);
			trc++;
		}
	}
	delete inf;
}
//------------------------------------------------
toolview::toolview(BRect frame):BView(frame,"tools",B_FOLLOW_NONE,B_WILL_DRAW)
{
	bm=NULL;
	mode=0;
}

toolview::~toolview()
{
	if(bm)delete bm;
}

void toolview::AttachedToWindow()
{
	SetLowColor(200,200,0);
	SetViewColor((uchar)(TOOLVIEWCOLOR>>16),(uchar)(TOOLVIEWCOLOR>>8),(uchar)TOOLVIEWCOLOR);
	SetFont(be_plain_font);
	SetFontSize(10);
	if(!bm)bm=new BBitmap(Bounds(),B_RGB_32_BIT);
	redraw();
}

void toolview::Draw(BRect rect)
{
	DrawBitmap(bm,BPoint(0,0));
}

void toolview::MouseDown(BPoint pt)
{
	uint32	m=0;
	if((pt.x<2)||(pt.x>18))return;
	if((pt.y>=2)&&(pt.y<=18))m='drpi';
	if((pt.y>=20)&&(pt.y<=36))m='drre';
	if((pt.y>=38)&&(pt.y<=54))m='drel';
	if((pt.y>=56)&&(pt.y<=72))m='drli';
	if((pt.y>=74)&&(pt.y<=90))m='drpo';
	if((pt.y>=92)&&(pt.y<=108))m='drcu';
	if((pt.y>=110)&&(pt.y<=126))m='drsh';
	if((pt.y>=128)&&(pt.y<=144))m='drex';
	if(m){
//		BMessage *mes=new BMessage(m);
//		Window()->PostMessage(mes,((gprodwindow*)Window())->v);
		BMessenger(((gprodwindow*)Window())->v).SendMessage(m);
	}
}

void toolview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'Vchg':{
			int8	d;
			if(!msg->FindInt8("mode",&d))mode=d;
			redraw();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void toolview::redraw()
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*pp=p;
	int		l=bm->BitsLength()/4;
	while(l--)*(pp++)=B_HOST_TO_LENDIAN_INT32(TOOLVIEWCOLOR);
	for(int i=0;i<8;i++){
		bool	f;
		uint32	fc,bc;
		if(i==0)f=(mode==0);
		if(i==1)f=(mode==1);
		if(i==2)f=(mode==2);
		if(i==3)f=(mode==5);
		if(i==4)f=(mode==6);
		if(i==5)f=(mode==7);
		if(i==6)f=(mode==8);
		if(i==7)f=(mode==-1);
		if(f){fc=0xffffffff;bc=0x00000000;}else{fc=0x00000000;bc=0xffffffff;}
		int	x=2;
		int	y=i*18+2;
		for(int yy=0;yy<16;yy++)for(int xx=0;xx<16;xx++){
			*(p+(y+yy)*dy+(x+xx))=(iconpat[i][yy]&(0x8000>>xx))?fc:bc;
		}
	}
	Draw(Bounds());
}
//------------------------------------------------
selectview::selectview(BRect frame):BView(frame,"selector",B_FOLLOW_NONE,B_WILL_DRAW)
{
	bm=NULL;
	now.fc=7;	now.bc=63;	now.fg=1;	now.bg=0;
	now.fon=dfn;	now.fos=18;		now.pen=1;
	sf=0x00;
}

selectview::~selectview()
{
	if(bm)delete bm;
}

void selectview::AttachedToWindow()
{
	SetLowColor(200,200,0);
	SetViewColor((uchar)(SELECTVIEWCOLOR>>16),(uchar)(SELECTVIEWCOLOR>>8),(uchar)SELECTVIEWCOLOR);
	SetFont(be_plain_font);
	SetFontSize(10);
	if(!bm)bm=new BBitmap(Bounds(),B_RGB_32_BIT);
	redraw();
}

void selectview::Draw(BRect rect)
{
	SetHighColor(0,0,0);
	DrawBitmap(bm,BPoint(0,0));
	char	s[32];
	if(now.fos>=0)sprintf(s,"font : %2d",now.fos);else strcpy(s,"font : --");
	DrawString(s,BPoint(342,12));
	if(now.pen>=0)sprintf(s,"pen  : %2d",now.pen);else strcpy(s,"pen  : --");
	DrawString(s,BPoint(342,28));
}

void selectview::MouseDown(BPoint pt)
{
	if(pt.x<128){			//color
		int d=(int)(pt.y/8)*16+(int)(pt.x/8);
		if(d<64){
			BMessage *mes=new BMessage('Vchg');
			mes->AddInt16((sf&0x01)?"bc":"fc",d);
			BMessenger(((gprodwindow*)Window())->v).SendMessage(mes);//Window()->PostMessage(mes,((gprodwindow*)Window())->v);
		}
	}else if(pt.x<160){		//now color
		if(pt.y<16)sf&=0xfe;
		else sf|=0x01;
		redraw();
	}else if(pt.x<192){		//now pattern
		if(pt.y<16)sf&=0xfd;
		else sf|=0x02;
		redraw();
	}else if(pt.x<320){		//pattern
		int d=(int)(pt.y/16)*8+(int)((pt.x-192)/16);
		if(d<16){
			BMessage *mes=new BMessage('Vchg');
			mes->AddInt16((sf&0x02)?"bg":"fg",d);
			BMessenger(((gprodwindow*)Window())->v).SendMessage(mes);//Window()->PostMessage(mes,((gprodwindow*)Window())->v);
		}
	}else{					//fontsize,pensize
		BMessage *mes=new BMessage('Vchg');
		if(pt.y<16){	//font
			int	fos=now.fos+((pt.x<365)?-2:2);
			if(fos<8)fos=8;if(fos>80)fos=80;
			mes->AddInt16("fos",fos);
		}else{			//pen
			int	pen=now.pen+((pt.x<365)?-1:1);
			if(pen<0)pen=0;if(pen>30)pen=30;
			mes->AddInt16("pen",pen);
		}
		BMessenger(((gprodwindow*)Window())->v).SendMessage(mes);	//Window()->PostMessage(mes,((gprodwindow*)Window())->v);
	}
}

void selectview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'Vchg':{
			int16	d;
			if(!msg->FindInt16("fc",&d))now.fc=d;
			if(!msg->FindInt16("bc",&d))now.bc=d;
			if(!msg->FindInt16("fg",&d))now.fg=d;
			if(!msg->FindInt16("bg",&d))now.bg=d;
			if(!msg->FindInt16("fos",&d))now.fos=d;
			if(!msg->FindInt16("pen",&d))now.pen=d;
			redraw();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void selectview::redraw()
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*pp=p;
	int		l=bm->BitsLength()/4;
	while(l--)*(pp++)=B_HOST_TO_LENDIAN_INT32(SELECTVIEWCOLOR);
	int	x,y;
	for(int i=0;i<64;i++){		//color
		uint32	c=pal[i];
		x=(i&0x0f)*8;
		y=(i&0xf0)/2;
		if(c&0xff000000)for(int yy=y+(~c>>29);yy<y+8;yy++){
			for(int xx=x;xx<x+8;xx++)*(p+yy*dy+xx)=B_HOST_TO_LENDIAN_INT32(c);
		}
	}
	for(int i=0;i<16;i++){		//pattern
		x=(i&0x07)*16+192;
		y=(i&0xf8)*2;
		for(int yy=0;yy<16;yy++)for(int xx=0;xx<16;xx++){
			*(p+(y+yy)*dy+(x+xx))=(pat[i][yy]&(1<<xx))?0xffffffff:0x00000000;
		}
	}
	for(int i=0;i<2;i++){		//now-color
		int	no=(i==0)?now.fc:now.bc;
		if(no>=0){
			uint32	c=pal[no];
			x=144;
			y=i*16;
			if(c&0xff000000)for(int yy=y+(~c>>28);yy<y+16;yy++){
				for(int xx=x;xx<x+16;xx++)*(p+yy*dy+xx)=B_HOST_TO_LENDIAN_INT32(c);
			}
		}
	}
	for(int i=0;i<2;i++){		//now-pattern
		int	no=(i==0)?now.fg:now.bg;
		if(no>=0){
			x=160;
			y=i*16;
			for(int yy=0;yy<16;yy++)for(int xx=0;xx<16;xx++){
				*(p+(y+yy)*dy+(x+xx))=(pat[no][yy]&(1<<xx))?0xffffffff:0x00000000;
			}
		}
	}

	uint32	tc=B_HOST_TO_LENDIAN_INT32(0xcc0000);
	x=132;
	y=(sf&1)?20:4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[3][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=180;
	y=(sf&2)?20:4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[2][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=330;
	y=4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[1][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=330;
	y=20;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[1][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=388;
	y=4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[0][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=388;
	y=20;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[0][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}

	Draw(Bounds());
}

void selectview::set(s_attr s)
{
	redraw();
}
//------------------------------------------------
gprodview::gprodview(BRect frame):BView(frame,"canvas",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	canvas=BRect(0,0,0,0);
	bm=NULL;		//no canvas
	bmdd=NULL;		//no drag&drop
	kin=0;
	mdf=false;	mcf=true;

	objs=0;
}

gprodview::~gprodview()
{
	if(bm)delete bm;
	if(bmdd)delete bmdd;
}

void gprodview::AttachedToWindow()
{
	init();
	SetHighColor(255,255,255);
	SetViewColor(50,50,50);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);
	MakeFocus();
}

void gprodview::Draw(BRect rect)
{
	if(bm){
		ConstrainClippingRegion(&BRegion(rect&vcanvas));
		BRect	br=bm->Bounds();
		BRect	vr(0,0,br.right*scale,br.bottom*scale);
		DrawBitmap(bm,br,vr);
		for(int i=0;i<objs;i++)obj[i]->drawframe(this,scale);
		if(sel_now.f)drawframe(sel_now.rect);
		ConstrainClippingRegion(&BRegion(vcanvas));		//need !!
	}else{
		SetFontSize(30);
		DrawString("Gprod",BPoint(45,50));
		SetFontSize(20);
		DrawString(VER,BPoint(75,80));
	}
}

void gprodview::KeyDown(const char *bytes,int32 numBytes)
{
	if(kin)return;
	if(numBytes==1){
		if((*bytes=='8')||(*bytes==B_UP_ARROW))kin|=0x01;		//up
		if((*bytes=='2')||(*bytes==B_DOWN_ARROW))kin|=0x02;		//down
		if((*bytes=='4')||(*bytes==B_LEFT_ARROW))kin|=0x04;		//left
		if((*bytes=='6')||(*bytes==B_RIGHT_ARROW))kin|=0x08;	//right
		if(*bytes==B_DELETE)kin|=0x10;							//delete
	}
	if((objs)&&(now_mode==0)){
		int		c;
		if(selm==1){
			object	*t;
			if(kin==1){		//to top
				c=objs-1;
				for(int i=objs-1;i>=0;i--){
					if(obj[i]->sel_pt==0)continue;
					t=obj[i];
					for(int j=i+1;j<=c;j++)obj[j-1]=obj[j];
					obj[c--]=t;
				}
			}
			if(kin==2){		//to bottom
				c=0;
				for(int i=0;i<objs;i++){
					if(obj[i]->sel_pt==0)continue;
					t=obj[i];
					for(int j=i-1;j>=c;j--)obj[j+1]=obj[j];
					obj[c++]=t;
				}
			}
		}else{
			if(kin==1){	//select first
				obj[0]->sel_pt=-1;
				for(int i=1;i<objs;i++)obj[i]->sel_pt=0;
				selm=1;
			}
			if(kin==2){	//select last
				for(int i=0;i<objs-1;i++)obj[i]->sel_pt=0;
				obj[objs-1]->sel_pt=-1;
				selm=1;
			}
		}
		if(kin==4){		//select back
			c=objs-1;
			for(int i=objs-1;i>=0;i--){
				if(obj[i]->sel_pt==0)continue;
				obj[i]->sel_pt=0;
				c=(i+objs-1)%objs;
			}
			obj[c]->sel_pt=-1;
			selm=1;
		}
		if(kin==8){		//select next
			c=0;
			for(int i=0;i<objs;i++){
				if(obj[i]->sel_pt==0)continue;
				obj[i]->sel_pt=0;
				c=(i+1)%objs;
			}
			obj[c]->sel_pt=-1;
			selm=1;
		}
		if(kin==0x10){	//delete
			BMessage *mes=new BMessage('edde');
			BMessenger(this).SendMessage(mes);		//Window()->PostMessage(mes,this);
		}
		redraw(5);
//		chkattr();
	}
}

void gprodview::KeyUp(const char *bytes,int32 numBytes)
{
/*
	if(numBytes==1){
		if((*bytes=='8')||(*bytes==B_UP_ARROW))kin&=0xfe;	//up
		if((*bytes=='2')||(*bytes==B_DOWN_ARROW))kin&=0xfd;	//down
		if((*bytes=='4')||(*bytes==B_LEFT_ARROW))kin&=0xfb;	//left
		if((*bytes=='6')||(*bytes==B_RIGHT_ARROW))kin&=0xf7;//right
	}
*/
	if(now_mode==0)chkattr();
	kin=0;
}

void gprodview::MouseDown(BPoint pt)
{
	chkinput();
}
void gprodview::MouseUp(BPoint pt)
{
	chkinput();
}
void gprodview::MouseMoved(BPoint pt,uint32 code,const BMessage *msg)
{
	chkinput();
}

void gprodview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	static BPoint	dp;
	BPoint	dr_pt,dr_off;
	if((!msg->FindPoint("_drop_point_",&dr_pt))&&(!msg->FindPoint("_drop_offset_",&dr_off))){
		ConvertFromScreen(&dr_pt);
		dr_pt=BPoint(dr_pt.x/scale,dr_pt.y/scale);
		float	sc;
		if(!msg->FindFloat("scale",&sc))dr_off=BPoint(dr_off.x/sc,dr_off.y/sc);
		dp=dr_pt-dr_off;
	}

	switch(msg->what){
		case B_COPY_TARGET:{	//drop(to external)
			ddcopy(msg);
		}break;
		case B_SIMPLE_DATA:{	//'DATA'(drop from external)
			const char	*source;
			if((!msg->FindString("source",&source))&&(!strcmp(source,"gprod"))){	//from gprod
				break;
			}
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){		//file
				BMessenger(be_app).SendMessage(msg);	//be_app->PostMessage(msg,be_app);
				break;
			}
			const char	*name;
			if(!msg->FindString("be:clip_name",&name)){	//image
				BMessage	mes(B_COPY_TARGET);
				int32	idx=0;
				const char	*mime;
				while(!msg->FindString("be:types",idx++,&mime)){
					if(!strncmp(mime,"image",5)){
						mes.AddString("be:types",mime);
    					msg->SendReply(&mes,this);
						break;
					}
				}
				break;
			}
		}	//not break;	(for text-data)
		case 'MIME':{
			Char 	*mime;
			type_code	type;
			if(msg->GetInfo(B_MIME_TYPE,0,&mime,&type)==B_OK){
				long	bc;
				const void	*d;
				if(!strncmp(mime,"image",5)){			//image data
					if(!msg->FindData(mime,B_MIME_TYPE,&d,&bc)){
						BMemoryIO		mem(d,bc);
						BBitmapStream	strm;
						if(strcmp(mime,"image/x-be-bitmap")){
							tr->Translate(&mem,NULL,NULL,&strm,B_TRANSLATOR_BITMAP,0,mime);
						}else{
							uchar	tbuf[1024];
							int32	tlen;
							while((tlen=mem.Read(tbuf,1024))>0)strm.Write(tbuf,tlen);
						}
						BBitmap *bmp;
						strm.DetachBitmap(&bmp);
						BRect	r=bmp->Bounds();
						r.OffsetTo(0,0);
						if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
						obj[objs++]=new obj_bitmap(dp,edat);
						obj[objs-1]->setbitmap(r,(uint32*)(bmp->Bits()));
						delete bmp;
						redraw(5);
					}
				}
				if(!strncmp(mime,"text",4)){			//text data
					if(!msg->FindData(mime,B_MIME_DATA,&d,&bc)){	//mime="text/plain"
						char	*str=new char[bc+1];
						strncpy(str,(const char*)d,bc);str[bc]=0;
						if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
						obj[objs++]=new obj_text(dr_pt-dr_off,edat);
						obj[objs-1]->settext(str,1);
						delete str;
						redraw(5);
					}
				}
			}
		}break;
		case 'fine':{
			for(int i=0;i<objs;i++)delete obj[i];
			objs=0;
			delete bm;bm=NULL;
			scale=1;
			vcanvas=BRect(0,0,0,0);
			Window()->Zoom();
			msg->FindRect("bounds",&canvas);
			bm=new BBitmap(canvas,B_RGB_32_BIT,true);
			memset(bm->Bits(),0,bm->BitsLength());
			vcanvas=BRect(canvas.left*scale,canvas.top*scale,canvas.right*scale,canvas.bottom*scale);
			ConstrainClippingRegion(&BRegion(vcanvas));
			canvasok=true;
			init();
			Window()->Zoom();
			Invalidate();
		}break;
		case 'fiop':{
			if(fp==NULL){
				fp=new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		case 'finw':{
			if(fp==NULL){
				fp=new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		case 'drpi':{
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now_mode=0;
			send2toolv();
			chkattr();
		}break;
		case 'drre':{
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now_mode=1;
			send2toolv();
			send2selv();
		}break;
		case 'drel':{
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now_mode=2;
			send2toolv();
			send2selv();
		}break;
		case 'drli':{
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now_mode=5;
			send2toolv();
			send2selv();
		}break;
		case 'drpo':{
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now_mode=6;
			send2toolv();
			send2selv();
		}break;
		case 'drcu':{
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now_mode=7;
			send2toolv();
			send2selv();
		}break;
		case 'drsh':{
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now_mode=8;
			send2toolv();
			send2selv();
		}break;
		case 'drex':{
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if((objs>0)&&(obj[objs-1]->cpts>=0))delete obj[--objs];//
			for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
			now_mode=-1;
			send2toolv();
			send2selv();
		}break;
		case 'edde':if(now_mode==0){
			int	c=0;
			for(int i=0;i<objs;i++){
				if(obj[i]->sel_pt){
					delete obj[i];
				}else{
					obj[c++]=obj[i];
				}
			}
			objs=c;
			selm=0;
			redraw(5);
		}break;
		case 'edrd':{
			redraw(5);
		}break;
		case 'Vchg':{
			int16	d;
			float	f;
			uint32	chgf=0;
			if(!msg->FindInt16("fc",&d)){edat.fc=d;chgf|=0x01;}
			if(!msg->FindInt16("bc",&d)){edat.bc=d;chgf|=0x02;}
			if(!msg->FindInt16("fg",&d)){edat.fg=d;chgf|=0x04;}
			if(!msg->FindInt16("bg",&d)){edat.bg=d;chgf|=0x08;}
			if(!msg->FindInt16("fon",&d)){edat.fon=d;chgf|=0x10;}
			if(!msg->FindInt16("fos",&d)){edat.fos=d;chgf|=0x20;}
			if(!msg->FindInt16("pen",&d)){edat.pen=d;chgf|=0x40;}
			if(!msg->FindFloat("scale",&f)){scale=f;chgf|=0x80;}
			if(chgf)send2selv();
			if((now_mode==0)&&(selm)&&(chgf&0x7f)){
				for(int i=0;i<objs;i++){
					if(obj[i]->sel_pt)obj[i]->set_attr(edat,chgf);
				}
				chkattr();
				redraw(5);								//redraw-all
			}
			if(chgf&0x80)chgscale();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void gprodview::chkinput()
{
	static input	inp_n,inp_b;	//now,before input
	static BPoint	pt_n,pt_b;		//now,before point(view)
	static uchar	bt_n,bt_b;		//now,before button


	BPoint	p;uint32	b;	GetMouse(&p,&b);		//dummy
	SetMouseEventMask(B_POINTER_EVENTS);

	inp_n=((gprodwindow*)Window())->inp;
	pt_n=inp_n.where;
	pt_n=BPoint((int)(pt_n.x/scale),(int)(pt_n.y/scale));
	bt_n=(uchar)inp_n.buttons;
	if(bt_n==B_PRIMARY_MOUSE_BUTTON){
		if(inp_n.modifiers&B_SHIFT_KEY)bt_n=B_SECONDARY_MOUSE_BUTTON;
		if(inp_n.modifiers&B_CONTROL_KEY)bt_n=B_TERTIARY_MOUSE_BUTTON;
	}

	if(bm){
		if(pt_n!=pt_b){
			ptr_move(pt_n,bt_b,inp_n);
		}
		if(bt_n!=bt_b){
			uchar	bt;
			if(bt=bt_b&~bt_n)btn_up(pt_n,bt,inp_n);
			if(bt=~bt_b&bt_n)btn_down(pt_n,bt,inp_n);
		}
	}
	pt_b=pt_n;
	bt_b=bt_n;
	inp_b=inp_n;
}

void gprodview::ptr_move(BPoint pt,uchar bt,input inp)
{
	if(pt==mmp)return;else mmp=pt;
	if((!mdf)&&(!(((now_mode>=5)&&(now_mode<=8))&&(selm<0))))return;
	if(!canvas.Contains(pt))return;
	if(now_mode>0){
		if(selm<0){
			redraw(2);
			obj[objs-1]->create(mdf?PRESSMOVE:RELEASEMOVE,pt);
			redraw(2);
		}
	}else{
		if(selm<0){
			redraw(2);
			sel_now.rect=BRect(mbp,pt);
			redraw(2);
		}
		if(now_mode==0){
			if((selm==2)||(selm==3)){
				redraw(2);
				if((mcf)&&(bt==B_TERTIARY_MOUSE_BUTTON)){
					mcf=false;
					int	c=objs;
					for(int i=0;i<c;i++){
						if(obj[i]->sel_pt<0){		//copy
							obj[objs++]=obj[i]->copy();
							obj[i]->sel_pt=0;
						}else if(obj[i]->sel_pt>0){	//add point(for line,poligon)
							obj[i]->inspoint(pt-mbp);
						}
					}
				}
				for(int i=0;i<objs;i++){			//move
					if(obj[i]->sel_pt==0)continue;
					obj[i]->move(pt-mbp);
				}
				mbp=pt;
				redraw(2);
			}
		}
	}
}

void gprodview::btn_up(BPoint pt,uchar bt,input inp)
{
	if(!mdf)return;
	mdf=false;	mcf=true;

	if(now_mode>0){
		if(selm<0){
			if(obj[objs-1]->create(RELEASE,pt)<0){
				selm=0;
				redraw(5);								//redraw-all
			}else{
				redraw(4);
			}
		}
	}else{
		if(selm<0){
			if(pt.x<canvas.left)pt.x=canvas.left;
			if(pt.x>canvas.right)pt.x=canvas.right;
			if(pt.y<canvas.top)pt.y=canvas.top;
			if(pt.y>canvas.bottom)pt.y=canvas.bottom;
//			sel_now.rect=BRect(mbp,pt);
			if(mbp.x<pt.x){sel_now.rect.left=mbp.x;sel_now.rect.right=pt.x;}else{sel_now.rect.left=pt.x;sel_now.rect.right=mbp.x;}
			if(mbp.y<pt.y){sel_now.rect.top=mbp.y;sel_now.rect.bottom=pt.y;}else{sel_now.rect.top=pt.y;sel_now.rect.bottom=mbp.y;}
		}
		if(now_mode==0){
			if(selm==4){
				int	c=0;
				for(int i=0;i<objs;i++){
					if((obj[i]->sel_pt>0)&&(obj[i]->delpoint())){
						delete obj[i];
					}else{
						obj[c++]=obj[i];
					}
				}
				objs=c;
			}
			sel_now.f=0;
			if(selm<2){
				for(int i=0;i<objs;i++){
					if(obj[i]->sel_pt)continue;
					int	scp=obj[i]->select_chk(sel_now.rect);
					if(scp)selm=1;		//selected_mode
				}
				redraw(4);									//
			}else{	//2.move,3.edit,4.delete
				selm=1;
				redraw(5);									//redraw-all
			}
			for(int i=0;i<objs;i++)if(obj[i]->sel_pt>0)obj[i]->sel_pt=-1;
			chkattr();
		}else{
			selm=1;
		}
	}	
}

void gprodview::btn_down(BPoint pt,uchar bt,input inp)
{
	SetMouseEventMask(B_POINTER_EVENTS);
	if(!canvas.Contains(pt))return;
	mdf=true;
	mbp=pt;

	if(now_mode>0){
		redraw(2);						//erase-frame
		if(selm==0){
			if(now_mode==1)obj[objs++]=new obj_rect(pt,edat);
			if(now_mode==2)obj[objs++]=new obj_ellipse(pt,edat);
			if(now_mode==5)obj[objs++]=new obj_line(pt,edat);
			if(now_mode==6)obj[objs++]=new obj_polygon(pt,edat);
			if(now_mode==7)obj[objs++]=new obj_curve(pt,edat);
			if(now_mode==8)obj[objs++]=new obj_shape(pt,edat);
			selm=-1;		//now create
		}
		int	stt=obj[objs-1]->create(bt==B_SECONDARY_MOUSE_BUTTON?CANSEL:PRESS,pt);
		if(stt<0)selm=0;
		if(stt==-2)delete obj[--objs];	//cansel
		if(selm)redraw(2);else redraw(5);
	}else if(now_mode==0){
		int	scf=0;
		redraw(2);					//erase-frame
		for(int i=0;i<objs;i++){
			if(obj[i]->sel_pt==0)continue;
			int	scp=obj[i]->select_chk(pt);
			if(scp<0)scf|=1;
			if(scp>0)scf|=2;
		}
		if(scf){
			if(scf==1){								//move
				selm=2;
			}else{
				for(int i=0;i<objs;i++)if(obj[i]->sel_pt<0)obj[i]->sel_pt=0;
				if(bt==B_SECONDARY_MOUSE_BUTTON){	//delete-point
					selm=4;
				}else{								//edit
					selm=3;
				}
			}
			redraw(2);				//draw-frame
		}else{				//now_out_of_selected_object
			if(bt==B_PRIMARY_MOUSE_BUTTON){
				for(int i=0;i<objs;i++)obj[i]->sel_pt=0;
				selm=-1;
			}
			sel_now.f=1;
			sel_now.rect=BRect(pt,pt);
		}
	}else{	//to external
		if((selm)&&(sel_now.rect.Contains(pt))){	//drag
			redraw(2);					//erase-frame
			selm=0;	mdf=false;	sel_now.f=0;
			if(bmdd){delete bmdd;bmdd=NULL;}
			bmdd=new BBitmap(sel_now.rect,B_RGB_32_BIT);
			int		dy=bm->BytesPerRow()/4;
			int		w=sel_now.rect.IntegerWidth()+1;
			int		h=sel_now.rect.IntegerHeight()+1;
			uint32	*p=(uint32*)(bm->Bits())+(int)(sel_now.rect.top*dy+sel_now.rect.left);
			uint32	*q=(uint32*)(bmdd->Bits());
			for(int y=0;y<h;y++)for(int x=0;x<w;x++)*(q++)=*(p+dy*y+x);
			BMessage	*mes=ddmessage();
			BRect	vr=BRect(sel_now.rect.left*scale,sel_now.rect.top*scale,sel_now.rect.right*scale,sel_now.rect.bottom*scale);
			DragMessage(mes,vr);
		}else{
			selm=-1;
			sel_now.f=1;
			sel_now.rect=BRect(pt,pt);
		}
	}	
}

BMessage* gprodview::ddmessage()
{
	BMessage	*msg=new BMessage(B_SIMPLE_DATA);
	msg->AddString("be:types","image/x-be-bitmap");
	for(int i=0;i<trc;i++){
		msg->AddString("be:types",((xlator*)xlt.ItemAt(i))->mime);
		msg->AddString("be:filetypes",((xlator*)xlt.ItemAt(i))->mime);			//for output
		msg->AddString("be:type_descriptions",((xlator*)xlt.ItemAt(i))->name);	//for menu
	}
	msg->AddString("be:types",B_FILE_MIME_TYPE);
	msg->AddInt32("be:actions",B_COPY_TARGET);
	msg->AddString("be:clip_name","Gprod_img");
	msg->AddString("source","gprod");
	msg->AddFloat("scale",scale);
	return(msg);
}

void gprodview::ddcopy(BMessage *msg)
{
	if(bmdd==NULL)return;
	BBitmapStream	strm(bmdd);
	entry_ref	dir;
	const char	*name,*mime;
	translator_id	tid;
	uint32	fmt;
	if(msg->FindRef("directory",&dir)==B_OK){
		msg->FindString("name",&name);
		msg->FindString("be:filetypes",&mime);
		BFile	*wf=new BFile();
		BDirectory(&dir).CreateFile(name,wf,false);
		select_trans(mime,&tid,&fmt);
		tr->Translate(tid,&strm,NULL,wf,fmt);
		BAppFileInfo	wfi(wf);
		wfi.SetType(mime);
		delete wf;
	}else{
		msg->FindString("be:types",&mime);
		BMallocIO	*dat=new BMallocIO;
		BMessage	*res=new BMessage(B_MIME_DATA);
		if(strcmp(mime,"image/x-be-bitmap")){
			select_trans(mime,&tid,&fmt);
			tr->Translate(tid,&strm,NULL,dat,fmt);
		}else{
			uchar	tbuf[1024];
			int32	tlen;
			while((tlen=strm.Read(tbuf,1024))>0)dat->Write(tbuf,tlen);
		}
		res->AddData(mime,B_MIME_DATA,dat->Buffer(),dat->BufferLength());
		msg->SendReply(res);
		delete dat;
		delete res;
	}
	bmdd=NULL;
}

void gprodview::select_trans(const char *mime,translator_id *tid,uint32 *fmt)
{
	for(int i=0;i<trc;i++){
		if(strcmp(((xlator*)xlt.ItemAt(i))->mime,mime))continue;
		*tid=((xlator*)xlt.ItemAt(i))->id;
		*fmt=((xlator*)xlt.ItemAt(i))->type;
		return;
	}
	*tid=0;
	*fmt=0;
}

void gprodview::chgscale()
{
	if(bm==NULL)return;
	vcanvas=BRect(canvas.left*scale,canvas.top*scale,canvas.right*scale,canvas.bottom*scale);
	ConstrainClippingRegion(&BRegion(vcanvas));
	Window()->Zoom();
	Invalidate();
}

void gprodview::init()
{
	sel_now.f=0;
	selm=0;
	now_mode=0;
	edat.fc=7;	edat.bc=63;	edat.fg=1;	edat.bg=0;
	edat.pen=1;
	edat.fon=dfn;	edat.fos=18;
	scale=1;
	send2toolv();
	chkattr();
	((gprodwindow*)Window())->markmenu(_T("Scale"),"100%");
}

void gprodview::chkattr()
{
	uchar	f=FGCOL|BGCOL|FGPAT|BGPAT|FONT|FNTSZ|PENSZ;
	puat.fc=-1;	puat.bc=-1;	puat.fg=-1;	puat.bg=-1;
	puat.fon=-1;	puat.fos=-1;	puat.pen=-1;
	selc=0;
	for(int i=0;i<objs;i++){
		if(obj[i]->sel_pt==0)continue;
		selc++;
		uchar	ff=obj[i]->attrflag;
		if(ff&FGCOL){
			if(f&FGCOL){puat.fc=obj[i]->da.fc;f^=FGCOL;}
			else if(puat.fc!=obj[i]->da.fc)puat.fc=-1;
		}
		if(ff&BGCOL){
			if(f&BGCOL){puat.bc=obj[i]->da.bc;f^=BGCOL;}
			else if(puat.bc!=obj[i]->da.bc)puat.bc=-1;
		}
		if(ff&FGPAT){
			if(f&FGPAT){puat.fg=obj[i]->da.fg;f^=FGPAT;}
			else if(puat.fg!=obj[i]->da.fg)puat.fg=-1;
		}
		if(ff&BGPAT){
			if(f&BGPAT){puat.bg=obj[i]->da.bg;f^=BGPAT;}
			else if(puat.bg!=obj[i]->da.bg)puat.bg=-1;
		}
		if(ff&FONT){
			if(f&FONT){puat.fon=obj[i]->da.fon;f^=FONT;}
			else if(puat.fon!=obj[i]->da.fon)puat.fon=-1;
		}
		if(ff&FNTSZ){
			if(f&FNTSZ){puat.fos=obj[i]->da.fos;f^=FNTSZ;}
			else if(puat.fos!=obj[i]->da.fos)puat.fos=-1;
		}
		if(ff&PENSZ){
			if(f&PENSZ){puat.pen=obj[i]->da.pen;f^=PENSZ;}
			else if(puat.pen!=obj[i]->da.pen)puat.pen=-1;
		}
	}
	send2selv();
}

void gprodview::send2toolv()
{
	BMessage *mes=new BMessage('Vchg');
	mes->AddInt8("mode",now_mode);
	BMessenger(((gprodwindow*)Window())->tv).SendMessage(mes);//Window()->PostMessage(mes,((gprodwindow*)Window())->tv);
}

void gprodview::send2selv()
{
	s_attr	*att=((now_mode)||(selc==0))?&edat:&puat;
	BMessage *mes=new BMessage('Vchg');
	mes->AddInt16("fc",att->fc);
	mes->AddInt16("bc",att->bc);
	mes->AddInt16("fg",att->fg);
	mes->AddInt16("bg",att->bg);
	mes->AddInt16("fon",att->fon);
	mes->AddInt16("fos",att->fos);
	mes->AddInt16("pen",att->pen);
	BMessenger(((gprodwindow*)Window())->sv).SendMessage(mes);//Window()->PostMessage(mes,((gprodwindow*)Window())->sv);
	char	s[128];	*s=0;
	if(att->fon>=0)sprintf(s,"%s(%s)",ft[att->fon].fam,ft[att->fon].sty);
	((gprodwindow*)Window())->markmenu(_T("Font"),s);
}

void gprodview::redraw(char f)
{
	if(bm==NULL)return;
	if(f&1){
		memset(bm->Bits(),0,bm->BitsLength());					//clear
		for(int i=0;i<objs;i++)obj[i]->draw(bm);				//object
	}
	if(f&2){
		for(int i=0;i<objs;i++)obj[i]->drawframe(this,scale);	//frame
		if(sel_now.f)drawframe(sel_now.rect);
	}
	if(f&4)Draw(Bounds());										//update screen
}

void gprodview::drawframe(BRect r)
{
	r=BRect(r.left*scale,r.top*scale,r.right*scale,r.bottom*scale);
	SetDrawingMode(B_OP_INVERT);
	StrokeRect(r,B_MIXED_COLORS);
	SetDrawingMode(B_OP_COPY);
}
//------------------------------------------------
object::object()
{
	wr=NULL;
	pts=0;
	pt=NULL;
	cpts=0;
	sel_pt=0;
}
object::object(const BPoint &p,const s_attr &m,int points)
{
	wr=NULL;
	if(points){
		pts=points;
		pt=new BPoint[pts];
	}else{	//for variable-points
		pts=1;
		pt=new BPoint[256];
	}
	pt[0]=p;
	cpts=0;
	sel_pt=0;
}

object::~object()
{
#if	__INTEL__
	if(pt)delete pt;
#endif
	if(wr)delete wr;
}

object* object::copy()
{
/*
	object	*neo=new object();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
*/
return(NULL);
}

int object::create(const uchar &mf,const BPoint &mp)
{
/*
	if((mf==PRESS)&&(cpts<pts)){
		pt[cpts]=mp;
		if(++cpts>=pts)cpts=-1;		//create complete
	}
	return(cpts);
*/
return(-1);
}

int object::select_chk(const BPoint &p)
{
/*
	int	spt=0;
	for(int i=0;i<pts;i++){
		BRect	rp(pt[i].x-2,pt[i].y-2,pt[i].x+2,pt[i].y+2);
		if(rp.Contains(p))spt=i+1;
	}
	if(spt)sel_pt=spt;
	return(spt);
*/
return(0);
}
int object::select_chk(const BRect &r)
{
/*
	int	spt=0;
	for(int i=0;i<pts;i++){
		BRect	rp(pt[i].x-2,pt[i].y-2,pt[i].x+2,pt[i].y+2);
		if(r.Contains(rp)||r.Intersects(rp))spt=-1;
	}
	if(spt)sel_pt=spt;
	return(spt);
*/
return(0);
}

void object::set_attr(const s_attr &m,const uint32 &f)
{
/*
printf("object:setattr\n");
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x10)da.fon=m.fon;
	if(f&0x20)da.fos=m.fos;
	if(f&0x40)da.pen=m.pen;
//	if(f&0x80)da.sty=m.sty;

	if(f&0xf0)if(wr){delete wr;wr=NULL;}
*/
}

void object::move(const BPoint &d)
{
/*
	if(sel_pt==0)return;
	for(int i=0;i<pts;i++){
		if((sel_pt<0)||(sel_pt==i+1))pt[i]+=d;
	}
*/
}

void object::inspoint(const BPoint &d)
{
}

bool object::delpoint()
{
	return(false);
}

void object::draw(BBitmap *bm)
{
	if(cpts>=0)return;							//now create
	uint32	*o=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	if(!wr)obj2ras();

	int16	*wrp=wr;
	int		l=rbounds.left;
	int		t=rbounds.top;
	int		w=rbounds.IntegerWidth()+1;
	int		h=rbounds.IntegerHeight()+1;
	o+=(int)(l+t*dy);
	for(int y=0;y<h;y++){
		int		x=*(wrp++);
		while(1){
			bool	f=(x!=-1);
			if(f){
				uchar	pc=*(wrp++);
				int	x2=*(wrp++);
				if(x2==-1){x2=w;f=false;}
				if(pc==0){
					x=x2;
				}else{
					uchar	pn=(pc==1)?da.fg:da.bg;
					for(;x<x2;x++){//line
						if(!canvas.Contains(BPoint(l+x,t+y)))continue;
						uint32	c=pal[(pat[pn][y&0x0f]&(1<<(x&0x0f)))?da.fc:da.bc];
						uint32	*p=o+(int)(x+y*dy);
						overlap(p,c);
					}
				}
				if(x<w)continue;
			}
			break;
		}
	}
}

void object::drawframe(BView *v,float scale)
{
	if(sel_pt)drawpoint(v,scale);
	if(cpts<0)return;
}

void object::form2ctrlp()
{
}

void object::ctrlp2form()
{
//set rbounds
}

void object::read(BFile &f)
{
}

void object::write(BFile &f)
{
}

void object::settext(const char *s,const uchar &f)
{
}

void object::setbitmap(const BRect &r,const uint32 *d)
{
}

int object::draw2bm(BBitmap &bm)
{
return(0);
}

void object::chk_usedef()
{
	if(attrflag&FGCOL)udf[da.fc]|=0x01;
	if(attrflag&BGCOL)udf[da.bc]|=0x01;
	if(attrflag&FGPAT)udf[da.fg]|=0x02;
	if(attrflag&BGPAT)udf[da.bg]|=0x02;
	if(attrflag&FONT)udf[da.fon]|=0x80;
}

void object::drawpoint(BView *v,float scale)
{
	v->SetDrawingMode(B_OP_INVERT);
	for(int i=0;i<pts;i++){
		BPoint	p(pt[i].x*scale,pt[i].y*scale);
		v->FillRect(BRect(p-BPoint(2,2),p+BPoint(2,2)));
	}
	v->SetDrawingMode(B_OP_COPY);
}

void object::overlap(uint32 *p,uint32 c)
{
#if	BYTE_ORDER==__LITTLE_ENDIAN
	BGRA	cc;
#else
	ARGB	cc;
#endif
	BGRA	pp,nn;
	cc.c=c;
	if(cc.u.a==0x00)return;
	if(cc.u.a==0xff){*p=B_HOST_TO_LENDIAN_INT32(c);return;}
	pp.c=*p;
	float	kc=(float)cc.u.a/255;
	float	kp=(float)1-kc;
	nn.u.r=kc*cc.u.r+kp*pp.u.r;
	nn.u.g=kc*cc.u.g+kp*pp.u.g;
	nn.u.b=kc*cc.u.b+kp*pp.u.b;
	nn.u.a=0xff;
	*p=nn.c;
}

void object::obj2ras()
{
	if(wr){delete wr;wr=NULL;}
	if(pts){		//create raster-data
		ctrlp2form();
		BRect	r(0,0,rbounds.IntegerWidth(),rbounds.IntegerHeight());
		BBitmap	*wb=new BBitmap(r,B_GRAYSCALE_8_BIT,TRUE);
		int c=draw2bm(*wb);

		wr=new int16[c];
		int16	*wrp=wr;
		uchar	*wp=(uchar*)(wb->Bits());
		int		wdy=wb->BytesPerRow();
		int		w=wb->Bounds().IntegerWidth()+1;
		int		h=wb->Bounds().IntegerHeight()+1;
		for(int y=0;y<h;y++){
			uchar	f1=0;
			for(int x=0;x<w;x++){
				uchar	f2=*(wp+x+y*wdy);
				if(f1!=f2){
					*(wrp++)=x;
					*(wrp++)=f2;
					f1=f2;
				}
			}
			*(wrp++)=-1;
		}
		*(wrp++)=-1;
		delete wb;
	}
}
//------------------------------------------------
object_r::object_r():object()
{
}
object_r::object_r(const BPoint &p,const s_attr &m):object(p,m,4)
{
}

int object_r::create(const uchar &mf,const BPoint &mp)
{
	if((mf==PRESS)&&(cpts==0)){
		pt[3]=pt[2]=pt[1]=pt[0]=mp;
		cpts=1;
	}
	if((mf==RELEASE)&&(cpts==1)){
		pt[3].x=pt[1].x=mp.x;
		pt[3].y=pt[2].y=mp.y;
		cpts=-1;		//create complete
	}
	if((mf==PRESSMOVE)&&(cpts==1)){
		pt[3].x=pt[1].x=mp.x;
		pt[3].y=pt[2].y=mp.y;
	}
	ctrlp2form();
	return(cpts);
}

int object_r::select_chk(const BPoint &p)
{
	int	spt=0;
	for(int i=0;i<4;i++){
		BRect	rp(pt[i].x-2,pt[i].y-2,pt[i].x+2,pt[i].y+2);
		if(rp.Contains(p))spt=i+1;
	}
	if(spt==0){
		if(da.rec.Contains(p))spt=-1;
	}
	if(spt)sel_pt=spt;
	return(spt);
}
int object_r::select_chk(const BRect &r)
{
	int	spt=0;
	if(r.Contains(da.rec)||r.Intersects(da.rec))spt=-1;
	if(spt)sel_pt=spt;
	return(spt);
}

void object_r::move(const BPoint &d)
{
	if(sel_pt==0)return;
	if((sel_pt>0)&&(editflag<EDITABLE))return;
	if(sel_pt<0){pt[0]+=d;pt[1]+=d;pt[2]+=d;pt[3]+=d;}
	if(sel_pt==1){pt[0]+=d;pt[2].x+=d.x;pt[1].y+=d.y;}
	if(sel_pt==2){pt[1]+=d;pt[3].x+=d.x;pt[0].y+=d.y;}
	if(sel_pt==3){pt[2]+=d;pt[0].x+=d.x;pt[3].y+=d.y;}
	if(sel_pt==4){pt[3]+=d;pt[1].x+=d.x;pt[2].y+=d.y;}
	ctrlp2form();
	if(sel_pt>0)if(wr){delete wr;wr=NULL;}
}

void object_r::drawframe(BView *v,float scale)
{
	if(sel_pt)drawpoint(v,scale);
	if(cpts<0)return;
	v->SetDrawingMode(B_OP_INVERT);
	v->StrokeRect(BRect(pt[0].x*scale,pt[0].y*scale,pt[3].x*scale,pt[3].y*scale),B_MIXED_COLORS);
	v->SetDrawingMode(B_OP_COPY);
}
//------------------------------------------------
object_l::object_l():object()
{
	addf=false;
}
object_l::object_l(const BPoint &p,const s_attr &m):object(p,m,0)
{
	addf=false;
}

int object_l::create(const uchar &mf,const BPoint &mp)
{
	if(mf==PRESS){
		if(cpts==0){
			pt[pts++]=mp;	//next
			cpts++;
		}else{
			BRect	rp(pt[cpts-1].x-2,pt[cpts-1].y-2,pt[cpts-1].x+2,pt[cpts-1].y+2);
			if(rp.Contains(mp)){	//create complete
				pts--;
				cpts=-1;
			}else{
				pt[cpts++]=mp;
				pt[pts++]=mp;	//next
			}
		}
	}
	if(mf==CANSEL){
		cpts--;pts--;
		if(pts<2){
			pts=0;cpts=-2;
		}else{
			pt[pts-1]=mp;
		}
	}
	if((mf==RELEASEMOVE)&&(cpts)){
		pt[pts-1]=mp;
	}
	ctrlp2form();
	return(cpts);
}

int object_l::select_chk(const BPoint &p)
{
	int	spt=0;
	for(int i=0;i<pts;i++){
		BRect	rp(pt[i].x-2,pt[i].y-2,pt[i].x+2,pt[i].y+2);
		if(rp.Contains(p))spt=i+1;
	}
	if(spt==0){
		if(da.rec.Contains(p))spt=-1;
	}
	if(spt)sel_pt=spt;
	addf=(spt>0);
	return(spt);
}
int object_l::select_chk(const BRect &r)
{
	int	spt=0;
	if(r.Contains(da.rec)||r.Intersects(da.rec))spt=-1;
	if(spt)sel_pt=spt;
	addf=(spt>0);
	return(spt);
}

void object_l::move(const BPoint &d)
{
	if(sel_pt==0)return;
	for(int i=0;i<pts;i++){
		if((sel_pt<0)||(sel_pt-1==i))pt[i]+=d;
	}
	ctrlp2form();
	if(sel_pt>0)if(wr){delete wr;wr=NULL;}
}
//------------------------------------------------
obj_rect::obj_rect():object_r()
{
	objtype=RECT;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|PENSZ;
}
obj_rect::obj_rect(const BPoint &p,const s_attr &m):object_r(p,m)
{
	objtype=RECT;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|PENSZ;
	set_attr(m);
}

object* obj_rect::copy()
{
	obj_rect	*neo=new obj_rect();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_rect::set_attr(const s_attr &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_rect::form2ctrlp()
{
	sint16	l,r,t,b;
	l=da.rec.left;
	r=da.rec.right;
	t=da.rec.top;
	b=da.rec.bottom;
	pt=new BPoint[pts=4];
	pt[0].x=pt[2].x=l;	pt[1].x=pt[3].x=r;
	pt[0].y=pt[1].y=t;	pt[2].y=pt[3].y=b;
	cpts=-1;
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_rect::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	if(l>pt[1].x)l=pt[1].x;	if(l>pt[2].x)l=pt[2].x;	if(l>pt[3].x)l=pt[3].x;
	if(r<pt[1].x)r=pt[1].x;	if(r<pt[2].x)r=pt[2].x;	if(r<pt[3].x)r=pt[3].x;
	if(t>pt[1].y)t=pt[1].y;	if(t>pt[2].y)t=pt[2].y;	if(t>pt[3].y)t=pt[3].y;
	if(b<pt[1].y)b=pt[1].y;	if(b<pt[2].y)b=pt[2].y;	if(b<pt[3].y)b=pt[3].y;
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_rect::read(BFile &f)
{
	int	l=13;
	char	*dt=new char[l];
	f.Read(dt,l);
	da.rec.left=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+0)));
	da.rec.top=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+2)));
	da.rec.right=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+4)));
	da.rec.bottom=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+6)));
	da.fc=cx[*((uchar*)(dt+8))];
	da.bc=cx[*((uchar*)(dt+9))];
	da.fg=px[*((uchar*)(dt+10))];
	da.bg=px[*((uchar*)(dt+11))];
	da.pen=*((uchar*)(dt+12));
	delete	dt;
	form2ctrlp();
}

void obj_rect::write(BFile &f)
{
	int	l=14;
	char	*dt=new char[l];
	dt[0]=RECT;
	*((uint16*)(dt+1))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.left);
	*((uint16*)(dt+3))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.top);
	*((uint16*)(dt+5))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.right);
	*((uint16*)(dt+7))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.bottom);
	*((uchar*)(dt+9))=cx[da.fc];
	*((uchar*)(dt+10))=cx[da.bc];
	*((uchar*)(dt+11))=px[da.fg];
	*((uchar*)(dt+12))=px[da.bg];
	*((uchar*)(dt+13))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_rect::draw2bm(BBitmap &bm)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
//	wv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	wv->SetHighColor(20,0,0);	//fg=1(grayscale)
	wv->SetLowColor(20,20,0);	//bg=2(grayscale)
	memset(bm.Bits(),0,bm.BitsLength());	//clear
	bm.Lock();
	bm.AddChild(wv);
	BRect	r(da.rec.LeftTop()-rbounds.LeftTop(),da.rec.RightBottom()-rbounds.LeftTop());
	wv->FillRect(r,B_SOLID_LOW);
	if(da.pen)wv->StrokeRect(r);
//	if(da.pen)wv->StrokeRoundRect(r,da.pen/2,da.pen/2);
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;
	return((rbounds.IntegerHeight()+1)*9+da.pen*5);
}
//------------------------------------------------
obj_ellipse::obj_ellipse():object_r()
{
	objtype=ELLIPSE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|PENSZ;
}
obj_ellipse::obj_ellipse(const BPoint &p,const s_attr &m):object_r(p,m)
{
	objtype=ELLIPSE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|PENSZ;
	set_attr(m);
}

object* obj_ellipse::copy()
{
	obj_ellipse	*neo=new obj_ellipse();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_ellipse::set_attr(const s_attr &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_ellipse::drawframe(BView *v,float scale)
{
	if(sel_pt)drawpoint(v,scale);
	if(cpts<0)return;
	v->SetDrawingMode(B_OP_INVERT);
	v->StrokeEllipse(BRect(pt[0].x*scale,pt[0].y*scale,pt[3].x*scale,pt[3].y*scale),B_MIXED_COLORS);
	v->SetDrawingMode(B_OP_COPY);
}

void obj_ellipse::form2ctrlp()
{
	sint16	l,r,t,b;
	l=da.rec.left;
	r=da.rec.right;
	t=da.rec.top;
	b=da.rec.bottom;
	pt=new BPoint[pts=4];
	pt[0].x=pt[2].x=l;	pt[1].x=pt[3].x=r;
	pt[0].y=pt[1].y=t;	pt[2].y=pt[3].y=b;
	cpts=-1;
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_ellipse::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	if(l>pt[1].x)l=pt[1].x;	if(l>pt[2].x)l=pt[2].x;	if(l>pt[3].x)l=pt[3].x;
	if(r<pt[1].x)r=pt[1].x;	if(r<pt[2].x)r=pt[2].x;	if(r<pt[3].x)r=pt[3].x;
	if(t>pt[1].y)t=pt[1].y;	if(t>pt[2].y)t=pt[2].y;	if(t>pt[3].y)t=pt[3].y;
	if(b<pt[1].y)b=pt[1].y;	if(b<pt[2].y)b=pt[2].y;	if(b<pt[3].y)b=pt[3].y;
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_ellipse::read(BFile &f)
{
	int	l=13;
	char	*dt=new char[l];
	f.Read(dt,l);
	da.rec.left=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+0)));
	da.rec.top=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+2)));
	da.rec.right=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+4)));
	da.rec.bottom=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+6)));
	da.fc=cx[*((uchar*)(dt+8))];
	da.bc=cx[*((uchar*)(dt+9))];
	da.fg=px[*((uchar*)(dt+10))];
	da.bg=px[*((uchar*)(dt+11))];
	da.pen=*((uchar*)(dt+12));
	delete	dt;
	form2ctrlp();
}

void obj_ellipse::write(BFile &f)
{
	int	l=14;
	char	*dt=new char[l];
	dt[0]=ELLIPSE;
	*((uint16*)(dt+1))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.left);
	*((uint16*)(dt+3))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.top);
	*((uint16*)(dt+5))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.right);
	*((uint16*)(dt+7))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.bottom);
	*((uchar*)(dt+9))=cx[da.fc];
	*((uchar*)(dt+10))=cx[da.bc];
	*((uchar*)(dt+11))=px[da.fg];
	*((uchar*)(dt+12))=px[da.bg];
	*((uchar*)(dt+13))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_ellipse::draw2bm(BBitmap &bm)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
	wv->SetHighColor(20,0,0);	//fg=1(grayscale)
	wv->SetLowColor(20,20,0);	//bg=2(grayscale)
	memset(bm.Bits(),0,bm.BitsLength());	//clear
	bm.Lock();
	bm.AddChild(wv);
	BRect	r(da.rec.LeftTop()-rbounds.LeftTop(),da.rec.RightBottom()-rbounds.LeftTop());
	wv->FillEllipse(r,B_SOLID_LOW);
	if(da.pen)wv->StrokeEllipse(r);
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;
	return((rbounds.IntegerHeight()+1)*9+da.pen*5);
}
//------------------------------------------------
obj_text::obj_text():object_r()
{
	objtype=TEXT;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|FONT|FNTSZ;
	da.str=NULL;
}
obj_text::obj_text(const BPoint &p,const s_attr &m):object_r(p,m)
{
	objtype=TEXT;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|FONT|FNTSZ;
	da.str=NULL;
	set_attr(m);
}

obj_text::~obj_text()
{
	if(da.str)delete da.str;
}

object* obj_text::copy()
{
	obj_text	*neo=new obj_text();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	neo->da.str=NULL;	neo->settext(da.str,0);
	return(neo);
}

void obj_text::set_attr(const s_attr &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x10)da.fon=m.fon;
	if(f&0x20)da.fos=m.fos;
//	if(f&0x80)da.sty=m.sty;

	if(f&0x30)if(wr){delete wr;wr=NULL;}
}

void obj_text::form2ctrlp()
{
	sint16	l,r,t,b;
	l=da.rec.left;
	r=da.rec.right;
	t=da.rec.top;
	b=da.rec.bottom;
	pt=new BPoint[pts=4];
	pt[0].x=pt[2].x=l;	pt[1].x=pt[3].x=r;
	pt[0].y=pt[1].y=t;	pt[2].y=pt[3].y=b;
	cpts=-1;
	rbounds=BRect(l,t,r,b);
}

void obj_text::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	if(l>pt[1].x)l=pt[1].x;	if(l>pt[2].x)l=pt[2].x;	if(l>pt[3].x)l=pt[3].x;
	if(r<pt[1].x)r=pt[1].x;	if(r<pt[2].x)r=pt[2].x;	if(r<pt[3].x)r=pt[3].x;
	if(t>pt[1].y)t=pt[1].y;	if(t>pt[2].y)t=pt[2].y;	if(t>pt[3].y)t=pt[3].y;
	if(b<pt[1].y)b=pt[1].y;	if(b<pt[2].y)b=pt[2].y;	if(b<pt[3].y)b=pt[3].y;
	da.rec=BRect(l,t,r,b);
	rbounds=BRect(l,t,r,b);
}

void obj_text::read(BFile &f)
{
	int	l=15;
	char	*d=new char[l];
	f.Read(d,l);
	da.rec.left=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+0)));
	da.rec.top=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+2)));
	da.rec.right=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+4)));
	da.rec.bottom=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+6)));
	da.fc=cx[*((uchar*)(d+8))];
	da.bc=cx[*((uchar*)(d+9))];
	da.fg=px[*((uchar*)(d+10))];
	da.bg=px[*((uchar*)(d+11))];
	da.fon=fx[*((uchar*)(d+12))];
	da.fos=*((uchar*)(d+13));
	int	sl=*((uchar*)(d+14));
	delete	d;
	da.str=new char[sl+1];
	f.Read(da.str,sl);
	da.str[sl]=0;
	form2ctrlp();
}

void obj_text::write(BFile &f)
{
	int	sl=strlen(da.str);
	int	l=16+sl;
	char	*d=new char[l];
	d[0]=TEXT;
	*((uint16*)(d+1))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.left);
	*((uint16*)(d+3))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.top);
	*((uint16*)(d+5))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.right);
	*((uint16*)(d+7))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.bottom);
	*((uchar*)(d+9))=cx[da.fc];
	*((uchar*)(d+10))=cx[da.bc];
	*((uchar*)(d+11))=px[da.fg];
	*((uchar*)(d+12))=px[da.bg];
	*((uchar*)(d+13))=fx[da.fon];
	*((uchar*)(d+14))=da.fos;
	*((uchar*)(d+15))=sl;
	memcpy(d+16,da.str,sl);
	f.Write(d,l);
	delete d;
}

void obj_text::settext(const char *s,const uchar &f)
{
	if(da.str){delete da.str;da.str=NULL;}
	da.str=new char[strlen(s)+1];
	strcpy(da.str,s);
	if(f){
		BFont	wf;
		font_height	fh;
		int		w,h;
		wf.SetFamilyAndStyle(ft[da.fon].fam,ft[da.fon].sty);
		wf.SetSize(da.fos);
		w=(int)wf.StringWidth(s);
		wf.GetHeight(&fh);
		h=(int)(fh.ascent+fh.descent);
		int16	l=pt[0].x;
		int16	t=pt[0].y;
		int16	r=l+w-1;
		int16	b=t+h-1;
		pt[1].x=r;	pt[1].y=t;
		pt[2].x=l;	pt[2].y=b;
		pt[3].x=r;	pt[3].y=b;
		cpts=-1;
	}
	ctrlp2form();
}

int obj_text::draw2bm(BBitmap &bm)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetHighColor(20,0,0);	//fg=1(grayscale)
	wv->SetLowColor(20,20,0);	//bg=2(grayscale)
	BFont	wf;
	font_height	fh;
	wf.SetFamilyAndStyle(ft[da.fon].fam,ft[da.fon].sty);
	wf.SetSize(da.fos);
	wf.GetHeight(&fh);
	wv->SetFont(&wf);
	memset(bm.Bits(),0,bm.BitsLength());	//clear
	bm.Lock();
	bm.AddChild(wv);
	BRect	r(da.rec.LeftTop()-rbounds.LeftTop(),da.rec.RightBottom()-rbounds.LeftTop());
	wv->FillRect(r,B_SOLID_LOW);
	if(da.str)wv->DrawString(da.str,BPoint(0,fh.ascent));
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;
	return((rbounds.IntegerWidth()+1)*3*(rbounds.IntegerHeight()+1));
}
//------------------------------------------------
obj_bitmap::obj_bitmap():object_r()
{
	objtype=BITMAP;	editflag=MOVEONLY;	attrflag=0;
	da.bm=NULL;
}
obj_bitmap::obj_bitmap(const BPoint &p,const s_attr &m):object_r(p,m)
{
	objtype=BITMAP;	editflag=MOVEONLY;	attrflag=0;
	da.bm=NULL;
	set_attr(m);
}

obj_bitmap::~obj_bitmap()
{
	if(da.bm)delete da.bm;
}

object* obj_bitmap::copy()
{
	obj_bitmap	*neo=new obj_bitmap();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[pts];
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	neo->da.bm=NULL;	neo->setbitmap(da.bm->Bounds(),(uint32*)(da.bm->Bits()));
	return(neo);
}

void obj_bitmap::draw(BBitmap *bm)
{
	if(cpts>=0)return;
	int16	l=(int16)da.rec.left;
	int16	t=(int16)da.rec.top;
	int16	r=(int16)da.rec.right;
	int16	b=(int16)da.rec.bottom;
	int	w=r-l+1;
	int	h=b-t+1;
	if(da.bm){
		uint32	*o=(uint32*)(bm->Bits());
		int		dy=bm->BytesPerRow()/4;
		o+=(int)(l+t*dy);
		uchar	*wp=(uchar*)(da.bm->Bits());
		int		wdy=da.bm->BytesPerRow()/4;
		for(int y=0;y<h;y++)for(int x=0;x<w;x++){
			if(!canvas.Contains(BPoint(l+x,t+y)))continue;
			if(!da.bm->Bounds().Contains(BPoint(x,y)))continue;
			uint32	c=*((uint32*)wp+x+y*wdy);
			uint32	*p=o+(int)(x+y*dy);
			overlap(p,c);
		}
	}
}

void obj_bitmap::form2ctrlp()
{
	sint16	l,r,t,b;
	l=da.rec.left;
	r=da.rec.right;
	t=da.rec.top;
	b=da.rec.bottom;
	pt=new BPoint[pts=4];
	pt[0].x=pt[2].x=l;	pt[1].x=pt[3].x=r;
	pt[0].y=pt[1].y=t;	pt[2].y=pt[3].y=b;
	cpts=-1;
	rbounds=BRect(l,t,r,b);
}

void obj_bitmap::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	if(l>pt[1].x)l=pt[1].x;	if(l>pt[2].x)l=pt[2].x;	if(l>pt[3].x)l=pt[3].x;
	if(r<pt[1].x)r=pt[1].x;	if(r<pt[2].x)r=pt[2].x;	if(r<pt[3].x)r=pt[3].x;
	if(t>pt[1].y)t=pt[1].y;	if(t>pt[2].y)t=pt[2].y;	if(t>pt[3].y)t=pt[3].y;
	if(b<pt[1].y)b=pt[1].y;	if(b<pt[2].y)b=pt[2].y;	if(b<pt[3].y)b=pt[3].y;
	da.rec=BRect(l,t,r,b);
	rbounds=BRect(l,t,r,b);
}

void obj_bitmap::read(BFile &f)
{
	int	l=8;
	char	*d=new char[l];
	f.Read(d,l);
	da.rec.left=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+0)));
	da.rec.top=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+2)));
	da.rec.right=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+4)));
	da.rec.bottom=B_BENDIAN_TO_HOST_INT16(*((uint16*)(d+6)));
	delete	d;
	BRect	r(da.rec);
	r.OffsetTo(0,0);
	da.bm=new BBitmap(r,B_RGB_32_BIT);
	f.Read(da.bm->Bits(),da.bm->BitsLength());
	form2ctrlp();
}

void obj_bitmap::write(BFile &f)
{
	int	bl=da.bm->BitsLength();
	int	l=9+bl;
	char	*d=new char[l];
	d[0]=BITMAP;
	*((uint16*)(d+1))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.left);
	*((uint16*)(d+3))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.top);
	*((uint16*)(d+5))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.right);
	*((uint16*)(d+7))=B_HOST_TO_BENDIAN_INT16((uint16)da.rec.bottom);
	memcpy(d+9,da.bm->Bits(),bl);
	f.Write(d,l);
	delete d;
}

void obj_bitmap::setbitmap(const BRect &rec,const uint32 *d)
{
	if(da.bm){delete da.bm;da.bm=NULL;}
	da.bm=new BBitmap(rec,B_RGB_32_BIT);
//	memcpy(da.bm->Bits(),d,da.bm->BitsLength());
	uint32	*p=(uint32*)(da.bm->Bits());
	uint32	len=da.bm->BitsLength()/4;
	for(int i=0;i<len;i++)p[i]=B_LENDIAN_TO_HOST_INT32(d[i]);
	sint16	l=pt[0].x;
	sint16	t=pt[0].y;
	sint16	r=l+rec.IntegerWidth();
	sint16	b=t+rec.IntegerHeight();
	pt[1].x=r;	pt[1].y=t;
	pt[2].x=l;	pt[2].y=b;
	pt[3].x=r;	pt[3].y=b;
	cpts=-1;
	ctrlp2form();
}

int obj_bitmap::draw2bm(BBitmap &bm)
{
	return(0);
}
//------------------------------------------------
obj_line::obj_line():object_l()
{
	objtype=LINE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|PENSZ;
}
obj_line::obj_line(const BPoint &p,const s_attr &m):object_l(p,m)
{
	objtype=LINE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|PENSZ;
	set_attr(m);
}

object* obj_line::copy()
{
	obj_line	*neo=new obj_line();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[256];///
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_line::set_attr(const s_attr &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_line::inspoint(const BPoint &d)
{
	if(!addf)return;
	BPoint	p=d+pt[sel_pt-1];
	float	d1,d2;
	d1=0;d2=0;
	if(sel_pt!=1){
		d1+=(p.x-pt[sel_pt-2].x)*(p.x-pt[sel_pt-2].x)+(p.y-pt[sel_pt-2].y)*(p.y-pt[sel_pt-2].y);
		d2+=(pt[sel_pt-2].x-pt[sel_pt-1].x)*(pt[sel_pt-2].x-pt[sel_pt-1].x)+(pt[sel_pt-2].y-pt[sel_pt-1].y)*(pt[sel_pt-2].y-pt[sel_pt-1].y);
	}
	if(sel_pt!=pts){
		d1+=(pt[sel_pt].x-pt[sel_pt-1].x)*(pt[sel_pt].x-pt[sel_pt-1].x)+(pt[sel_pt].y-pt[sel_pt-1].y)*(pt[sel_pt].y-pt[sel_pt-1].y);
		d2+=(p.x-pt[sel_pt].x)*(p.x-pt[sel_pt].x)+(p.y-pt[sel_pt].y)*(p.y-pt[sel_pt].y);
	}	
	if(d1>d2)sel_pt++;
	for(int i=pts;i>=sel_pt;i--)pt[i]=pt[i-1];
	pt[sel_pt-1]=p;
	pts++;
	ctrlp2form();
	if(wr){delete wr;wr=NULL;}
	addf=false;
}

bool obj_line::delpoint()
{
	bool	f=(--pts<2);
	if(!f){
		for(int i=sel_pt-1;i<pts;i++)pt[i]=pt[i+1];
		ctrlp2form();
		if(wr){delete wr;wr=NULL;}
	}
	return(f);
}

void obj_line::drawframe(BView *v,float scale)
{
	if(sel_pt)drawpoint(v,scale);
	if(cpts<0)return;
	v->SetDrawingMode(B_OP_INVERT);
	v->MovePenTo(pt[0].x*scale,pt[0].y*scale);
	for(int i=1;i<pts;i++)v->StrokeLine(BPoint(pt[i].x*scale,pt[i].y*scale),B_MIXED_COLORS);
	v->SetDrawingMode(B_OP_COPY);
}

void obj_line::form2ctrlp()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
	cpts=-1;
}

void obj_line::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_line::read(BFile &f)
{
	f.Read(&pts,1);
	pt=new BPoint[256];///pts
	int	l=pts*4+4;
	char	*dt=new char[l];
	f.Read(dt,l);
	for(int i=0;i<pts;i++){
		pt[i].x=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+0)));
		pt[i].y=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+2)));
	}
	da.fc=cx[*((uchar*)(dt+pts*4+0))];
	da.bc=cx[*((uchar*)(dt+pts*4+1))];
	da.fg=px[*((uchar*)(dt+pts*4+2))];
	da.pen=*((uchar*)(dt+pts*4+3));
	delete	dt;
	form2ctrlp();
}

void obj_line::write(BFile &f)
{
	int	l=pts*4+6;
	char	*dt=new char[l];
	dt[0]=LINE;
	*((uchar*)(dt+1))=pts;
	for(int i=0;i<pts;i++){
		*((uint16*)(dt+i*4+2))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].x);
		*((uint16*)(dt+i*4+4))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].y);
	}
	*((uchar*)(dt+pts*4+2))=cx[da.fc];
	*((uchar*)(dt+pts*4+3))=cx[da.bc];
	*((uchar*)(dt+pts*4+4))=px[da.fg];
	*((uchar*)(dt+pts*4+5))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_line::draw2bm(BBitmap &bm)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
	wv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	wv->SetHighColor(20,0,0);	//fg=1(grayscale)
//	wv->SetLowColor(20,20,0);	//bg=2(grayscale)
	memset(bm.Bits(),0,bm.BitsLength());	//clear
	bm.Lock();
	bm.AddChild(wv);
	wv->MovePenTo(pt[0]-rbounds.LeftTop());
	for(int i=1;i<pts;i++)wv->StrokeLine(pt[i]-rbounds.LeftTop());
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;

	int	c=0;
	int	y=pt[0].y;
	for(int i=1;i<pts;i++){c+=abs(pt[i].y-y+1);y=pt[i].y;}
	c=c*9+da.pen*pts*5;
	return(c);
}
//------------------------------------------------
obj_polygon::obj_polygon():object_l()
{
	objtype=POLY;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|PENSZ;
}
obj_polygon::obj_polygon(const BPoint &p,const s_attr &m):object_l(p,m)
{
	objtype=POLY;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|PENSZ;
	set_attr(m);
}

object* obj_polygon::copy()
{
	obj_polygon	*neo=new obj_polygon();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[256];///
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_polygon::set_attr(const s_attr &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_polygon::inspoint(const BPoint &d)
{
	if(!addf)return;
	BPoint	p=d+pt[sel_pt-1];
	float	d1,d2;
	d1=0;d2=0;
	if(sel_pt!=1){
		d1+=(p.x-pt[sel_pt-2].x)*(p.x-pt[sel_pt-2].x)+(p.y-pt[sel_pt-2].y)*(p.y-pt[sel_pt-2].y);
		d2+=(pt[sel_pt-2].x-pt[sel_pt-1].x)*(pt[sel_pt-2].x-pt[sel_pt-1].x)+(pt[sel_pt-2].y-pt[sel_pt-1].y)*(pt[sel_pt-2].y-pt[sel_pt-1].y);
	}else{
		d1+=(p.x-pt[pts-1].x)*(p.x-pt[pts-1].x)+(p.y-pt[pts-1].y)*(p.y-pt[pts-1].y);
		d2+=(pt[pts-1].x-pt[0].x)*(pt[pts-1].x-pt[0].x)+(pt[pts-1].y-pt[0].y)*(pt[pts-1].y-pt[0].y);
	}
	if(sel_pt!=pts){
		d1+=(pt[sel_pt].x-pt[sel_pt-1].x)*(pt[sel_pt].x-pt[sel_pt-1].x)+(pt[sel_pt].y-pt[sel_pt-1].y)*(pt[sel_pt].y-pt[sel_pt-1].y);
		d2+=(p.x-pt[sel_pt].x)*(p.x-pt[sel_pt].x)+(p.y-pt[sel_pt].y)*(p.y-pt[sel_pt].y);
	}else{
		d1+=(pt[0].x-pt[pts-1].x)*(pt[0].x-pt[pts-1].x)+(pt[0].y-pt[pts-1].y)*(pt[0].y-pt[pts-1].y);
		d2+=(p.x-pt[0].x)*(p.x-pt[0].x)+(p.y-pt[0].y)*(p.y-pt[0].y);
	}
	if(d1>d2)sel_pt++;
	for(int i=pts;i>=sel_pt;i--)pt[i]=pt[i-1];
	pt[sel_pt-1]=p;
	pts++;
	ctrlp2form();
	if(wr){delete wr;wr=NULL;}
	addf=false;
}

bool obj_polygon::delpoint()
{
	bool	f=(--pts<3);
	if(!f){
		for(int i=sel_pt-1;i<pts;i++)pt[i]=pt[i+1];
		ctrlp2form();
		if(wr){delete wr;wr=NULL;}
	}
	return(f);
}

void obj_polygon::drawframe(BView *v,float scale)
{
	if(sel_pt)drawpoint(v,scale);
	if(cpts<0)return;
	v->SetDrawingMode(B_OP_INVERT);
	v->MovePenTo(pt[0].x*scale,pt[0].y*scale);
	for(int i=1;i<pts;i++)v->StrokeLine(BPoint(pt[i].x*scale,pt[i].y*scale),B_MIXED_COLORS);
	if(pts>2)v->StrokeLine(BPoint(pt[0].x*scale,pt[0].y*scale),B_MIXED_COLORS);
	v->SetDrawingMode(B_OP_COPY);
}

void obj_polygon::form2ctrlp()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
	cpts=-1;
}

void obj_polygon::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_polygon::read(BFile &f)
{
	f.Read(&pts,1);
	pt=new BPoint[256];///
	int	l=pts*4+5;
	char	*dt=new char[l];
	f.Read(dt,l);
	for(int i=0;i<pts;i++){
		pt[i].x=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+0)));
		pt[i].y=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+2)));
	}
	da.fc=cx[*((uchar*)(dt+pts*4+0))];
	da.bc=cx[*((uchar*)(dt+pts*4+1))];
	da.fg=px[*((uchar*)(dt+pts*4+2))];
	da.bg=px[*((uchar*)(dt+pts*4+3))];
	da.pen=*((uchar*)(dt+pts*4+4));
	delete	dt;
	form2ctrlp();
}

void obj_polygon::write(BFile &f)
{
	int	l=pts*4+7;
	char	*dt=new char[l];
	dt[0]=POLY;
	*((uchar*)(dt+1))=pts;
	for(int i=0;i<pts;i++){
		*((uint16*)(dt+i*4+2))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].x);
		*((uint16*)(dt+i*4+4))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].y);
	}
	*((uchar*)(dt+pts*4+2))=cx[da.fc];
	*((uchar*)(dt+pts*4+3))=cx[da.bc];
	*((uchar*)(dt+pts*4+4))=px[da.fg];
	*((uchar*)(dt+pts*4+5))=px[da.bg];
	*((uchar*)(dt+pts*4+6))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_polygon::draw2bm(BBitmap &bm)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
	wv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	wv->SetHighColor(20,0,0);	//fg=1(grayscale)
	wv->SetLowColor(20,20,0);	//bg=2(grayscale)
	memset(bm.Bits(),0,bm.BitsLength());	//clear
	bm.Lock();
	bm.AddChild(wv);
	BPoint	tp[256];
	for(int i=0;i<pts;i++)tp[i]=pt[i]-rbounds.LeftTop();
	if(pts>2){
		wv->FillPolygon(tp,pts,B_SOLID_LOW);
		if(da.pen)wv->StrokePolygon(tp,pts);
	}else{
		if(da.pen)wv->StrokeLine(tp[0],tp[1]);
	}
	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;

	int	c=0;
	int	y=pt[pts-1].y;
	for(int i=0;i<pts;i++){c+=abs(pt[i].y-y+1);y=pt[i].y;}
	c=c*9+da.pen*pts*5;
	return(c);
}
//------------------------------------------------
obj_curve::obj_curve():object_l()
{
	objtype=CURVE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|PENSZ;
}
obj_curve::obj_curve(const BPoint &p,const s_attr &m):object_l(p,m)
{
	objtype=CURVE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|PENSZ;
	set_attr(m);
}

object* obj_curve::copy()
{
	obj_curve	*neo=new obj_curve();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[256];///
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_curve::set_attr(const s_attr &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_curve::inspoint(const BPoint &d)
{
	if(!addf)return;
	BPoint	p=d+pt[sel_pt-1];
	float	d1,d2;
	d1=0;d2=0;
	if(sel_pt!=1){
		d1+=(p.x-pt[sel_pt-2].x)*(p.x-pt[sel_pt-2].x)+(p.y-pt[sel_pt-2].y)*(p.y-pt[sel_pt-2].y);
		d2+=(pt[sel_pt-2].x-pt[sel_pt-1].x)*(pt[sel_pt-2].x-pt[sel_pt-1].x)+(pt[sel_pt-2].y-pt[sel_pt-1].y)*(pt[sel_pt-2].y-pt[sel_pt-1].y);
	}
	if(sel_pt!=pts){
		d1+=(pt[sel_pt].x-pt[sel_pt-1].x)*(pt[sel_pt].x-pt[sel_pt-1].x)+(pt[sel_pt].y-pt[sel_pt-1].y)*(pt[sel_pt].y-pt[sel_pt-1].y);
		d2+=(p.x-pt[sel_pt].x)*(p.x-pt[sel_pt].x)+(p.y-pt[sel_pt].y)*(p.y-pt[sel_pt].y);
	}	
	if(d1>d2)sel_pt++;
	for(int i=pts;i>=sel_pt;i--)pt[i]=pt[i-1];
	pt[sel_pt-1]=p;
	pts++;
	ctrlp2form();
	if(wr){delete wr;wr=NULL;}
	addf=false;
}

bool obj_curve::delpoint()
{
	bool	f=(--pts<2);
	if(!f){
		for(int i=sel_pt-1;i<pts;i++)pt[i]=pt[i+1];
		ctrlp2form();
		if(wr){delete wr;wr=NULL;}
	}
	return(f);
}

void obj_curve::drawframe(BView *v,float scale)
{
	if(sel_pt)drawpoint(v,scale);
	if(cpts<0)return;
	v->SetDrawingMode(B_OP_INVERT);
/*
	v->MovePenTo(pt[0].x*scale,pt[0].y*scale);
	for(int i=1;i<pts;i++)v->StrokeLine(BPoint(pt[i].x*scale,pt[i].y*scale),B_MIXED_COLORS);
*/
	if(pts>2){	// spline
		BPoint	q[4];
		for(int i=0;i<pts-2;i++){
			q[0]=(i==0)?pt[i]:BPoint((pt[i].x+pt[i+1].x)/2,(pt[i].y+pt[i+1].y)/2);
			q[3]=(i==pts-3)?pt[i+2]:BPoint((pt[i+1].x+pt[i+2].x)/2,(pt[i+1].y+pt[i+2].y)/2);
			q[1]=BPoint((q[0].x+pt[i+1].x*2)/3,(q[0].y+pt[i+1].y*2)/3);
			q[2]=BPoint((q[3].x+pt[i+1].x*2)/3,(q[3].y+pt[i+1].y*2)/3);

			q[0]=BPoint(q[0].x*scale,q[0].y*scale);
			q[1]=BPoint(q[1].x*scale,q[1].y*scale);
			q[2]=BPoint(q[2].x*scale,q[2].y*scale);
			q[3]=BPoint(q[3].x*scale,q[3].y*scale);
			v->StrokeBezier(q,B_MIXED_COLORS);
		}
	}else{
		v->StrokeLine(BPoint(pt[0].x*scale,pt[0].y*scale),BPoint(pt[1].x*scale,pt[1].y*scale),B_MIXED_COLORS);
	}

	v->SetDrawingMode(B_OP_COPY);
}

void obj_curve::form2ctrlp()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
	cpts=-1;
}

void obj_curve::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_curve::read(BFile &f)
{
	f.Read(&pts,1);
	pt=new BPoint[256];///pts
	int	l=pts*4+4;
	char	*dt=new char[l];
	f.Read(dt,l);
	for(int i=0;i<pts;i++){
		pt[i].x=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+0)));
		pt[i].y=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+2)));
	}
	da.fc=cx[*((uchar*)(dt+pts*4+0))];
	da.bc=cx[*((uchar*)(dt+pts*4+1))];
	da.fg=px[*((uchar*)(dt+pts*4+2))];
	da.pen=*((uchar*)(dt+pts*4+3));
	delete	dt;
	form2ctrlp();
}

void obj_curve::write(BFile &f)
{
	int	l=pts*4+6;
	char	*dt=new char[l];
	dt[0]=CURVE;
	*((uchar*)(dt+1))=pts;
	for(int i=0;i<pts;i++){
		*((uint16*)(dt+i*4+2))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].x);
		*((uint16*)(dt+i*4+4))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].y);
	}
	*((uchar*)(dt+pts*4+2))=cx[da.fc];
	*((uchar*)(dt+pts*4+3))=cx[da.bc];
	*((uchar*)(dt+pts*4+4))=px[da.fg];
	*((uchar*)(dt+pts*4+5))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_curve::draw2bm(BBitmap &bm)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
	wv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	wv->SetHighColor(20,0,0);	//fg=1(grayscale)
//	wv->SetLowColor(20,20,0);	//bg=2(grayscale)
	memset(bm.Bits(),0,bm.BitsLength());	//clear
	bm.Lock();
	bm.AddChild(wv);

// spline
	BPoint	q[4];
	for(int i=0;i<pts-2;i++){
		q[0]=(i==0)?pt[i]:BPoint((pt[i].x+pt[i+1].x)/2,(pt[i].y+pt[i+1].y)/2);
		q[3]=(i==pts-3)?pt[i+2]:BPoint((pt[i+1].x+pt[i+2].x)/2,(pt[i+1].y+pt[i+2].y)/2);
		q[1]=BPoint((q[0].x+pt[i+1].x*2)/3,(q[0].y+pt[i+1].y*2)/3);
		q[2]=BPoint((q[3].x+pt[i+1].x*2)/3,(q[3].y+pt[i+1].y*2)/3);

		q[0]=q[0]-rbounds.LeftTop();
		q[1]=q[1]-rbounds.LeftTop();
		q[2]=q[2]-rbounds.LeftTop();
		q[3]=q[3]-rbounds.LeftTop();
		wv->StrokeBezier(q);
	}
//

	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;

	int	c=0;
	int	y=pt[0].y;
	for(int i=1;i<pts;i++){c+=abs(pt[i].y-y+1);y=pt[i].y;}
	c=c*9+da.pen*pts*5;
	return(c);
}
//------------------------------------------------
obj_shape::obj_shape():object_l()
{
	objtype=SHAPE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|PENSZ;
}
obj_shape::obj_shape(const BPoint &p,const s_attr &m):object_l(p,m)
{
	objtype=SHAPE;	editflag=EDITABLE;	attrflag=FGCOL|BGCOL|FGPAT|BGPAT|PENSZ;
	set_attr(m);
}

object* obj_shape::copy()
{
	obj_shape	*neo=new obj_shape();
	neo->sel_pt=sel_pt;
	neo->pts=pts;
	neo->pt=new BPoint[256];///
	for(int i=0;i<pts;i++)neo->pt[i]=pt[i];
	neo->cpts=cpts;
	neo->rbounds=rbounds;
	neo->wr=NULL;
	neo->da=da;
	return(neo);
}

void obj_shape::set_attr(const s_attr &m,const uint32 &f)
{
	if(f&0x01)da.fc=m.fc;
	if(f&0x02)da.bc=m.bc;
	if(f&0x04)da.fg=m.fg;
	if(f&0x08)da.bg=m.bg;
	if(f&0x40)da.pen=m.pen;

	if(f&0x40)if(wr){delete wr;wr=NULL;}
}

void obj_shape::inspoint(const BPoint &d)
{
	if(!addf)return;
	BPoint	p=d+pt[sel_pt-1];
	float	d1,d2;
	d1=0;d2=0;
	if(sel_pt!=1){
		d1+=(p.x-pt[sel_pt-2].x)*(p.x-pt[sel_pt-2].x)+(p.y-pt[sel_pt-2].y)*(p.y-pt[sel_pt-2].y);
		d2+=(pt[sel_pt-2].x-pt[sel_pt-1].x)*(pt[sel_pt-2].x-pt[sel_pt-1].x)+(pt[sel_pt-2].y-pt[sel_pt-1].y)*(pt[sel_pt-2].y-pt[sel_pt-1].y);
	}else{
		d1+=(p.x-pt[pts-1].x)*(p.x-pt[pts-1].x)+(p.y-pt[pts-1].y)*(p.y-pt[pts-1].y);
		d2+=(pt[pts-1].x-pt[0].x)*(pt[pts-1].x-pt[0].x)+(pt[pts-1].y-pt[0].y)*(pt[pts-1].y-pt[0].y);
	}
	if(sel_pt!=pts){
		d1+=(pt[sel_pt].x-pt[sel_pt-1].x)*(pt[sel_pt].x-pt[sel_pt-1].x)+(pt[sel_pt].y-pt[sel_pt-1].y)*(pt[sel_pt].y-pt[sel_pt-1].y);
		d2+=(p.x-pt[sel_pt].x)*(p.x-pt[sel_pt].x)+(p.y-pt[sel_pt].y)*(p.y-pt[sel_pt].y);
	}else{
		d1+=(pt[0].x-pt[pts-1].x)*(pt[0].x-pt[pts-1].x)+(pt[0].y-pt[pts-1].y)*(pt[0].y-pt[pts-1].y);
		d2+=(p.x-pt[0].x)*(p.x-pt[0].x)+(p.y-pt[0].y)*(p.y-pt[0].y);
	}
	if(d1>d2)sel_pt++;
	for(int i=pts;i>=sel_pt;i--)pt[i]=pt[i-1];
	pt[sel_pt-1]=p;
	pts++;
	ctrlp2form();
	if(wr){delete wr;wr=NULL;}
	addf=false;
}

bool obj_shape::delpoint()
{
	bool	f=(--pts<3);
	if(!f){
		for(int i=sel_pt-1;i<pts;i++)pt[i]=pt[i+1];
		ctrlp2form();
		if(wr){delete wr;wr=NULL;}
	}
	return(f);
}

void obj_shape::drawframe(BView *v,float scale)
{
	if(sel_pt)drawpoint(v,scale);
	if(cpts<0)return;
	v->SetDrawingMode(B_OP_INVERT);
/*
	v->MovePenTo(pt[0].x*scale,pt[0].y*scale);
	for(int i=1;i<pts;i++)v->StrokeLine(BPoint(pt[i].x*scale,pt[i].y*scale),B_MIXED_COLORS);
	if(pts>2)v->StrokeLine(BPoint(pt[0].x*scale,pt[0].y*scale),B_MIXED_COLORS);
*/
	if(pts>2){
		BShape	bs;
		BPoint	q[4];
		bs.MoveTo(BPoint((pt[0].x+pt[1].x)/2*scale,(pt[0].y+pt[1].y)/2*scale));
		for(int i=0;i<pts;i++){
			q[0]=BPoint((pt[i].x+pt[(i+1)%pts].x)/2,(pt[i].y+pt[(i+1)%pts].y)/2);
			q[3]=BPoint((pt[(i+1)%pts].x+pt[(i+2)%pts].x)/2,(pt[(i+1)%pts].y+pt[(i+2)%pts].y)/2);
			q[1]=BPoint((q[0].x+pt[(i+1)%pts].x*2)/3,(q[0].y+pt[(i+1)%pts].y*2)/3);
			q[2]=BPoint((q[3].x+pt[(i+1)%pts].x*2)/3,(q[3].y+pt[(i+1)%pts].y*2)/3);

//			q[0]=BPoint(q[0].x*scale,q[0].y*scale);
			q[1]=BPoint(q[1].x*scale,q[1].y*scale);
			q[2]=BPoint(q[2].x*scale,q[2].y*scale);
			q[3]=BPoint(q[3].x*scale,q[3].y*scale);
			bs.BezierTo(q+1);
		}
//		bs.Close();
		v->MovePenTo(BPoint(0,0));
		v->StrokeShape(&bs,B_MIXED_COLORS);
	}else{
		v->StrokeLine(BPoint(pt[0].x*scale,pt[0].y*scale),BPoint(pt[1].x*scale,pt[1].y*scale),B_MIXED_COLORS);
	}

	v->SetDrawingMode(B_OP_COPY);
}

void obj_shape::form2ctrlp()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
	cpts=-1;
}

void obj_shape::ctrlp2form()
{
	sint16	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	da.rec=BRect(l,t,r,b);
	l-=(da.pen+1)/2;
	t-=(da.pen+1)/2;
	r+=(da.pen+1)/2;
	b+=(da.pen+1)/2;
	rbounds=BRect(l,t,r,b);
}

void obj_shape::read(BFile &f)
{
	f.Read(&pts,1);
	pt=new BPoint[256];///
	int	l=pts*4+5;
	char	*dt=new char[l];
	f.Read(dt,l);
	for(int i=0;i<pts;i++){
		pt[i].x=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+0)));
		pt[i].y=B_BENDIAN_TO_HOST_INT16(*((uint16*)(dt+i*4+2)));
	}
	da.fc=cx[*((uchar*)(dt+pts*4+0))];
	da.bc=cx[*((uchar*)(dt+pts*4+1))];
	da.fg=px[*((uchar*)(dt+pts*4+2))];
	da.bg=px[*((uchar*)(dt+pts*4+3))];
	da.pen=*((uchar*)(dt+pts*4+4));
	delete	dt;
	form2ctrlp();
}

void obj_shape::write(BFile &f)
{
	int	l=pts*4+7;
	char	*dt=new char[l];
	dt[0]=SHAPE;
	*((uchar*)(dt+1))=pts;
	for(int i=0;i<pts;i++){
		*((uint16*)(dt+i*4+2))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].x);
		*((uint16*)(dt+i*4+4))=B_HOST_TO_BENDIAN_INT16((uint16)pt[i].y);
	}
	*((uchar*)(dt+pts*4+2))=cx[da.fc];
	*((uchar*)(dt+pts*4+3))=cx[da.bc];
	*((uchar*)(dt+pts*4+4))=px[da.fg];
	*((uchar*)(dt+pts*4+5))=px[da.bg];
	*((uchar*)(dt+pts*4+6))=da.pen;
	f.Write(dt,l);
	delete dt;
}

int obj_shape::draw2bm(BBitmap &bm)
{
	BView *wv=new BView(bm.Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
//	wv->SetViewColor(0,0,0);
	wv->SetPenSize(da.pen);
	wv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	wv->SetHighColor(20,0,0);	//fg=1(grayscale)
	wv->SetLowColor(20,20,0);	//bg=2(grayscale)
	memset(bm.Bits(),0,bm.BitsLength());	//clear
	bm.Lock();
	bm.AddChild(wv);

	BShape	bs;
	BPoint	q[4];
	bs.MoveTo(BPoint((pt[0].x+pt[1].x)/2,(pt[0].y+pt[1].y)/2)-rbounds.LeftTop());
	for(int i=0;i<pts;i++){
		q[0]=BPoint((pt[i].x+pt[(i+1)%pts].x)/2,(pt[i].y+pt[(i+1)%pts].y)/2);
		q[3]=BPoint((pt[(i+1)%pts].x+pt[(i+2)%pts].x)/2,(pt[(i+1)%pts].y+pt[(i+2)%pts].y)/2);
		q[1]=BPoint((q[0].x+pt[(i+1)%pts].x*2)/3,(q[0].y+pt[(i+1)%pts].y*2)/3);
		q[2]=BPoint((q[3].x+pt[(i+1)%pts].x*2)/3,(q[3].y+pt[(i+1)%pts].y*2)/3);

//		q[0]=q[0]-rbounds.LeftTop();
		q[1]=q[1]-rbounds.LeftTop();
		q[2]=q[2]-rbounds.LeftTop();
		q[3]=q[3]-rbounds.LeftTop();
		bs.BezierTo(q+1);
	}
//	bs.Close();
	wv->FillShape(&bs,B_SOLID_LOW);
	if(da.pen)wv->StrokeShape(&bs);

	wv->Sync();
	bm.RemoveChild(wv);
	bm.Unlock();
	delete wv;

	int	c=0;
	int	y=pt[pts-1].y;
	for(int i=0;i<pts;i++){c+=abs(pt[i].y-y+1);y=pt[i].y;}
	c=c*9+da.pen*pts*5;
	return(c);
}
