// gproe.cpp		ver.0.053
//copyright 1998-2004 Beer[Tsutsumi Hiroyuki]

#include	"gproe.h"

#define	VER		"ver.0.053"
#define	DATE	"2004. 7. 5"

int main()
{
	if(!(tr=BTranslatorRoster::Default()))return(1);
	gproe	app;
	app.Run();
	return(0);
}
//------------------------------------------------
gproe::gproe():BApplication("application/x-vnd.Beer-gproe")
{
#if	B_BEOS_VERSION>=0x0520
	app_info	ai;	be_app->GetAppInfo(&ai);
	BPath	ap(&ai.ref),dp;
	ap.GetParent(&dp);
	BPath	lp(dp);
	lp.Append("Language/Dictionaries");
	lp.Append("gpro");
	be_locale.LoadLanguageFile(lp.Path());
#endif

	canvas.Set(0,0,0,0);
	BRect	frame;
	frame.Set(100,100,499,399);
	w=new gproewindow(frame);
}

void gproe::RefsReceived(BMessage *mes)
{
	uint32	type;
	int32	files;
	mes->GetInfo("refs",&type,&files);
	if(files>0){
		entry_ref	eref;
		BMessage msg(B_SIMPLE_DATA);
		for(int i=0;i<files;i++){
			mes->FindRef("refs",i,&eref);
			msg.AddRef("refs",&eref);
		}
		BMessenger(w->v).SendMessage(&msg);//w->PostMessage(&msg,w->v);
	}
}

void gproe::MessageReceived(BMessage *mes)
{
	switch(mes->what){
		case B_SAVE_REQUESTED:{
			entry_ref	dir;
			const char		*name;
			mes->FindRef("directory",&dir);
			mes->FindString("name",&name);
			BMessage msg(B_SAVE_REQUESTED);
			msg.AddRef("directory",&dir);
			msg.AddString("name",name);
			BMessenger(w->v).SendMessage(&msg);//w->PostMessage(&msg,w->v);
		}break;
		case B_CANCEL:{
			BMessenger(w->v).SendMessage(B_CANCEL);//w->PostMessage(B_CANCEL,w->v);
		}break;
		default:{
			BApplication::MessageReceived(mes);
		}break;
	}
}

void gproe::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"Gproe "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.wht.mmtr.or.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
} 
//------------------------------------------------
gproewindow::gproewindow(BRect frame):BWindow(frame,"gproe "VER,B_DOCUMENT_WINDOW,0)
{
	get_translator_for_output();
	BRect	viewframe;
	viewframe.Set(0,0,frame.Width()-B_V_SCROLL_BAR_WIDTH,frame.Height()-B_H_SCROLL_BAR_HEIGHT-20);
	viewframe.OffsetTo(0,20);			//for menus
	v=new gproeview(viewframe);
	AddChild(v);
	setupmenus();
	BRect	sbvframe;
	sbvframe.Set(0,0,B_V_SCROLL_BAR_WIDTH,viewframe.Height()+2);
	sbvframe.OffsetTo(viewframe.Width()+1,20-1);
	sbv=new BScrollBar(sbvframe,"scrollv",(BView*)v,0,0,B_VERTICAL);
	AddChild(sbv);
	BRect	sbhframe;
	sbhframe.Set(0,0,viewframe.Width()+2,B_H_SCROLL_BAR_HEIGHT);
	sbhframe.OffsetTo(-1,viewframe.Height()+21);
	sbh=new BScrollBar(sbhframe,"scrollh",(BView*)v,0,0,B_HORIZONTAL);
	AddChild(sbh);
	FrameResized(frame.Width(),frame.Height());
	Show();
}

bool gproewindow::QuitRequested()
{
	xlator	*xl;
	for(int i=0;xl=(xlator*)xlt.ItemAt(i);i++)delete xl;
	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);//be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void gproewindow::Zoom(BPoint rec_position,float rec_width,float rec_height)
{
	int	w,h;
	w=canvas.IntegerWidth()+(int)B_V_SCROLL_BAR_WIDTH;		//+scrollbar
	h=canvas.IntegerHeight()+20+(int)B_H_SCROLL_BAR_HEIGHT;	//+menu+scrollbar
	if(w<400)w=399;
	if(h<300)h=299;
	SetSizeLimits(399,w,299,h);
	if((Bounds().IntegerWidth()==w)&&(Bounds().IntegerHeight()==h)){w=399;h=299;}
	ResizeTo(w,h);
}

void gproewindow::FrameResized(float width,float height)
{
	float	rv,rh;
	rv=canvas.Height()-sbv->Bounds().Height()+2;
	rh=canvas.Width()-sbh->Bounds().Width()+2;
	sbv->SetRange(0,rv>0?rv:0);
	sbh->SetRange(0,rh>0?rh:0);
	sbv->SetProportion(sbv->Bounds().Height()/canvas.Height());
	sbh->SetProportion(sbh->Bounds().Width()/canvas.Width());
	sbv->SetSteps(5,sbv->Bounds().Height());
	sbh->SetSteps(5,sbh->Bounds().Width());
}

void gproewindow::setupmenus()
{
//	BMenuBar	*mb;
	BMenu		*m,*mm;
	BMenuItem	*mi;
	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
/*
	 mi=new BMenuItem("new",new BMessage('fine'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
*/
	 mi=new BMenuItem(_T("Open"),new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
/*
	 mi=new BMenuItem("close",new BMessage('ficl'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("save",new BMessage('fiow'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
*/
	 mm=new BMenu(_T("Save as"));
		for(int i=0;i<trc;i++){
			mes=new BMessage('fiwr');
			mes->AddInt16("format_no",i);
			mi=new BMenuItem(((xlator*)xlt.ItemAt(i))->name,mes);
			mi->SetTarget((BHandler*)v);
			mm->AddItem(mi);
		}
	 m->AddItem(mm);
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	m=new BMenu(_T("Effect"));
	 mi=new BMenuItem(_T("Undo"),new BMessage('efun'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mm=new BMenu(_T("Reverse"));
	  mes=new BMessage('efre');mes->AddInt8("rgb",7);
	  mi=new BMenuItem(_T("All"),mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('efre');mes->AddInt8("rgb",1);
	  mi=new BMenuItem(_T("Red"),mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('efre');mes->AddInt8("rgb",2);
	  mi=new BMenuItem(_T("Green"),mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('efre');mes->AddInt8("rgb",4);
	  mi=new BMenuItem(_T("Blue"),mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	 m->AddItem(mm);
	 mm=new BMenu(_T("Mirror"));
	  mes=new BMessage('efmi');mes->AddInt16("deg",0);
	  mi=new BMenuItem(_T("Horizontal"),mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('efmi');mes->AddInt16("deg",90);
	  mi=new BMenuItem(_T("Vertical"),mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	 m->AddItem(mm);
	 mm=new BMenu(_T("Rotate"));
	  mes=new BMessage('efro');mes->AddInt16("deg",90);
	  mi=new BMenuItem(_T("Right"),mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('efro');mes->AddInt16("deg",180);
	  mi=new BMenuItem(_T("Turn"),mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('efro');mes->AddInt16("deg",270);
	  mi=new BMenuItem(_T("Left"),mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	 m->AddItem(mm);
	 mi=new BMenuItem(_T("Wave"),new BMessage('efwa'));			//waver
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Contrast"),new BMessage('efco'));		//contrast
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Color-RGB"),new BMessage('efc1'));	//rgb,huv
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Color-LSH"),new BMessage('efc2'));	//lsh
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Monochrome"),new BMessage('efmo'));		//monochrome
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Frequency"),new BMessage('efeq'));	//equalizer
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Medium"),new BMessage('efme'));		//medium5-filter
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	mb->AddItem(m);
	m=new BMenu(_T("Frame"));
	 mi=new BMenuItem(_T("Rectangle"),new BMessage('frre'));
	 mi->SetMarked(true);
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Ellipse"),new BMessage('frel'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Canvas"),new BMessage('frca'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 m->SetRadioMode(true);
	mb->AddItem(m);
	m=new BMenu(_T("Overlap"));
	 mi=new BMenuItem(_T("Overwrite"),new BMessage('ovov'));
	 mi->SetMarked(true);
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Translucence"),new BMessage('ovtr'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mes=new BMessage('ovgr');mes->AddInt16("deg",0);
	 mi=new BMenuItem(_T("Gradation-N"),mes);
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mes=new BMessage('ovgr');mes->AddInt16("deg",90);
	 mi=new BMenuItem(_T("Gradation-E"),mes);
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mes=new BMessage('ovgr');mes->AddInt16("deg",270);
	 mi=new BMenuItem(_T("Gradation-W"),mes);
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mes=new BMessage('ovgr');mes->AddInt16("deg",180);
	 mi=new BMenuItem(_T("Gradation-S"),mes);
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mes=new BMessage('ovgr');mes->AddInt16("deg",-1);
	 mi=new BMenuItem(_T("Gradation-C"),mes);
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mes=new BMessage('ovgr');mes->AddInt16("deg",-2);
	 mi=new BMenuItem(_T("Gradation-O"),mes);
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Chromakey"),new BMessage('ovch'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 m->SetRadioMode(true);
	mb->AddItem(m);
	AddChild(mb);
}

void gproewindow::markmenu(const char *menu,const char *item)
{
	if(mb==NULL)return;
	int	c=mb->CountItems();
	for(int i=0;i<c;i++){
		BMenu	*m=mb->SubmenuAt(i);
		if(strcmp(m->Name(),menu))continue;
		int	ic=m->CountItems();
		for(int j=0;j<ic;j++){
			BMenuItem	*mi=m->ItemAt(j);
			if(strcmp(mi->Label(),item))continue;
//printf("found: [%s]-[%s]\n",m->Name(),mi->Label());
			mi->SetMarked(true);
		}
	}
}

void gproewindow::get_translator_for_output()
{
	BBitmap 			*tbm=new BBitmap(BRect(0,0,7,7),B_RGB_32_BIT);
	BBitmapStream		*instrm=new BBitmapStream(tbm);
	translator_info		*inf;
	const translation_format	*frm;
	int32				infs,frms;
	tr->GetTranslators(instrm,NULL,&inf,&infs);
	for(int i=0;i<infs;i++){
		tr->GetOutputFormats(inf[i].translator,&frm,&frms);
		for(int j=0;j<frms;j++){
//printf("%c%c%c%c %4.2f %4.2f\n",frm[j].type>>24,frm[j].type>>16,frm[j].type>>8,frm[j].type,frm[j].quality,frm[j].capability);
			if(frm[j].type=='bits')continue;		//standard bitmap
			if(frm[j].type=='mhi!')continue;		//progressive bitmap
			xlator	*xl=new xlator;
			xl->type=frm[j].type;
			xl->id=inf[i].translator;
			strcpy(xl->name,frm[j].name);
			strcpy(xl->mime,frm[j].MIME);
			if(frm[j].type=='TGA ')xlt.AddItem((void*)xl,0);else xlt.AddItem((void*)xl);
			trc++;
		}
	}
	delete inf;
}
//------------------------------------------------
gproeview::gproeview(BRect frame):BView(frame,"canvas",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	bm=NULL;
	un.bm=NULL;		//no undo_bitmap
	bmdd=NULL;		//no bitmap for drag&drop
	sel_now.type=sel_old.type=0;
	mode=1;
	olmode=0;
	grmode=-1;
	efwin=false;
	fp=NULL;		//no file_panel
	xfno=0;
}

void gproeview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(50,50,50);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);
	MakeFocus();
	Window()->Zoom();
}

void gproeview::Draw(BRect rect)
{
	if(bm){
		ConstrainClippingRegion(&BRegion(rect&canvas));
		redraw();
		ConstrainClippingRegion(&BRegion(canvas));		//need !!
	}else{
		SetFontSize(30);
		DrawString("Gproe",BPoint(45,50));
		SetFontSize(20);
		DrawString(VER,BPoint(75,80));
	}
}

void gproeview::MouseDown(BPoint pt)
{
	if(efwin)return;
	if(!canvas.Contains(pt))return;

	BPoint	p;uint32	b;	GetMouse(&p,&b);
	if(b==B_SECONDARY_MOUSE_BUTTON){	//for chromakey
		int		dy=bm->BytesPerRow()/4;
		uint32	*p=(uint32*)(bm->Bits());
		if(olmode==-1){chrom=*(p+(int)(pt.y*dy+pt.x))&B_HOST_TO_LENDIAN_INT32(0xffffff);setoverlap();}	//for chromakey
		return;
	}
	mdf=true;

	if((sel_now.type)&&(sel_now.rect.Contains(pt))){
		mdf=false;
		if(bmdd){delete bmdd;bmdd=NULL;}
		bmdd=new BBitmap(sel_now.rect,B_RGB_32_BIT);
		int		dy=bm->BytesPerRow()/4;
		int		w=sel_now.rect.IntegerWidth()+1;
		int		h=sel_now.rect.IntegerHeight()+1;
		uint32	*p=(uint32*)(bm->Bits());
		if(olmode==-1){chrom=*(p+(int)(pt.y*dy+pt.x))&B_HOST_TO_LENDIAN_INT32(0xffffff);setoverlap();}	//for chromakey
		p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
		uint32	*q=(uint32*)(bmdd->Bits());
		for(int y=0;y<h;y++)for(int x=0;x<w;x++)*(q++)=*(p+dy*y+x);
		BMessage	*mes=ddmessage();
		DragMessage(mes,sel_now.rect);
	}else{
		sel_now.type=0;
		sel_now.rect.left=sel_now.rect.right=pt.x;
		sel_now.rect.top=sel_now.rect.bottom=pt.y;
		redraw(0x0c);
	}
}

void gproeview::MouseUp(BPoint pt)
{
	if(efwin)return;
	mdf=false;
	BRect r=sel_now.rect;
	if(r.left>r.right){sel_now.rect.left=r.right;sel_now.rect.right=r.left;}
	if(r.top>r.bottom){sel_now.rect.top=r.bottom;sel_now.rect.bottom=r.top;}
	redraw(0x0c);
	setoverlap();
}

void gproeview::MouseMoved(BPoint pt, uint32 code, const BMessage *msg)
{
	if(efwin)return;
	if(!canvas.Contains(pt))return;
	if((mdf)&&(mode>0)){
		sel_now.type=mode;
		sel_now.rect.SetRightBottom(pt);
		redraw(0x0c);
	}
}

void gproeview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	static BPoint	dp;
	BPoint	dr_pt,dr_off;
	if((!msg->FindPoint("_drop_point_",&dr_pt))&&(!msg->FindPoint("_drop_offset_",&dr_off))){
		ConvertFromScreen(&dr_pt);
		float	sc;
		if(!msg->FindFloat("scale",&sc))dr_off=BPoint(dr_off.x/sc,dr_off.y/sc);	//for gprop
		dp=dr_pt-dr_off;
	}

	if(efwin){
		switch(msg->what){
			case 'Vchg':{
//msg->PrintToStream();
				int f=0;
				float	red,green,blue;
				float	lum,sat,hue;
				float	m_red,m_green,m_blue;
				float	dc,al,ah;
				float	bb,ct;
				float	wl,wh;
				bool	wd;
				if(!msg->FindFloat("red",&red))f=1;
				if(!msg->FindFloat("green",&green))f=1;
				if(!msg->FindFloat("blue",&blue))f=1;
				if(!msg->FindFloat("lum",&lum))f=2;
				if(!msg->FindFloat("sat",&sat))f=2;
				if(!msg->FindFloat("hue",&hue))f=2;
				if(!msg->FindFloat("dc",&dc))f=3;
				if(!msg->FindFloat("ac-low",&al))f=3;
				if(!msg->FindFloat("ac-high",&ah))f=3;
				if(!msg->FindFloat("length",&wl))f=4;
				if(!msg->FindFloat("height",&wh))f=4;
				if(!msg->FindBool("dir",&wd))f=4;
				if(!msg->FindFloat("boundary",&bb))f=5;
				if(!msg->FindFloat("contrast",&ct))f=5;
				if(!msg->FindFloat("m_red",&m_red))f=6;
				if(!msg->FindFloat("m_green",&m_green))f=6;
				if(!msg->FindFloat("m_blue",&m_blue))f=6;
				if(f==1)rgbcontrol(red,green,blue);
				if(f==2)lshcontrol(lum,sat,hue);
				if(f==3)equalize(dc,al,ah);
				if(f==4)wave(wl,wh,wd);
				if(f==5)contrast(bb,ct);
				if(f==6)monochrome(m_red,m_green,m_blue);
//printf("main: sendreply\n");
				msg->SendReply('okok');
			}break;
			case 'quit':{
				efwin=false;
			}break;
			default:{
				BView::MessageReceived(msg);
			}break;
		}
	}else{
		switch(msg->what){
			case B_COPY_TARGET:{	//drop(to external)
				ddcopy(msg);
			}break;
			case B_SIMPLE_DATA:{	//'DATA'(drop from external)
				uint32	type;
				int32	files;
				if(!msg->GetInfo("refs",&type,&files)){		//file
					for(int i=0;i<files;i++){
						entry_ref	eref;
						msg->FindRef("refs",i,&eref);
						load(eref);
						if(bm)break;
					}
					break;
				}
				const char	*name;
				if(!msg->FindString("be:clip_name",&name)){	//image
					BMessage	mes(B_COPY_TARGET);
//					const char	*source;
//					if((!msg->FindString("source",&source))&&(!strncmp(source,"gpro",4))){	//from gpro-series
//						mes.AddString("be:types","image/x-be-bitmap");
//					}else{
						int32	idx=0;
						const char	*mime;
						while(!msg->FindString("be:types",idx++,&mime)){
							if(!strncmp(mime,"image",5)){
								mes.AddString("be:types",mime);
								break;
							}
						}
//					}
		    		msg->SendReply(&mes,this);
					break;
				}
			}
			case 'MIME':{
				Char 	*mime;
				type_code	type;
				if(msg->GetInfo(B_MIME_TYPE,0,&mime,&type)==B_OK){
					long	bc;
					const void	*d;
					if(!strncmp(mime,"image",5)){			//image data
						if(!msg->FindData(mime,B_MIME_TYPE,&d,&bc)){
							BMemoryIO		mem(d,bc);
							BBitmapStream	strm;
							if(strcmp(mime,"image/x-be-bitmap")){
								tr->Translate(&mem,NULL,NULL,&strm,B_TRANSLATOR_BITMAP,0,mime);
							}else{
								uchar	tbuf[1024];
								int32	tlen;
								while((tlen=mem.Read(tbuf,1024))>0)strm.Write(tbuf,tlen);
							}
							BBitmap *bmp;
							strm.DetachBitmap(&bmp);
							bool	rf=false;
							uint32	*s_dat=(uint32*)(bmp->Bits());
							int		w=bmp->Bounds().IntegerWidth()+1;
							int		h=bmp->Bounds().IntegerHeight()+1;
							int		l,t;
							if(bm){
								l=dp.x;	t=dp.y;
								setundo(BRect(l,t,l+w-1,t+h-1));
								sel_now.type=0;
							}else{
								init();
								l=0;	t=0;
//								dp=BPoint(0,0);
								canvas.Set(0,0,w-1,h-1);
								bm=new BBitmap(canvas,B_RGB_32_BIT);
								memset(bm->Bits(),0,bm->BitsLength());
								Window()->Zoom();
								rf=true;
//								strcpy(title,"no title");
							}
							uint32	*p=(uint32*)(bm->Bits());
							int		dy=bm->BytesPerRow()/4;
							p+=(int)t*dy+l;
							for(int y=0;y<h;y++)for(int x=0;x<w;x++){
								if(!canvas.Contains(BPoint(l+x,t+y)))continue;
bool	olf=true;
								if(olf){
									overlap(p+dy*y+x,*((uint32*)(s_dat)+w*y+x));
								}else{
									*(p+dy*y+x)=*((uint32*)(s_dat)+w*y+x);
								}
							}
							delete bmp;
//							redraw(rf);
							Invalidate();
						}
					}
				}
			}break;
			case B_SAVE_REQUESTED:{		//save
				entry_ref	dir;
				char	*name;
				msg->FindRef("directory",&dir);
				msg->FindString("name",(const char**)&name);
				save(dir,name);
				fp=NULL;
			}break;
			case B_CANCEL:{				//save cansel
				fp=NULL;
			}break;

/*
			case 'fine':{
				delete bm;
				canvas.Set(0,0,400,300);
				bm=new BBitmap(canvas,B_RGB_32_BIT);
				memset(bm->Bits(),0,bm->BitsLength());
				sel_now.type=0;
				Invalidate();
			}break;
*/
			case 'fiop':{
				if(fp==NULL){
					fp=new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false);
					fp->Show();
				}
			}break;
			case 'fiwr':{
				if(bm){
					if(fp==NULL){
						msg->FindInt16("format_no",&xfno);
						fp=new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false);
						fp->Window()->SetTitle(((xlator*)xlt.ItemAt(xfno))->name);
						fp->Show();
					}
				}
			}break;
			case 'efun':{
				if(un.bm)undo();
			}break;
			case 'efre':{
				signed char	rgb;
				msg->FindInt8("rgb",&rgb);
				reverse(rgb);
			}break;
			case 'efmi':{
				short	deg;
				msg->FindInt16("deg",&deg);
				mirror(deg);
			}break;
			case 'efro':{
				short	deg;
				msg->FindInt16("deg",&deg);
				rotate(deg);
			}break;
			case 'efwa':{
				if((!efwin)&&(sel_now.type!=0)){
					efwin=true;
					setundo(canvas);
					effectwindow *ew=new effectwindow(BRect(200,250,400,380),4,this);
					ew->Show();
				}
			}break;
			case 'efme':{
				mediumfilter();
			}break;
			case 'efco':{
				if((!efwin)&&(sel_now.type!=0)){
					efwin=true;
					setundo(sel_now.rect);
					effectwindow *ew=new effectwindow(BRect(200,250,400,350),5,this);
					ew->Show();
				}
			}break;
			case 'efc1':{
				if((!efwin)&&(sel_now.type!=0)){
					efwin=true;
					setundo(sel_now.rect);
					effectwindow *ew=new effectwindow(BRect(200,250,400,420),1,this);
					ew->Show();
				}
			}break;
			case 'efc2':{
				if((!efwin)&&(sel_now.type!=0)){
					efwin=true;
					setundo(sel_now.rect);
					effectwindow *ew=new effectwindow(BRect(200,250,400,380),2,this);
					ew->Show();
				}
			}break;
			case 'efmo':{
				if((!efwin)&&(sel_now.type!=0)){
					efwin=true;
					setundo(sel_now.rect);
					monochrome(255,255,255);
					effectwindow *ew=new effectwindow(BRect(200,250,400,380),6,this);
					ew->Show();
				}
			}break;
			case 'efeq':{
				if((!efwin)&&(sel_now.type!=0)){
					efwin=true;
					setundo(sel_now.rect);
					effectwindow *ew=new effectwindow(BRect(200,250,400,380),3,this);
					ew->Show();
				}
			}break;
			case 'frre':{
				sel_now.type=0;
				mode=1;
				redraw(0x08);
			}break;
			case 'frel':{
				sel_now.type=0;
				mode=2;
				redraw(0x08);
			}break;
			case 'frca':{
				sel_now.rect=canvas;
				sel_now.type=1;
				mode=-1;
				redraw(0x0c);
				setoverlap();
			}break;
			case 'ovov':{
				olmode=0;
				setoverlap();
			}break;
			case 'ovtr':{
				olmode=1;
				setoverlap();
			}break;
			case 'ovgr':{
				msg->FindInt16("deg",&grmode);
				olmode=2;
				setoverlap();
			}break;
			case 'ovch':{
				olmode=-1;
			}break;
			default:{
				BView::MessageReceived(msg);
			}break;
		}
	}
}

BMessage* gproeview::ddmessage()
{
	BMessage	*msg=new BMessage(B_SIMPLE_DATA);
	msg->AddString("be:types","image/x-be-bitmap");
	for(int i=0;i<trc;i++){
		msg->AddString("be:types",((xlator*)xlt.ItemAt(i))->mime);
		msg->AddString("be:filetypes",((xlator*)xlt.ItemAt(i))->mime);			//for output
		msg->AddString("be:type_descriptions",((xlator*)xlt.ItemAt(i))->name);	//for menu
	}
	msg->AddString("be:types",B_FILE_MIME_TYPE);
	msg->AddInt32("be:actions",B_COPY_TARGET);
	msg->AddString("be:clip_name","Gproe_img");
	msg->AddString("source","gproe");
	return(msg);
}

void gproeview::ddcopy(BMessage *msg)
{
	if(bmdd==NULL)return;
	BBitmapStream	strm(bmdd);
	entry_ref	dir;
	const char	*name,*mime;
	translator_id	tid;
	uint32	fmt;
	if(msg->FindRef("directory",&dir)==B_OK){
		msg->FindString("name",&name);
		msg->FindString("be:filetypes",&mime);
		BFile	*wf=new BFile();
		BDirectory(&dir).CreateFile(name,wf,false);
		select_trans(mime,&tid,&fmt);
		tr->Translate(tid,&strm,NULL,wf,fmt);
		BAppFileInfo	wfi(wf);
		wfi.SetType(mime);
		delete wf;
	}else{
		msg->FindString("be:types",&mime);
		BMallocIO	*dat=new BMallocIO;
		BMessage	*res=new BMessage(B_MIME_DATA);
		if(strcmp(mime,"image/x-be-bitmap")){
			select_trans(mime,&tid,&fmt);
			tr->Translate(tid,&strm,NULL,dat,fmt);
		}else{
			uchar	tbuf[1024];
			int32	tlen;
			while((tlen=strm.Read(tbuf,1024))>0)dat->Write(tbuf,tlen);
		}
		res->AddData(mime,B_MIME_DATA,dat->Buffer(),dat->BufferLength());
		msg->SendReply(res);
		delete dat;
		delete res;
	}
	bmdd=NULL;
}

void gproeview::select_trans(const char *mime,translator_id *tid,uint32 *fmt)
{
	for(int i=0;i<trc;i++){
		if(strcmp(((xlator*)xlt.ItemAt(i))->mime,mime))continue;
		*tid=((xlator*)xlt.ItemAt(i))->id;
		*fmt=((xlator*)xlt.ItemAt(i))->type;
		return;
	}
	*tid=0;
	*fmt=0;
}

void gproeview::redraw(uchar f)
{
	if(bm){
		if(f&2){
			DrawBitmap(bm,BPoint(0,0));					//draw-bitmap(canvas)
		}else if(f&1){
			DrawBitmap(bm,sel_now.rect,sel_now.rect);	//draw-bitmap(frame)
		}else{
			if(f&8)drawframe(sel_old);					//erase-old-frame
		}
		if(f&4){
			drawframe(sel_now);							//draw-new-frame
			sel_old=sel_now;
		}
	}
}

void gproeview::drawframe(s_sel fr)
{
	SetDrawingMode(B_OP_INVERT);
	BRect	r=fr.rect;
	if(r.left>r.right){r.left=fr.rect.right;r.right=fr.rect.left;}
	if(r.top>r.bottom){r.top=fr.rect.bottom;r.bottom=fr.rect.top;}
	if(fr.type==1)StrokeRect(r,B_MIXED_COLORS);
	if(fr.type==2)StrokeEllipse(r,B_MIXED_COLORS);
	if(fr.type==3)StrokeRect(r,B_MIXED_COLORS);
	SetDrawingMode(B_OP_COPY);
}

void gproeview::init()
{
	sel_now.type=sel_old.type=0;
	mode=1;
	olmode=0;
	grmode=-1;
	((gproewindow*)Window())->markmenu(_T("Frame"),_T("Rectangle"));
	((gproewindow*)Window())->markmenu(_T("Overlap"),_T("Overwrite"));
}

void gproeview::load(entry_ref &eref)
{
	init();
	canvas=BRect(0,0,0,0);
	Window()->Zoom();
	BFile	*rf=new BFile(&eref,O_RDONLY|O_BINARY);
	strcpy(title,eref.name);
	if(bm){delete bm;bm=NULL;}
	BBitmapStream	outstrm;
	if(!tr->Translate(rf,NULL,NULL,&outstrm,B_TRANSLATOR_BITMAP)){
		outstrm.DetachBitmap(&bm);
		canvas=bm->Bounds();
#if	BYTE_ORDER==__BIG_ENDIAN
//printf("colorspace %04x\n",bm->ColorSpace());
		if((bm->ColorSpace()==B_RGB32_BIG)||(bm->ColorSpace()==B_RGBA32_BIG)){
			BBitmap	*tbm=bm;
			bm=new BBitmap(tbm->Bounds(),B_RGB_32_BIT);
			uint32	*q=(uint32*)bm->Bits();
			uint32	*p=(uint32*)tbm->Bits();
			int	len=tbm->BitsLength()/4;
			for(int i=0;i<len;i++)*(q++)=B_SWAP_INT32(*(p++));
			delete	tbm;
		}
#endif
	}
	delete	rf;
	Window()->Zoom();
//	redraw();
	Invalidate();
}

void gproeview::save(entry_ref &dir,char *name)
{
	BFile	*wf=new BFile();
	BDirectory(&dir).CreateFile(name,wf,false);
	BBitmapStream	instrm(bm);
	tr->Translate(&instrm,NULL,NULL,wf,((xlator*)xlt.ItemAt(xfno))->type);
	instrm.DetachBitmap(&bm);
	BAppFileInfo	wfi(wf);
	wfi.SetType(((xlator*)xlt.ItemAt(xfno))->mime);
	delete	wf;
}

void gproeview::setoverlap()
{
	if(sel_now.type!=0){
		uint32	*p=(uint32*)(bm->Bits());
		int		dy=bm->BytesPerRow()/4;
		int		w=sel_now.rect.right-sel_now.rect.left+1;
		int		h=sel_now.rect.bottom-sel_now.rect.top+1;
		float	rx2=(w/2)*(w/2);
		float	ry2=(h/2)*(h/2);
		float	xx2,yy2;
		p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
		for(int y=0;y<h;y++)for(int x=0;x<w;x++){
			*(p+dy*y+x)&=B_HOST_TO_LENDIAN_INT32(0xffffff);
			if(olmode<=0)*(p+dy*y+x)|=B_HOST_TO_LENDIAN_INT32(0xff000000);	//overwrite
			if(olmode==1)*(p+dy*y+x)|=B_HOST_TO_LENDIAN_INT32(0x80000000);	//translucence
			if(olmode==2){
				int	k;
				if(grmode<0){						//gradation(center)
					xx2=(x-w/2)*(x-w/2);
					yy2=(y-h/2)*(y-h/2);
					if(grmode==-1)k=255-(xx2/rx2+yy2/ry2)*255;
					if(grmode==-2){k=(xx2/rx2+yy2/ry2)*255;if(k>255)k=255;}
					if(k>0)*(p+dy*y+x)|=B_HOST_TO_LENDIAN_INT32((uint32)((uchar)k<<24));
				}else{								//gradation
					if(grmode==0)k=255*(h-y)/h;
					if(grmode==90)k=255*(x+1)/w;
					if(grmode==180)k=255*(y+1)/h;
					if(grmode==270)k=255*(w-x)/w;
					*(p+dy*y+x)|=B_HOST_TO_LENDIAN_INT32((uint32)((uchar)k<<24));
				}
			}
		}
		if(olmode==-1){		//chromakey
			BGRA	cc,cr;
			for(int y=0;y<h;y++)for(int x=0;x<w;x++){
				cc.c=*(p+dy*y+x);	cr.c=chrom;
				int dr=abs(cc.u.r-cr.u.r);
				int dg=abs(cc.u.g-cr.u.g);
				int db=abs(cc.u.b-cr.u.b);
				if((db<32)&&(dg<32)&&(dr<32))cc.u.a=0;
				else if((db<64)&&(dg<64)&&(dr<64))cc.u.a=(192-(dr+dg+db))*255/96;
				*(p+dy*y+x)=cc.c;
			}
		}
		if(sel_now.type==2){		//ellipse-frame
			for(int y=0;y<h;y++)for(int x=0;x<w;x++){
				xx2=(x-w/2)*(x-w/2);
				yy2=(y-h/2)*(y-h/2);
				if(rx2*ry2-xx2*ry2-yy2*rx2<0)*(p+dy*y+x)&=B_HOST_TO_LENDIAN_INT32(0xffffff);
			}
		}
	}
}

void gproeview::overlap(uint32 *p,uint32 d)
{
	BGRA	cc,cd;
	cc.c=*p;	cd.c=d;
	uchar	cca=~cd.u.a;
	cc.u.r=(cc.u.r*cca+cd.u.r*cd.u.a)/255;
	cc.u.g=(cc.u.g*cca+cd.u.g*cd.u.a)/255;
	cc.u.b=(cc.u.b*cca+cd.u.b*cd.u.a)/255;
	*p=cc.c;
}

void gproeview::setundo(BRect r)
{
	r=r&canvas;
	if(!r.IsValid())return;
	delete un.bm;
	int		w=r.right-r.left+1;
	int		h=r.bottom-r.top+1;
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*up=un.bm=new uint32[w*h];
	un.rect=r;
	p+=(int)(r.top*dy+r.left);
	for(int y=0;y<h;y++)for(int x=0;x<w;x++)*(up++)=*(p+dy*y+x);
}

void gproeview::undo()
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	int		w=un.rect.right-un.rect.left+1;
	int		h=un.rect.bottom-un.rect.top+1;
	uint32	*up=un.bm;
	p+=(int)(un.rect.top*dy+un.rect.left);
	for(int y=0;y<h;y++)for(int x=0;x<w;x++)*(p+dy*y+x)=*(up++);
	redraw(0x06);
}

void gproeview::reverse(char rgb)
{
	if(!sel_now.type)return;
	uint32	r=0;
	if(rgb&1)r|=B_HOST_TO_LENDIAN_INT32(0x00ff0000);		//red
	if(rgb&2)r|=B_HOST_TO_LENDIAN_INT32(0x0000ff00);		//green
	if(rgb&4)r|=B_HOST_TO_LENDIAN_INT32(0x000000ff);		//blue
	setundo(sel_now.rect);
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
	for(int y=0;y<h;y++)for(int x=0;x<w;x++)overlap(p+dy*y+x,*(p+dy*y+x)^r);
	redraw(0x05);
}

void gproeview::mirror(int deg)
{
	if(!sel_now.type)return;
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	uint32	d;
	setundo(sel_now.rect);
	p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
	if(deg==0){		//horizontal
		for(int y=0;y<h;y++)for(int x=0;x<w/2;x++){
			d=*(p+dy*y+x);
			overlap(p+dy*y+x,*(p+dy*y+(w-x-1)));
			overlap(p+dy*y+(w-x-1),d);
		}
	}
	if(deg==90){	//vertical
		for(int y=0;y<h/2;y++)for(int x=0;x<w;x++){
			d=*(p+dy*y+x);
			overlap(p+dy*y+x,*(p+dy*(h-y-1)+x));
			overlap(p+dy*(h-y-1)+x,d);
		}
	}
	redraw(0x05);
}

void gproeview::rotate(int deg)
{
	if(!sel_now.type)return;
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	uint32	*d=new uint32[w*h];

	uint32	*pp=p+(int)(sel_now.rect.top*dy+sel_now.rect.left);
	uint32	*dp=d;
	for(int y=0;y<h;y++)for(int x=0;x<w;x++)*(dp++)=*(pp+dy*y+x);

	if(deg==180){										//180
		setundo(sel_now.rect);
		for(int y=0;y<h;y++)for(int x=0;x<w;x++)overlap(pp+dy*y+x,*(--dp));
	}else{
		int l=sel_now.rect.left+(w-h)/2;
		int t=sel_now.rect.top+(h-w)/2;
		setundo(BRect(l,t,l+h-1,t+w-1));
		pp=p+t*dy+l;
		if(deg==90){
			for(int x=0;x<h;x++)for(int y=w-1;y>=0;y--){
				dp--;
				if(canvas.Contains(BPoint(l+x,t+y)))overlap(pp+dy*y+x,*dp);	//r-90
			}
		}
		if(deg==270){
			for(int x=h-1;x>0;x--)for(int y=0;y<w;y++){
				dp--;
				if(canvas.Contains(BPoint(l+x,t+y)))overlap(pp+dy*y+x,*dp);	//l-90
			}
		}
	}
	delete d;
	redraw(0x06);
}

void gproeview::mediumfilter()
{
	if(!sel_now.type)return;
	uint32	*p=(uint32*)(bm->Bits());
	uint32	*up=un.bm;
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	setundo(sel_now.rect);
	p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
	for(int y=1;y<h-1;y++)for(int x=1;x<w-1;x++){
		int		i,j,jj,xx,yy;
		uchar	rr[3],gg[3],bb[3];
		BGRA	cc;
		for(j=0;j<3;j++)rr[j]=gg[j]=bb[j]=0;
		for(i=0;i<5;i++){
			if(i==0){xx=x;yy=y-1;}
			if(i==1){xx=x-1;yy=y;}
			if(i==2){xx=x;yy=y;}
			if(i==3){xx=x+1;yy=y;}
			if(i==4){xx=x;yy=y+1;}
			up=un.bm+yy*w+xx;
			cc.c=*up;
			for(j=0;j<3;j++)if(rr[j]<cc.u.r){for(jj=2;jj>j;jj--)rr[jj]=rr[jj-1];rr[j]=cc.u.r;break;}
			for(j=0;j<3;j++)if(gg[j]<cc.u.g){for(jj=2;jj>j;jj--)gg[jj]=gg[jj-1];gg[j]=cc.u.g;break;}
			for(j=0;j<3;j++)if(bb[j]<cc.u.b){for(jj=2;jj>j;jj--)bb[jj]=bb[jj-1];bb[j]=cc.u.b;break;}
		}
		cc.c=*(un.bm+y*w+x);
		cc.u.r=rr[2];cc.u.g=gg[2];cc.u.b=bb[2];
		overlap(p+dy*y+x,cc.c);
		up++;
	}
	redraw(0x05);
}

void gproeview::contrast(float bbrt,float cntr)
{
	if(!sel_now.type)return;
	uint32	*p=(uint32*)(bm->Bits());
	uint32	*up=un.bm;
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
	float	n,kl,kh;
	n=pow(4,cntr/100);
	kl=pow(bbrt,1-n);
	kh=pow(255-bbrt,1-n);
	uchar	ff[256];
	for(int i=0;i<256;i++){
		int	f=(i<bbrt)?(kl*pow(i,n)):(255-kh*pow(255-i,n));
		if(f<0)ff[i]=0;else if(f>0xff)ff[i]=0xff;else ff[i]=f;
	}
	for(int y=0;y<h;y++)for(int x=0;x<w;x++){
		BGRA	cc;
		cc.c=*up;
		cc.u.r=ff[cc.u.r];
		cc.u.g=ff[cc.u.g];
		cc.u.b=ff[cc.u.b];
		*(p+dy*y+x)=*up;
		overlap(p+dy*y+x,cc.c);
		up++;
	}
	redraw(0x05);
}

void gproeview::rgbcontrol(float red,float green,float blue)
{
	if(!sel_now.type)return;
	uint32	*p=(uint32*)(bm->Bits());
	uint32	*up=un.bm;
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
	for(int y=0;y<h;y++)for(int x=0;x<w;x++){
		BGRA	cc;
		cc.c=*up;
		int	r=cc.u.r+red;	if(r<0)cc.u.r=0;else if(r>0xff)cc.u.r=0xff;else cc.u.r=r;
		int g=cc.u.g+green;	if(g<0)cc.u.g=0;else if(g>0xff)cc.u.g=0xff;else cc.u.g=g;
		int b=cc.u.b+blue;	if(b<0)cc.u.b=0;else if(b>0xff)cc.u.b=0xff;else cc.u.b=b;
		*(p+dy*y+x)=*up;
		overlap(p+dy*y+x,cc.c);
		up++;
	}
	redraw(0x05);
}

void gproeview::lshcontrol(float lum,float sat,float hue)
{
	if(!sel_now.type)return;
	uint32	*p=(uint32*)(bm->Bits());
	uint32	*up=un.bm;
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
	for(int y=0;y<h;y++)for(int x=0;x<w;x++){
		BGRA	cc;
		cc.c=*up;
		float ll=0.3*(float)cc.u.r+0.59*(float)cc.u.g+0.11*(float)cc.u.b;
		float c1=(float)cc.u.r-ll;
		float c2=(float)cc.u.b-ll;
		float ss=sqrt(c1*c1+c2*c2);
		float hh=atan2(c1,c2)*180/PI;
		ll+=lum;ss+=sat;hh+=hue;
		if(ss<0)ss=0;
		hh=PI*hh/180;
		c1=ss*sin(hh);c2=ss*cos(hh);
		int	r=ll+c1;						if(r<0)cc.u.r=0;else if(r>0xff)cc.u.r=0xff;else cc.u.r=r;
		int g=ll-0.3/0.59*c1-0.11/0.59*c2;	if(g<0)cc.u.g=0;else if(g>0xff)cc.u.g=0xff;else cc.u.g=g;
		int b=ll+c2;						if(b<0)cc.u.b=0;else if(b>0xff)cc.u.b=0xff;else cc.u.b=b;
		*(p+dy*y+x)=*up;
		overlap(p+dy*y+x,cc.c);
		up++;
	}
	redraw(0x05);
}

void gproeview::monochrome(float red,float green,float blue)
{
	if(!sel_now.type)return;
	uint32	*p=(uint32*)(bm->Bits());
	uint32	*up=un.bm;
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
	red/=255;green/=255;blue/=255;
	for(int y=0;y<h;y++)for(int x=0;x<w;x++){
		BGRA	cc;
		cc.c=*up;
		float	yy=0.2990*cc.u.r+0.5870*cc.u.g+0.1140*cc.u.b;
		cc.u.r=yy*red;
		cc.u.g=yy*green;
		cc.u.b=yy*blue;
		*(p+dy*y+x)=*up;
		overlap(p+dy*y+x,cc.c);
		up++;
	}
	redraw(0x05);
}

void gproeview::equalize(float dc,float al,float ah)
{
	if(!sel_now.type)return;
	uint32	*p=(uint32*)(bm->Bits());
	uint32	*up=un.bm;
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	p+=(int)(sel_now.rect.top*dy+sel_now.rect.left);
	int		r,g,b,k[64],i,j;
	short	m[3][64];
	for(int y=0;y<h;y+=8)for(int x=0;x<w;x+=8){
		i=0;
		BGRA	cc;
		for(int yy=y;yy<y+8;yy++)for(int xx=x;xx<x+8;xx++){
			if((yy<h)&&(xx<w)){
				cc.c=*(un.bm+yy*w+xx);
				k[i]=cc.u.a;
				m[0][i]=cc.u.r;	//r
				m[1][i]=cc.u.g;	//g
				m[2][i]=cc.u.b;	//b
			}else{
				m[0][i]=m[0][i-1];
				m[1][i]=m[1][i-1];
				m[2][i]=m[2][i-1];
			}
			i++;
		}

		for(j=0;j<3;j++){
			fdct(m[j],m[j]);
			for(i=0;i<64;i++){
				if(zigzag[i]==0)m[j][i]=(float)m[j][i]*dc/100;			//dc
				else if(zigzag[i]<6)m[j][i]=(float)m[j][i]*al/100;		//ac-low
				else m[j][i]=(float)m[j][i]*ah/100;						//ah-high
			}
			idct(m[j],m[j]);
		}

		i=0;
		for(int yy=y;yy<y+8;yy++)for(int xx=x;xx<x+8;xx++){
			if((yy<h)&&(xx<w)){
				up=un.bm+yy*w+xx;
				r=m[0][i];	if(r<0)cc.u.r=0;else if(r>0xff)cc.u.r=0xff;else cc.u.r=r;
				g=m[1][i];	if(g<0)cc.u.g=0;else if(g>0xff)cc.u.g=0xff;else cc.u.g=g;
				b=m[2][i];	if(b<0)cc.u.b=0;else if(b>0xff)cc.u.b=0xff;else cc.u.b=b;
				cc.u.a=k[i];
				*(p+dy*yy+xx)=*up;
				overlap(p+dy*yy+xx,cc.c);
			}
			i++;
		}
	}
	redraw(0x05);
}

void gproeview::wave(float wl,float wh,bool wd)
{
	if(!sel_now.type)return;
	if((wl==0)||(wh==0)){undo();return;}
	uint32	*p=(uint32*)(bm->Bits());
	uint32	*up=un.bm;
	int		dy=bm->BytesPerRow()/4;
	int		w=sel_now.rect.right-sel_now.rect.left+1;
	int		h=sel_now.rect.bottom-sel_now.rect.top+1;
	for(int y=0;y<=canvas.Height();y++)for(int x=0;x<=canvas.Width();x++)*(p++)=*(up++);
	p=(uint32*)(bm->Bits());
	up=un.bm;
	int x0=sel_now.rect.left;
	int y0=sel_now.rect.top;
	p+=(int)(dy*y0+x0);
	up+=(int)(dy*y0+x0);
	if(wd){					//vertical
		for(int y=0;y<h;y++){
			int	xx=sin(M_PI*2*y/wl)*wh;
			for(int x=0;x<w;x++){
				if((x0+x+xx<canvas.left)||(x0+x+xx>canvas.right))continue;
				overlap(p+dy*y+x+xx,*(up+dy*y+x));
			}
		}
	}else{					//horizontal
		for(int x=0;x<w;x++){
			int	yy=sin(M_PI*2*x/wl)*wh;
			for(int y=0;y<h;y++){
				if((y0+y+yy<canvas.top)||(y0+y+yy>canvas.bottom))continue;
				overlap(p+dy*(y+yy)+x,*(up+dy*y+x));
			}
		}
	}
	redraw(0x06);
}

void gproeview::fdct(short *mcu,short *dct)
{
	long	dd;
	short	d[8][8];
	for(int i=0;i<8;i++)for(int j=0;j<8;j++){
		dd=0;
		for(int k=0;k<8;k++){
			dd+=(long)mcu[i*8+k]*coeff[j][k];
			d[i][j]=(dd+2048)>>12;
		}
	}
	for(int i=0;i<8;i++)for(int j=0;j<8;j++){
		dd=0;
		for(int k=0;k<8;k++){
			dd+=(long)d[k][i]*coeff[j][k];
			dct[j*8+i]=(dd+16384)>>15;
		}
	}
}

void gproeview::idct(short *dct,short *mcu)
{
	long	dd;
	short	d[8][8];
	for(int i=0;i<8;i++)for(int j=0;j<8;j++){
		dd=0;
		for(int k=0;k<8;k++){
			dd+=(long)dct[k*8+i]*coeff[k][j];
			d[i][j]=(dd+2048)>>12;
		}
	}
	for(int i=0;i<8;i++)for(int j=0;j<8;j++){
		dd=0;
		for(int k=0;k<8;k++){
			dd+=(long)d[k][i]*coeff[k][j];
			mcu[i*8+j]=(dd+16384)>>15;
		}
	}
}
//------------------------------------------------
effectwindow::effectwindow(BRect frame,int efmode,BView *target):BWindow(frame,"gproe-effecter",B_TITLED_WINDOW,B_NOT_RESIZABLE|B_NOT_ZOOMABLE|B_NOT_MINIMIZABLE)
{
	tgt=target;
	BRect	viewframe;
	viewframe.Set(0,0,frame.Width(),frame.Height());
	viewframe.OffsetTo(0,0);
	ev=new effectview(viewframe,efmode,target);
	AddChild(ev);
	FrameResized(frame.Width(),frame.Height());
	Show();
}

bool effectwindow::QuitRequested()
{
	BMessage *mes=new BMessage('quit');
	mes->AddBool("cansel",false);
	BInvoker *inv=new BInvoker(mes,tgt);
	inv->Invoke();
	return true;
}
//------------------------------------------------
effectview::effectview(BRect frame,int efmode,BView *target):BView(frame,"effectview",B_FOLLOW_NONE,B_WILL_DRAW)
{
	tgt=target;
	mode=efmode;
	busy=false;	req=0;
	if(mode==1){	//color control(rgb)
		rv=new sliderview(BRect(0,40,200,55),"red",_T("red"),this,-100,100,r=0);
		AddChild(rv);rv->Show();
		gv=new sliderview(BRect(0,60,200,75),"green",_T("green"),this,-100,100,g=0);
		AddChild(gv);gv->Show();
		bv=new sliderview(BRect(0,80,200,95),"blue",_T("blue"),this,-100,100,b=0);
		AddChild(bv);bv->Show();
		yv=new sliderview(BRect(0,100,200,115),"y",_T("y"),this,-100,100,y=0);
		AddChild(yv);yv->Show();
		uv=new sliderview(BRect(0,120,200,135),"u",_T("u"),this,-100,100,u=0);
		AddChild(uv);uv->Show();
		vv=new sliderview(BRect(0,140,200,155),"v",_T("v"),this,-100,100,v=0);
		AddChild(vv);vv->Show();
	}
	if(mode==2){	//color control(lsh)
		lv=new sliderview(BRect(0,40,200,55),"lum",_T("lum"),this,-100,100,l=0);
		AddChild(lv);lv->Show();
		sv=new sliderview(BRect(0,70,200,85),"sat",_T("sat"),this,-100,100,s=0);
		AddChild(sv);sv->Show();
		hv=new sliderview(BRect(0,100,200,115),"hue",_T("hue"),this,-180,180,h=0);
		AddChild(hv);hv->Show();
	}
	if(mode==3){	//equalize
		dcv=new sliderview(BRect(0,40,200,55),"dc",_T("dc"),this,0,200,dc=100);
		AddChild(dcv);dcv->Show();
		alv=new sliderview(BRect(0,70,200,85),"ac-low",_T("ac-low"),this,0,200,al=100);
		AddChild(alv);alv->Show();
		ahv=new sliderview(BRect(0,100,200,115),"ac-high",_T("ac-high"),this,0,200,ah=100);
		AddChild(ahv);ahv->Show();
	}
	if(mode==4){	//waver
		wlv=new sliderview(BRect(0,40,200,55),"length",_T("length"),this,0,500,wl=0);
		AddChild(wlv);wlv->Show();
		whv=new sliderview(BRect(0,70,200,85),"height",_T("height"),this,-200,200,wh=0);
		AddChild(whv);whv->Show();
		BMessage	*mes;
		mes=new BMessage('Vchg');mes->AddBool("dir",false);
		wdb1=new BRadioButton(BRect(30,100,100,115),"dir_h",_T("vertical"),mes);
		wdb1->SetValue(1);
		AddChild(wdb1);wdb1->Show();
		mes=new BMessage('Vchg');mes->AddBool("dir",true);
		wdb2=new BRadioButton(BRect(100,100,170,115),"dir_v",_T("horizontal"),mes);
		AddChild(wdb2);wdb2->Show();
	}
	if(mode==5){	//contrast
		bbv=new sliderview(BRect(0,40,200,55),"boundary",_T("boundary"),this,0,255,bb=128);
		AddChild(bbv);bbv->Show();
		ctv=new sliderview(BRect(0,70,200,85),"contrast",_T("contrast"),this,-100,100,ct=0);
		AddChild(ctv);ctv->Show();
	}
	if(mode==6){	//monochrome
		rv=new sliderview(BRect(0,40,200,55),"m_red",_T("red"),this,0,255,mr=255);
		AddChild(rv);rv->Show();
		gv=new sliderview(BRect(0,60,200,75),"m_green",_T("green"),this,0,255,mg=255);
		AddChild(gv);gv->Show();
		bv=new sliderview(BRect(0,80,200,95),"m_blue",_T("blue"),this,0,255,mb=255);
		AddChild(bv);bv->Show();
	}
}

void effectview::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(220,220,220);
	SetLowColor(220,220,220);
	SetFont(be_plain_font);
	SetFontSize(18);
	if(mode==4){	//waver
		wdb1->SetTarget(this);
		wdb2->SetTarget(this);
	}
}

void effectview::Draw(BRect rect)
{
	SetHighColor(0,0,0);
	if(mode==1)DrawString(_T("Color controller(rgb)"),BPoint(20,20));
	if(mode==2)DrawString(_T("Color controller(lsh)"),BPoint(20,20));
	if(mode==3)DrawString(_T("Equalizer"),BPoint(20,20));
	if(mode==4)DrawString(_T("Waver"),BPoint(20,20));
	if(mode==5)DrawString(_T("Contrast controller"),BPoint(20,20));
	if(mode==6)DrawString(_T("Monochromer"),BPoint(20,20));
}

void effectview::MessageReceived(BMessage *msg)
{
//printf("efview mesrecv\n");
//msg->PrintToStream();
	switch(msg->what){
		case 'Vchg':{
			int		f=0;
			float	df;
			bool	db;
			if(!msg->FindFloat("red",&df)){r=df;f=1;}
			if(!msg->FindFloat("green",&df)){g=df;f=1;}
			if(!msg->FindFloat("blue",&df)){b=df;f=1;}
			if(!msg->FindFloat("y",&df)){y=df;f=2;}
			if(!msg->FindFloat("u",&df)){u=df;f=2;}
			if(!msg->FindFloat("v",&df)){v=df;f=2;}
			if(!msg->FindFloat("lum",&df)){l=df;f=3;}
			if(!msg->FindFloat("sat",&df)){s=df;f=3;}
			if(!msg->FindFloat("hue",&df)){h=df;f=3;}
			if(!msg->FindFloat("dc",&df)){dc=df;f=4;}
			if(!msg->FindFloat("ac-low",&df)){al=df;f=4;}
			if(!msg->FindFloat("ac-high",&df)){ah=df;f=4;}
			if(!msg->FindFloat("length",&df)){wl=df;f=5;}
			if(!msg->FindFloat("height",&df)){wh=df;f=5;}
			if(!msg->FindBool("dir",&db)){wd=db;f=5;}
			if(!msg->FindFloat("boundary",&df)){bb=df;f=6;}
			if(!msg->FindFloat("contrast",&df)){ct=df;f=6;}
			if(!msg->FindFloat("m_red",&df)){mr=df;f=7;}
			if(!msg->FindFloat("m_green",&df)){mg=df;f=7;}
			if(!msg->FindFloat("m_blue",&df)){mb=df;f=7;}
			if(f==1)chgrgb();
			if(f==2)chgyuv();
			if(f>0){req=mode;send();}
		}break;
		case 'okok':{
			busy=false;
			send();
		}
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void effectview::send()
{
	if((busy)||(req==0))return;
	busy=true;	req=0;
	BMessage *mes=new BMessage('Vchg');
	if(mode==1){
		mes->AddFloat("red",r);
		mes->AddFloat("green",g);
		mes->AddFloat("blue",b);
	}
	if(mode==2){
		mes->AddFloat("lum",l);
		mes->AddFloat("sat",s);
		mes->AddFloat("hue",h);
	}
	if(mode==3){
		mes->AddFloat("dc",dc);
		mes->AddFloat("ac-low",al);
		mes->AddFloat("ac-high",ah);
	}
	if(mode==4){
		mes->AddFloat("length",wl);
		mes->AddFloat("height",wh);
		mes->AddBool("dir",wd);
	}
	if(mode==5){
		mes->AddFloat("boundary",bb);
		mes->AddFloat("contrast",ct);
	}
	if(mode==6){
		mes->AddFloat("m_red",mr);
		mes->AddFloat("m_green",mg);
		mes->AddFloat("m_blue",mb);
	}
	BInvoker *inv=new BInvoker(mes,tgt);
	inv->SetHandlerForReply(this);
	inv->Invoke();							//to gproeview
}

void effectview::chgrgb()
{
	y=r*0.2990+g*0.5870+b*0.1140;
	u=-r*0.1684-g*0.3316+b*.5000;
	v=r*0.5000-g*0.5000-b*0.0813;
	yv->SetValue(y);
	uv->SetValue(u);
	vv->SetValue(v);
}

void effectview::chgyuv()
{
	r=y+v*1.4020;
	g=y-u*0.3441-v*0.7139;
	b=y+u*1.7718-v*0.0012;
	rv->SetValue(r);
	gv->SetValue(g);
	bv->SetValue(b);
}
