// gproe.cpp		ver.0.053
//copyright 1998-2004 Beer[Tsutsumi Hiroyuki]

#include	<Be.h>
#if	B_BEOS_VERSION>=0x0520
#include	<Locale.h>
typedef	const char	Char;
#else
#define	_T(str)	str
typedef	char		Char;
#endif
#include	"slider.h"

union BGRA{				//bgra
	uint32	c;
	struct	{uchar	b,g,r,a;}u;
};

typedef struct{
		char	type;			//0..none  1..rect  2..ellipse
		BRect	rect;
}s_sel;

typedef struct{
		uint32	*bm;			//null=no data
		BRect	rect;
}s_undo;

class effectview:public BView
{
	public:
		effectview(BRect frame,int efmode,BView *target);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	MessageReceived(BMessage *msg);
		void	send();
		void	chgrgb();
		void	chgyuv();
	private:
		BView	*tgt;
		int		mode;
		sliderview	*rv,*gv,*bv,*yv,*uv,*vv;
		sliderview	*lv,*sv,*hv;
		sliderview	*dcv,*alv,*ahv;
		sliderview	*bbv,*ctv;
		sliderview	*wlv,*whv;
		BRadioButton	*wdb1,*wdb2;
		float	r,g,b,y,u,v;
		float	l,s,h;
		float	mr,mg,mb;
		float	dc,al,ah;
		float	bb,ct;
		float	wl,wh;
		bool	wd;
		bool	busy;
		uchar	req;		//0.none  1-4.next send data
};

class effectwindow:public BWindow
{
	public:
		effectwindow(BRect frame,int efmode,BView *target);
		bool	QuitRequested();
	private:
		BView	*tgt;			//=gproeview
		effectview	*ev;
};

class gproeview:public BView
{
	public:
		gproeview(BRect frame);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	MouseDown(BPoint pt);
		void	MouseUp(BPoint pt);
		void	MouseMoved(BPoint pt, uint32 code, const BMessage *msg);
		void	MessageReceived(BMessage *msg);
		BMessage*	ddmessage();		//for drag&drop
		void	ddcopy(BMessage *msg);	//for drag&drop
		void	select_trans(const char *mime,translator_id *tid,uint32 *fmt);
		void	redraw(uchar f=0xff);	//b0.bitmap(frame),b1.bitmap(canvas),b2.drawframe,b3.eraseframe
		void	drawframe(s_sel fr);
		void	init();
		void	load(entry_ref &eref);
		void	save(entry_ref &dir,char *name);
		void	setoverlap();
		void	overlap(uint32 *p,uint32 d);
		void	setundo(BRect r);
		void	undo();
		void	reverse(char rgb);
		void	mirror(int deg);
		void	rotate(int deg);
		void	mediumfilter();
		void	contrast(float bbrt,float cntr);
		void	rgbcontrol(float red,float green,float blue);
		void	lshcontrol(float lum,float sat,float hue);
		void	monochrome(float red,float green,float blue);
		void	equalize(float dc,float al,float ah);
		void	wave(float wl,float wh,bool wd);
		void	fdct(short *mcu,short *dct);
		void	idct(short *dct,short *mcu);
	private:
		BBitmap		*bm,*bmdd;	//canvas,drag&drop
		BFilePanel	*fp;
		s_undo		un;
		s_sel		sel_old,sel_now;
		int16		xfno;
		char		title[256],mime[256];
		bool		mdf;		//mouse_button  t..down  f..up
		char		mode;			//0..none  1..rect  2..ellipse
		int			olmode;			//0..overwrite  1..translucence  2..gradation
		short		grmode;			//-1..center  0-360..gradation
		uint32		chrom;			//chromakey color
		bool		efwin;
};

class gproewindow:public BWindow
{
	public:
		gproewindow(BRect frame);
		bool	QuitRequested();
		void	Zoom(BPoint rec_position,float rec_width,float rec_height);
		void	FrameResized(float width,float height);
		void	setupmenus();
		void	markmenu(const char *name,const char *item);
		void	get_translator_for_output();
		BMenuBar	*mb;
		gproeview	*v;
		BScrollBar	*sbv,*sbh;
};

class gproe:public BApplication
{
	public:
		gproe();
		void	RefsReceived(BMessage *mes);
		void	MessageReceived(BMessage *mes);
		void	AboutRequested();
		gproewindow	*w;
};

static const uchar zigzag[64]={
	 0, 1, 5, 6,14,15,27,28,
	 2, 4, 7,13,16,26,29,42,
	 3, 8,12,17,25,30,41,43,
	 9,11,18,24,31,40,44,53,
	10,19,23,32,39,45,52,54,
	20,22,33,38,46,51,55,60,
	21,34,37,47,50,56,59,61,
	35,36,48,49,57,58,62,63
};

static const short coeff[8][8]={
	{	4096, 4096, 4096, 4096, 4096, 4096, 4096, 4096	},
	{	5681, 4816, 3218, 1130,-1130,-3218,-4816,-5681	},
	{	5352, 2217,-2217,-5352,-5352,-2217, 2217, 5352	},
	{	4816,-1130,-5681,-3218, 3218, 5681, 1130,-4816	},
	{	4096,-4096,-4096, 4096, 4096,-4096,-4096, 4096	},
	{	3218,-5681, 1130, 4816,-4816,-1130, 5681,-3218	},
	{	2217,-5352, 5352,-2217,-2217, 5352,-5352, 2217	},
	{	1130,-3218, 4816,-5681, 5681,-4816, 3218,-1130	},
};

BRect 				canvas;
BTranslatorRoster	*tr;
int32				trc=0;
BList				xlt;

struct xlator{
	translator_id		id;
	uint32				type;
	char				name[251];
	char				mime[251];
};
