// slider.cpp
//copyright 1998-2005 Beer[Tsutsumi Hiroyuki]

#include	"slider.h"

sliderview::sliderview(BRect frame,const char *name,const char *label,BView *target,float min,float max,float val):BView(frame,name,B_FOLLOW_NONE,B_WILL_DRAW)
{
	fMin=min;	fMax=max;	fValue=val;
	cLabel=label;
	vTarget=target;
	rBar.Set(frame.Width()*.25,0/*frame.top*/,frame.Width()*.75,frame.Height()/*frame.bottom*/);
	setslider();
	drag=false;
	lastval=fValue;
}

void sliderview::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(220,220,220);
	SetLowColor(220,220,220);
	SetFont(be_plain_font);
	SetFontSize(rBar.Height()*.7);
	pLabel.Set(rBar.left-StringWidth(cLabel)-3,rBar.Height()*.8);
	pValue.Set(rBar.right+3,rBar.Height()*.8);
}

void sliderview::Draw(BRect rect)
{
	SetHighColor(0,0,0);
	DrawString(cLabel,pLabel);
	char s[16];sprintf(s,"%d",(int)fValue);
	DrawString(s,pValue);
	SetHighColor(180,180,180);
	FillRect(rBar);
	SetHighColor(220,220,220);
	FillRect(rSlider);
}

void sliderview::MouseDown(BPoint pt)
{
	if(rBar.Contains(pt)){
		drag=true;
		slidermoved(pt.x);
	}
}

void sliderview::MouseUp(BPoint pt)
{
	drag=false;
}

void sliderview::MouseMoved(BPoint pt, uint32 code, const BMessage *msg)
{
	uint32	buttons;
	GetMouse(&pt,&buttons);
	if(drag&&(buttons&B_PRIMARY_MOUSE_BUTTON)){
		slidermoved(pt.x);
	}
}

void sliderview::SetValue(float value)
{
	fValue=(value<fMin)?fMin:(value>fMax)?fMax:value;
	setslider();
	Invalidate();
}

float sliderview::Value()
{
	return(fValue);
}

void sliderview::setslider()
{
	float size=rBar.Height()-2;
	rSlider.left=(rBar.Width()-size-2)*(fValue-fMin)/(fMax-fMin)+rBar.left+1;
	rSlider.right=rSlider.left+size;
	rSlider.top=rBar.top+1;
	rSlider.bottom=rBar.bottom-1;
}

void sliderview::slidermoved(int center)
{
	float size=rSlider.Width();
	float val=(center-size/2-rBar.left-1)/(rBar.Width()-size-2)*(fMax-fMin)+fMin;
	SetValue(val);
	if(fValue!=lastval){
		BMessage mes('Vchg');
		mes.AddFloat(Name(),fValue);
		BMessenger(vTarget).SendMessage(&mes);	//Window()->PostMessage(&mes,vTarget);
		lastval=fValue;
	}
}
