// gprop.cpp		ver.0.041
//copyright 2004 Beer[Tsutsumi Hiroyuki]

#include	"gprop.h"

#define	VER		"ver.0.041"
#define	DATE	"2004. 7.11"

int	main()
{
	if(!(tr=BTranslatorRoster::Default()))return(1);
	gprop	app;
	app.Run();
	return(0);
}
//------------------------------------------------
gprop::gprop():BApplication("application/x-vnd.Beer-gprop")
{
	app_info	ai;	be_app->GetAppInfo(&ai);
	BPath	ap(&ai.ref),dp;
	ap.GetParent(&dp);
	stpdir=dp;
	stpdir.Append("stamp");
#if	B_BEOS_VERSION>=0x0520
	BPath	lp(dp);
	lp.Append("Language/Dictionaries");
	lp.Append("gpro");
	be_locale.LoadLanguageFile(lp.Path());
#endif

	vcanvas.Set(0,0,0,0);
	BRect	frame;
	frame.Set(100,100,499,399);
	w=new gpropwindow(frame);
}

void gprop::RefsReceived(BMessage *mes)
{
	uint32	type;
	int32	files;
	mes->GetInfo("refs",&type,&files);
	if(files>0){
		entry_ref	eref;
		BMessage msg(B_SIMPLE_DATA);
		for(int i=0;i<files;i++){
			mes->FindRef("refs",i,&eref);
			msg.AddRef("refs",&eref);
		}
		BMessenger(w->v).SendMessage(&msg);		//w->PostMessage(&msg,w->v);
	}
}

void gprop::MessageReceived(BMessage *mes)
{
	switch(mes->what){
		case B_SAVE_REQUESTED:{
			entry_ref	dir;
			const char		*name;
			mes->FindRef("directory",&dir);
			mes->FindString("name",&name);
			BMessage msg(B_SAVE_REQUESTED);
			msg.AddRef("directory",&dir);
			msg.AddString("name",name);
			BMessenger(w->v).SendMessage(&msg);		//w->PostMessage(&msg,w->v);
		}break;
		case B_CANCEL:{
			BMessenger(w->v).SendMessage(B_CANCEL);	//w->PostMessage(B_CANCEL,w->v);
		}break;
		default:{
			BApplication::MessageReceived(mes);
		}break;
	}
}

void gprop::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"Gprop "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.wht.mmtr.or.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
} 
//------------------------------------------------
gpropwindow::gpropwindow(BRect frame):BWindow(frame,"gprop "VER,B_DOCUMENT_WINDOW,0)
{
	get_translator_for_output();
/*
	BScreen	bs;
	screen_width=bs.Frame().IntegerWidth()+1;
	screen_height=bs.Frame().IntegerHeight()+1;
*/
	inp.flags=0;

	mb=NULL;
	BRect	viewframe,sbvframe,sbhframe,selectframe,toolframe;

	selectframe.Set(0,0,399,32);
	selectframe.OffsetTo(0,20);				//menu=20
	sv=new selectview(selectframe);
	AddChild(sv);
	toolframe.Set(0,0,20,299-20-33);
	toolframe.OffsetTo(0,20+33);			//menu=20
	tv=new toolview(toolframe);
	AddChild(tv);

	viewframe.Set(0,0,frame.Width()-B_V_SCROLL_BAR_WIDTH-21,frame.Height()-B_H_SCROLL_BAR_HEIGHT-20-33);
	viewframe.OffsetTo(toolframe.right+1,selectframe.bottom+1);
	v=new gpropview(viewframe);
	AddChild(v);
	setupmenus();
	sbvframe.Set(0,0,B_V_SCROLL_BAR_WIDTH,viewframe.Height()+1);//
	sbvframe.OffsetTo(viewframe.right+1,viewframe.top);
	sbv=new BScrollBar(sbvframe,"scrollv",(BView*)v,0,0,B_VERTICAL);
	AddChild(sbv);
	sbhframe.Set(0,0,viewframe.Width()+1,B_H_SCROLL_BAR_HEIGHT);//
	sbhframe.OffsetTo(viewframe.left,viewframe.bottom+1);
	sbh=new BScrollBar(sbhframe,"scrollh",(BView*)v,0,0,B_HORIZONTAL);
	AddChild(sbh);
	FrameResized(frame.Width(),frame.Height());
	Show();
	SetPulseRate(100000);
}

bool gpropwindow::QuitRequested()
{
	xlator	*xl;
	for(int i=0;xl=(xlator*)xlt.ItemAt(i);i++)delete xl;
	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);//be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void gpropwindow::Zoom(BPoint rec_position,float rec_width,float rec_height)
{
	int	w,h;
 	w=vcanvas.IntegerWidth()+1+20+(int)B_V_SCROLL_BAR_WIDTH;			//+toolview+scrollbar
 	h=vcanvas.IntegerHeight()+1+20+32+(int)B_H_SCROLL_BAR_HEIGHT;	//+menu+selectview+scrollbar
 	if(w<400)w=399;
 	if(h<300)h=299;
 	SetSizeLimits(399,w,299,h);
 	if((Bounds().IntegerWidth()==w)&&(Bounds().IntegerHeight()==h)){w=399;h=299;}
	ResizeTo(w,h);
}

void gpropwindow::FrameResized(float width,float height)
{
	float	rv,rh;
	rv=vcanvas.Height()-sbv->Bounds().Height()+1;
	rh=vcanvas.Width()-sbh->Bounds().Width()+1;
	sbv->SetRange(0,rv>0?rv:0);
	sbh->SetRange(0,rh>0?rh:0);
	sbv->SetProportion(sbv->Bounds().Height()/vcanvas.Height());
	sbh->SetProportion(sbh->Bounds().Width()/vcanvas.Width());
	sbv->SetSteps(5,sbv->Bounds().Height());
	sbh->SetSteps(5,sbh->Bounds().Width());

	tv->ResizeTo(tv->Bounds().Width(),height);
	sv->ResizeTo(width,sv->Bounds().Height());
}

void gpropwindow::DispatchMessage(BMessage *msg,BHandler *handler)
{
//	static int32	mask=0;
	while(1){
		if(handler!=v)break;
		if((msg->what!=B_MOUSE_DOWN)&&(msg->what!=B_MOUSE_UP)&&(msg->what!=B_MOUSE_MOVED))break;
		float	f1,f2;
		int32	l;
		int64	ll;
		BPoint	p;
		if(!msg->FindInt32("be:cursor_needed",&l))break;	//anti-noise
		if(!msg->FindInt32("_msg_what_",&l))break;			//drag-now
//msg->PrintToStream();
		inp.flags=0;
		if((!msg->FindFloat("be:tablet_x",&f1))&&(!msg->FindFloat("be:tablet_y",&f2))){inp.x=f1;inp.y=f2;inp.flags|=TABLET_XY;}
		if((!msg->FindFloat("be:tablet_tilt_x",&f1))&&(!msg->FindFloat("be:tablet_tilt_y",&f2))){inp.tilt_x=f1;inp.tilt_y=f2;inp.flags|=TABLET_TILT_XY;}
		if(!msg->FindFloat("be:tablet_pressure",&f1)){inp.pressure=f1;inp.flags|=TABLET_PRESSURE;}
		if(!msg->FindInt32("be:tablet_eraser",&l)){inp.eraser=l;inp.flags|=TABLET_ERASER;}
		if(!msg->FindInt32("modifiers",&l)){inp.modifiers=l;inp.flags|=MODIFIERS;}
		if(!msg->FindInt32("buttons",&l)){inp.buttons=l;inp.flags|=BUTTONS;}
		if(!msg->FindInt64("when",&ll)){inp.when=ll;inp.flags|=WHEN;}
		if(!msg->FindPoint("be:view_where",&p)){inp.where=p;inp.flags|=WHERE;}
//		if(!msg->FindPoint("where",&p)){inp.where=p;inp.flags|=WHERE;}
//		if(!msg->FindPoint("screen_where",&p)){inp.where=p;inp.flags|=WHERE;}//zeta only
		if(!msg->FindInt32("be:transit",&l)){inp.transit=l;inp.flags|=TRANSIT;}
//		if(inp.flags&TRANSIT){
//			if(l==0){mask=inp.buttons;inp.buttons=0;}
//			if(l==1){if(inp.buttons&mask)inp.buttons=0;else mask=0;}
//			if(l!=1){inp.buttons=0;inp.flags|=BUTTONS;}
//if((l==0)||(l==2))printf("transit=%d (%d,%d)\n",l,(int)inp.where.x,(int)inp.where.y);
//		}
//printf("dispat:flag=%02x\n",inp.flags);
		break;
	}
	BWindow::DispatchMessage(msg,handler);
}

BMenu* gpropwindow::setupfonts()
{
	font	ftd;
	be_plain_font->GetFamilyAndStyle(&ftd.fam,&ftd.sty);

	font_family	fontf;
	font_style	fonts;
	BMenu	*m=new BMenu(_T("Font"));	//font family-style
	int	no=0;
	int fc=count_font_families();
	for(int i=0;i<fc;i++){
		get_font_family(i,&fontf);
		int sc=count_font_styles(fontf);
		for(int j=0;j<sc;j++){
			get_font_style(fontf,j,&fonts);
			char	s[130];
			sprintf(s,"%s(%s)",fontf,fonts);
			BMessage	*mes=new BMessage('Vchg');
			mes->AddString("fon_fam",fontf);
			mes->AddString("fon_sty",fonts);
			BMenuItem	*mi=new BMenuItem(s,mes);
			mi->SetTarget((BHandler*)v);
			if((!strcmp(ftd.fam,fontf))&&(!strcmp(ftd.sty,fonts)))mi->SetMarked(true);
			m->AddItem(mi);
			no++;
		}
	}
	m->SetRadioMode(true);
	return(m);
}

void gpropwindow::setupmenus()
{
//	BMenuBar	*mb;
	BMenu		*m,*mm;
	BMenuItem	*mi;
	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mm=new BMenu(_T("New"));
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,127,127));
	  mi=new BMenuItem("128x128",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,255,255));
	  mi=new BMenuItem("256x256",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,399,299));
	  mi=new BMenuItem("400x300",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,639,479));
	  mi=new BMenuItem("640x480",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	  mes=new BMessage('fine');mes->AddRect("bounds",BRect(0,0,799,599));
	  mi=new BMenuItem("800x600",mes);
	  mi->SetTarget((BHandler*)v);
	  mm->AddItem(mi);
	 m->AddItem(mm);
	 mi=new BMenuItem(_T("Open"),new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mm=new BMenu(_T("Save as"));
		for(int i=0;i<trc;i++){
			mes=new BMessage('fiwr');
			mes->AddInt16("format_no",i);
			mi=new BMenuItem(((xlator*)xlt.ItemAt(i))->name,mes);
			mi->SetTarget((BHandler*)v);
			mm->AddItem(mi);
		}
	 m->AddItem(mm);
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);

	m=new BMenu(_T("Edit"));
	 mi=new BMenuItem(_T("Memory"),new BMessage('edme'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Undo"),new BMessage('edun'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Clear"),new BMessage('edcl'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	mb->AddItem(m);

	m=setupfonts();
	mb->AddItem(m);

	m=new BMenu(_T("Stamp"));
	 BDirectory	dd(stpdir.Path());
	 int32	dce=dd.CountEntries();
	 BEntry	de;
	 struct stat	dst;
	 char	dn[256],dnb[256];
	 dnb[0]=0;
	 for(int i=0;i<dce;i++){
		dd.GetNextEntry(&de);
		de.GetStat(&dst);
		if(dst.st_mode&S_IFDIR)continue;
		de.GetName(dn);
		if(dn[strlen(dn)-2]!='.')continue;
		int	n=dn[strlen(dn)-1]-'0';
		if((n<1)||(n>3))continue;
		dn[strlen(dn)-2]=0;
		if(!strcmp(dn,dnb))continue;
		strcpy(dnb,dn);
	 	mes=new BMessage('Vchg');mes->AddString("stp",dn);
	 	mi=new BMenuItem(dn,mes);
	 	mi->SetTarget((BHandler*)v);
	 	m->AddItem(mi);
	 }
	 m->AddSeparatorItem();
	  mes=new BMessage('Vchg');mes->AddString("stp","");
	  mi=new BMenuItem("default",mes);
	  mi->SetTarget((BHandler*)v);
	  mi->SetMarked(true);
	  m->AddItem(mi);
	 m->SetRadioMode(true);
	mb->AddItem(m);

	static int	sc[]={
		50,75,100,125,150,200,250,300,400,	0
	};
	m=new BMenu(_T("Scale"));
	 for(int i=0;sc[i];i++){
	 	mes=new BMessage('Vchg');mes->AddFloat("scale",(float)sc[i]/100);
	 	char	s[8];
	 	sprintf(s,"%3d%%",sc[i]);
	 	mi=new BMenuItem(s,mes);
	 	mi->SetTarget((BHandler*)v);
	 	if(sc[i]==100)mi->SetMarked(true);
	 	m->AddItem(mi);
	 }
	 m->SetRadioMode(true);
	mb->AddItem(m);

	AddChild(mb);
}

void gpropwindow::markmenu(const char *menu,const char *item)
{
	if(mb==NULL)return;
	int	c=mb->CountItems();
	for(int i=0;i<c;i++){
		BMenu	*m=mb->SubmenuAt(i);
		if(strcmp(m->Name(),menu))continue;
		int	ic=m->CountItems();
		for(int j=0;j<ic;j++){
			BMenuItem	*mi=m->ItemAt(j);
			if(strcmp(mi->Label(),item))continue;
//printf("found: [%s]-[%s]\n",m->Name(),mi->Label());
			mi->SetMarked(true);
		}
	}
}

void gpropwindow::get_translator_for_output()
{
	BBitmap 			*tbm=new BBitmap(BRect(0,0,7,7),B_RGB_32_BIT);
	BBitmapStream		*instrm=new BBitmapStream(tbm);
	translator_info		*inf;
	const translation_format	*frm;
	int32				infs,frms;
	tr->GetTranslators(instrm,NULL,&inf,&infs);
	for(int i=0;i<infs;i++){
		tr->GetOutputFormats(inf[i].translator,&frm,&frms);
		for(int j=0;j<frms;j++){
//printf("%c%c%c%c %4.2f %4.2f\n",frm[j].type>>24,frm[j].type>>16,frm[j].type>>8,frm[j].type,frm[j].quality,frm[j].capability);
			if(frm[j].type=='bits')continue;		//standard bitmap
			if(frm[j].type=='mhi!')continue;		//progressive bitmap
			xlator	*xl=new xlator;
			xl->type=frm[j].type;
			xl->id=inf[i].translator;
			strcpy(xl->name,frm[j].name);
			strcpy(xl->mime,frm[j].MIME);
			if(frm[j].type=='TGA ')xlt.AddItem((void*)xl,0);else xlt.AddItem((void*)xl);
			trc++;
		}
	}
	delete inf;
}
//------------------------------------------------
toolview::toolview(BRect frame):BView(frame,"tools",B_FOLLOW_NONE,B_WILL_DRAW)
{
	bm=NULL;
	mode=FREE;
}

toolview::~toolview()
{
	if(bm)delete bm;
}

void toolview::AttachedToWindow()
{
	SetLowColor(200,200,0);
	SetViewColor((uchar)(TOOLVIEWCOLOR>>16),(uchar)(TOOLVIEWCOLOR>>8),(uchar)TOOLVIEWCOLOR);
	SetFont(be_plain_font);
	SetFontSize(10);
	if(!bm)bm=new BBitmap(Bounds(),B_RGB_32_BIT);
	redraw();
}

void toolview::Draw(BRect rect)
{
	SetHighColor(0,0,0);
	DrawBitmap(bm,BPoint(0,0));
}

void toolview::MouseDown(BPoint pt)
{
	char	m=0;
	if((pt.x<2)||(pt.x>18))return;
	if((pt.y>=2)&&(pt.y<=18))m=FREE;
	if((pt.y>=20)&&(pt.y<=36))m=SAND;
	if((pt.y>=38)&&(pt.y<=54))m=SPRAY;
	if((pt.y>=56)&&(pt.y<=72))m=RECT;
	if((pt.y>=74)&&(pt.y<=90))m=ELLIPSE;
	if((pt.y>=92)&&(pt.y<=108))m=LINE;
	if((pt.y>=110)&&(pt.y<=126))m=POLY;
	if((pt.y>=128)&&(pt.y<=144))m=PAINT;
	if((pt.y>=144)&&(pt.y<=162))m=STAMP;
	if((pt.y>=162)&&(pt.y<=180))m=EXT;
	if(m){
		BMessage *mes=new BMessage('tool');
		mes->AddInt8("mode",m);
		BMessenger(((gpropwindow*)Window())->v).SendMessage(mes);//Window()->PostMessage(mes,((gpropwindow*)Window())->v);
	}
}

void toolview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'Vchg':{
			int8	d;
			if(!msg->FindInt8("mode",&d))mode=d;
			redraw();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void toolview::redraw()
{
	static const uchar	tools[]={
		FREE,SAND,SPRAY,RECT,ELLIPSE,LINE,POLY,PAINT,STAMP,EXT,0
	};
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*pp=p;
	int		l=bm->BitsLength()/4;
	while(l--)*(pp++)=B_HOST_TO_LENDIAN_INT32(TOOLVIEWCOLOR);
	for(int i=0;tools[i];i++){
		uint32	fc,bc;
		if(mode==tools[i]){fc=0xffffffff;bc=0x00000000;}else{fc=0x00000000;bc=0xffffffff;}
		int	x=2;
		int	y=i*18+2;
		for(int yy=0;yy<16;yy++)for(int xx=0;xx<16;xx++){
			*(p+(y+yy)*dy+(x+xx))=(iconpat[i][yy]&(0x8000>>xx))?fc:bc;
		}
	}
	Draw(Bounds());
}
//------------------------------------------------
selectview::selectview(BRect frame):BView(frame,"selector",B_FOLLOW_NONE,B_WILL_DRAW)
{
	bm=NULL;
	now.fc=0xffffffff;	now.bc=0xff000000;
	now.fos=20;		now.pen=0;
	sf=0x00;	//00.fc  01.bc
}

selectview::~selectview()
{
	if(bm)delete bm;
}

void selectview::AttachedToWindow()
{
	SetLowColor(200,200,0);
	SetViewColor((uchar)(SELECTVIEWCOLOR>>16),(uchar)(SELECTVIEWCOLOR>>8),(uchar)SELECTVIEWCOLOR);
	SetFont(be_plain_font);
	SetFontSize(10);
	if(!bm)bm=new BBitmap(Bounds(),B_RGB_32_BIT);
	redraw();
}

void selectview::Draw(BRect rect)
{
	SetHighColor(0,0,0);
	DrawBitmap(bm,BPoint(0,0));
	DrawString("Pen",BPoint(175,12));
	DrawString("Eraser",BPoint(175,28));
	char	s[32];
	sprintf(s,"font : %2d",now.fos);
	DrawString(s,BPoint(342,12));
	sprintf(s,"pen  : %2d",now.pen);
	DrawString(s,BPoint(342,28));
}

void selectview::MouseDown(BPoint pt)
{
	if(pt.x<128){			//color
		int d=(int)(pt.y/8)*16+(int)(pt.x/8);
		if(d<64){
			BMessage *mes=new BMessage('Vchg');
			if(sf&0x01){now.bc=pal[d];mes->AddInt32("bc",now.bc);}
			else{now.fc=pal[d];mes->AddInt32("fc",now.fc);}
			BMessenger(((gpropwindow*)Window())->v).SendMessage(mes);//Window()->PostMessage(mes,((gpropwindow*)Window())->v);
			redraw();
		}
	}else if(pt.x<160){		//now color
		if(pt.y<16)sf&=0xfe;
		else sf|=0x01;
		redraw();
	}else{					//fontsize,pensize
		BMessage *mes=new BMessage('Vchg');
		if(pt.y<16){	//font
			int	d=now.fos;
			d=(pt.x<365)?d-2:d+2;
			if((d>=8)&&(d<=80))now.fos=d;
			mes->AddInt16("fos",now.fos);
		}else{			//pen
			int	d=now.pen;
			d=(pt.x<365)?d-1:d+1;
			if((d>=0)&&(d<=30))now.pen=d;
			mes->AddInt16("pen",now.pen);
		}
		BMessenger(((gpropwindow*)Window())->v).SendMessage(mes);//Window()->PostMessage(mes,((gpropwindow*)Window())->v);
		redraw();
	}
}

void selectview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case B_PASTE:{
			rgb_color	*c;
			ssize_t		l;
			msg->FindData("RGBColor",B_RGB_COLOR_TYPE,(const void **)&c,&l);
			BMessage *mes=new BMessage('Vchg');
			if(sf&0x01){
				now.bc=(c->alpha<<24)|(c->red<<16)|(c->green<<8)|(c->blue);
				mes->AddInt32("bc",now.bc);
			}else{
				now.fc=(c->alpha<<24)|(c->red<<16)|(c->green<<8)|(c->blue);
				mes->AddInt32("fc",now.fc);
			}
			BMessenger(((gpropwindow*)Window())->v).SendMessage(mes);//Window()->PostMessage(mes,((gpropwindow*)Window())->v);
			redraw();
		}break;
		case 'Vchg':{
			int32	l;
			int16	d;
			if(!msg->FindInt32("fc",&l))now.fc=l;
			if(!msg->FindInt32("bc",&l))now.bc=l;
			if(!msg->FindInt16("fos",&d))now.fos=d;
			if(!msg->FindInt16("pen",&d))now.pen=d;
			redraw();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void selectview::redraw()
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*pp=p;
	int		l=bm->BitsLength()/4;
	while(l--)*(pp++)=B_HOST_TO_LENDIAN_INT32(SELECTVIEWCOLOR);
	int	x,y;
	for(int i=0;i<64;i++){		//color
		uint32	c=pal[i];
		x=(i&0x0f)*8;
		y=(i&0xf0)/2;
		if(c&0xff000000)for(int yy=y+(~c>>29);yy<y+8;yy++){
			for(int xx=x;xx<x+8;xx++)*(p+yy*dy+xx)=B_HOST_TO_LENDIAN_INT32(c);
		}
	}
	for(int i=0;i<2;i++){		//now-color
		uint32	c=(i==0)?now.fc:now.bc;
		x=144;
		y=i*16;
		if(c&0xff000000)for(int yy=y+(~c>>28);yy<y+16;yy++){
			for(int xx=x;xx<x+16;xx++)*(p+yy*dy+xx)=B_HOST_TO_LENDIAN_INT32(c);
		}
	}

	uint32	tc=B_HOST_TO_LENDIAN_INT32(0xcc0000);
	x=164;
	y=(sf&1)?20:4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[2][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=330;
	y=4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[1][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=330;
	y=20;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[1][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=388;
	y=4;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[0][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=388;
	y=20;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[0][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}

	Draw(Bounds());
}

void selectview::set(s_mode s)
{
	redraw();
}
//------------------------------------------------
gpropview::gpropview(BRect frame):BView(frame,"canvas",B_FOLLOW_ALL_SIDES,B_WILL_DRAW|B_PULSE_NEEDED)
{
	canvas=BRect(0,0,0,0);
	vv=NULL;		//no bitmap for draw
	bm=NULL;		//no canvas
	bmm=NULL;		//no undo_bitmap
	bmdd=NULL;		//no drag&drop
	for(int i=0;i<4;i++)stbm[i]=NULL;	//no stamp
	fp=NULL;		//file-panel
	xfno=0;

	mdf=false;	mcf=true;

	sel_now.f=0;
	selm=0;
	strcpy(title,"gprop "VER);
}

gpropview::~gpropview()
{
	if(bm)delete bm;
	if(bmm)delete bmm;
	if(bmdd)delete bmdd;
	for(int i=0;i<4;i++)if(stbm[i])delete stbm[i];
}

void gpropview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(50,50,50);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);
	MakeFocus();
	Window()->Zoom();
	init();
}

void gpropview::Draw(BRect rect)
{
	if(bm){
		ConstrainClippingRegion(&BRegion(rect&vcanvas));
		BRect	br=bm->Bounds();
		BRect	vr(0,0,br.right*scale,br.bottom*scale);
		DrawBitmap(bm,br,vr);
		if(obj)obj->drawframe(this,scale);
		if(sel_now.f)drawframe(sel_now.rect);
		ConstrainClippingRegion(&BRegion(vcanvas));		//need !!
	}else{
		SetFontSize(30);
		DrawString("Gprop",BPoint(45,50));
		SetFontSize(20);
		DrawString(VER,BPoint(75,80));
	}
}

void gpropview::Pulse()
{
	if((now.mode!=SAND)&&(now.mode!=SPRAY))return;

	static input	inp_n;	//now input
	static BPoint	pt_n;	//now point(view)
	static uchar	bt_n;	//now button

	inp_n=((gpropwindow*)Window())->inp;
	pt_n=inp_n.where;
	pt_n=BPoint((int)(pt_n.x/scale),(int)(pt_n.y/scale));
	bt_n=(uchar)inp_n.buttons;
	if(bt_n==B_PRIMARY_MOUSE_BUTTON){
		if(inp_n.modifiers&B_SHIFT_KEY)bt_n=B_SECONDARY_MOUSE_BUTTON;
		if(inp_n.modifiers&B_CONTROL_KEY)bt_n=B_TERTIARY_MOUSE_BUTTON;
	}

	if(bm)if(bt_n)ptr_move(pt_n,bt_n,inp_n);
}

void gpropview::MouseDown(BPoint pt)
{
	chkinput();
}
void gpropview::MouseUp(BPoint pt)
{
	chkinput();
}
void gpropview::MouseMoved(BPoint pt,uint32 code,const BMessage *msg)
{
#if	B_BEOS_VERSION>=0x0520
	static bigtime_t	systime_b,when_b;
	bigtime_t	systime_n=system_time();
	bigtime_t	when_n=((gpropwindow*)Window())->inp.when;
	if(when_n==when_b){
		when_n+=systime_n-systime_b;
		((gpropwindow*)Window())->inp.when=when_n;
	}
	systime_b=systime_n;
	when_b=when_n;
#endif
	chkinput();
}

void gpropview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	static BPoint	dp;
	BPoint	dr_pt,dr_off;
	if((!msg->FindPoint("_drop_point_",&dr_pt))&&(!msg->FindPoint("_drop_offset_",&dr_off))){
		ConvertFromScreen(&dr_pt);
		dr_pt=BPoint(dr_pt.x/scale,dr_pt.y/scale);
		float	sc;
		if(!msg->FindFloat("scale",&sc))dr_off=BPoint(dr_off.x/sc,dr_off.y/sc);
//printf("%d %d %d %d\n",(int)dr_pt.x,(int)dr_pt.y,(int)dr_off.x,(int)dr_off.y);
		dp=dr_pt-dr_off;
	}

	switch(msg->what){
		case B_COPY_TARGET:{	//drop(to external)
			ddcopy(msg);
		}break;
		case B_SIMPLE_DATA:{	//'DATA'(drop from external)
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){		//file
				for(int i=0;i<files;i++){
					entry_ref	eref;
					msg->FindRef("refs",i,&eref);
					load(eref);
					if(bm)break;
				}
				break;
			}
			const char	*name;
			if(!msg->FindString("be:clip_name",&name)){	//image
				BMessage	mes(B_COPY_TARGET);
				int32	idx=0;
				const char	*mime;
				while(!msg->FindString("be:types",idx++,&mime)){
					if(!strncmp(mime,"image",5)){
						mes.AddString("be:types",mime);
    					msg->SendReply(&mes,this);
						break;
					}
				}
				break;
			}
		}	//not break;
		case 'MIME':{
			Char 	*mime;
			type_code	type;
			if(msg->GetInfo(B_MIME_TYPE,0,&mime,&type)==B_OK){
				long	bc;
				const void	*d;
				if(!strncmp(mime,"image",5)){			//image data
					if(!msg->FindData(mime,B_MIME_TYPE,&d,&bc)){
						BMemoryIO		mem(d,bc);
						BBitmapStream	strm;
						if(strcmp(mime,"image/x-be-bitmap")){
							tr->Translate(&mem,NULL,NULL,&strm,B_TRANSLATOR_BITMAP,0,mime);
						}else{
							uchar	tbuf[1024];
							int32	tlen;
							while((tlen=mem.Read(tbuf,1024))>0)strm.Write(tbuf,tlen);
						}
						BBitmap *bmp;
						strm.DetachBitmap(&bmp);
						BRect	r=bmp->Bounds();
						r.OffsetTo(0,0);
						if(bm){
							if(obj){redraw(2);delete obj;obj=NULL;}
							obj=new obj_bitmap(dp,now);
							obj->setbitmap(r,(uint32*)(bmp->Bits()));
							delete bmp;
							redraw(5);
							delete obj;	obj=NULL;
						}else{
							scale=1;
							newcanvas(r,bmp);
						}
					}
				}
				if(!strncmp(mime,"text",4)){			//text data
					if(!msg->FindData(mime,B_MIME_DATA,&d,&bc)){	//mime="text/plain"
						if(obj){redraw(2);delete obj;obj=NULL;}
						char	*str=new char[bc+1];
						strncpy(str,(const char*)d,bc);str[bc]=0;
						obj=new obj_text(dr_pt-dr_off,now);
						obj->settext(str,1);
						delete str;
						redraw(5);
						delete obj;	obj=NULL;
					}
				}
			}
		}break;
		case B_SAVE_REQUESTED:{		//save
			entry_ref	dir;
			char	*name;
			msg->FindRef("directory",&dir);
			msg->FindString("name",(const char**)&name);
			save(dir,name);
			fp=NULL;
		}break;
		case B_CANCEL:{				//save cansel
			fp=NULL;
		}break;
		case 'fine':{
			BRect	r;
			msg->FindRect("bounds",&r);
			scale=1;
			newcanvas(r);
		}break;
		case 'fiop':{
			if(fp==NULL){
				fp=new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		case 'fiwr':{
			if(bm){
				if(fp==NULL){
					msg->FindInt16("format_no",&xfno);
					fp=new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false);
					fp->Window()->SetTitle(((xlator*)xlt.ItemAt(xfno))->name);
					fp->Show();
				}
			}
		}break;
		case 'edme':{	//memory
//			if(obj){delete obj;obj=NULL;}
			selm=0;
			if(bm){
				if(bmm){delete bmm;bmm=NULL;}
				bmm=new BBitmap(bm);
			}
			Invalidate();
		}break;
		case 'edun':{	//undo
			if(obj){redraw(2);delete obj;obj=NULL;}
			selm=0;
			if(bmm){
				if(bm){delete bm;bm=NULL;}
				bm=new BBitmap(bmm,true);//////true...child_view);
				canvas=bm->Bounds();
				vcanvas=BRect(canvas.left*scale,canvas.top*scale,canvas.right*scale,canvas.bottom*scale);
				ConstrainClippingRegion(&BRegion(vcanvas));
				if(vv){delete vv;vv=NULL;}
				vv=new BView(canvas,"drawbitmap",B_NOT_RESIZABLE,B_WILL_DRAW);
			}			
			Invalidate();
		}break;
		case 'edcl':{	//clear
			if(obj){redraw(2);delete obj;obj=NULL;}
			selm=0;
			memset(bm->Bits(),0,bm->BitsLength());
			Invalidate();
		}break;
		case 'tool':{	//tool selected
			if(obj){redraw(2);delete obj;obj=NULL;}	//erase frame
			int8	m;
			msg->FindInt8("mode",&m);
			selm=0;
			sel_now.f=0;
			now.mode=m;
			send2toolv();
			if(now.mode==STAMP)setstpcol();
		}break;
		case 'Vchg':if(bm){
			int32	l;
			int16	d;
			float	f;
			const char	*s;
			uint32	chgf=0;
			if(!msg->FindInt32("fc",&l)){now.fc=l;chgf|=0x01;}
			if(!msg->FindInt32("bc",&l)){now.bc=l;chgf|=0x02;}
			if(!msg->FindString("fon_fam",&s)){strcpy(now.fon.fam,s);chgf|=0x04;}
			if(!msg->FindString("fon_sty",&s)){strcpy(now.fon.sty,s);chgf|=0x08;}
			if(!msg->FindInt16("fos",&d)){now.fos=d;chgf|=0x10;}
			if(!msg->FindInt16("pen",&d)){now.pen=d;chgf|=0x20;}
			if(!msg->FindString("stp",&s)){strcpy(now.stp,s);chgf|=0x40;}
			if(!msg->FindFloat("scale",&f)){scale=f;chgf|=0x80;}
			if(chgf)send2selv();
			if(chgf&0x40)setstpbmp();
			if(chgf&0x01)setstpcol();
			if(chgf&0x80)chgscale();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void gpropview::chkinput()
{
	static input	inp_n,inp_b;	//now,before input
	static BPoint	pt_n,pt_b;		//now,before point(view)
	static uchar	bt_n,bt_b;		//now,before button


	BPoint	p;uint32	b;	GetMouse(&p,&b);		//dummy
	SetMouseEventMask(B_POINTER_EVENTS);

	inp_n=((gpropwindow*)Window())->inp;
	pt_n=inp_n.where;
	pt_n=BPoint((int)(pt_n.x/scale),(int)(pt_n.y/scale));
	bt_n=(uchar)inp_n.buttons;
	if(bt_n==B_PRIMARY_MOUSE_BUTTON){
		if(inp_n.modifiers&B_SHIFT_KEY)bt_n=B_SECONDARY_MOUSE_BUTTON;
		if(inp_n.modifiers&B_CONTROL_KEY)bt_n=B_TERTIARY_MOUSE_BUTTON;
	}

	if(bm){
		if(pt_n!=pt_b){
			ptr_move(pt_n,bt_b,inp_n);
		}
		if(bt_n!=bt_b){
			uchar	bt;
			if(bt=bt_b&~bt_n)btn_up(pt_n,bt,inp_n);
			if(bt=~bt_b&bt_n)btn_down(pt_n,bt,inp_n);
		}
	}
	pt_b=pt_n;
	bt_b=bt_n;
	inp_b=inp_n;
}

void gpropview::ptr_move(BPoint pt,uchar bt,input inp)
{
	if((!mdf)&&(!(((now.mode==LINE)||(now.mode==POLY))&&(selm<0))))return;
	if(now.mode==EXT){
		if(selm<0){
			redraw(2);		//erase frame
			sel_now.rect=BRect(mbp,pt);
			redraw(2);		//write frame
		}
	}else if(now.mode>=0x20){		//object
		if(selm<0){
			redraw(2);		//erase frame
			obj->create(mdf?PRESSMOVE:RELEASEMOVE,pt);
			redraw(2);		//write frame
		}
	}else if(now.mode>=0x10){		//free,sand,spray
		BRect	rr;
		if((inp.flags&TABLET_ERASER)&&(inp.eraser)||(bt==2)){
			vv->SetHighColor((uchar)(now.bc>>16),(uchar)(now.bc>>8),(uchar)now.bc);
		}else{
			vv->SetHighColor((uchar)(now.fc>>16),(uchar)(now.fc>>8),(uchar)now.fc);
		}
		vv->SetLowColor(0,0,0);
		vv->SetDrawingMode(now.mode==SPRAY?B_OP_BLEND:B_OP_COPY);
		int	pensize=((now.pen==0)&&(inp.flags&TABLET_PRESSURE))?inp.pressure*20:now.pen;
		bm->Lock();
		bm->AddChild(vv);
		if(now.mode==FREE){				//line(mbp-pt)
			rr=BRect(mbp-BPoint(pensize+1,pensize+1),mbp+BPoint(pensize+1,pensize+1))|BRect(pt-BPoint(pensize+1,pensize+1),pt+BPoint(pensize+1,pensize+1));
			vv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
			vv->MovePenTo(mbp);
			int	cnt=abs(pensize-bps)+1;
			for(int i=1;i<=cnt;i++){
				vv->SetPenSize((bps*(cnt-i)+pensize*i)/cnt);
				vv->StrokeLine(BPoint((mbp.x*(cnt-i)+pt.x*i)/cnt,(mbp.y*(cnt-i)+pt.y*i)/cnt));
			}
			bps=pensize;
			mbp=pt;
		}else{							//spray(mbp-pt)
			rr=BRect(mbp-BPoint(8,8),mbp+BPoint(8,8))|BRect(pt-BPoint(8,8),pt+BPoint(8,8));
			uint32	mnt=(uint32)inp.when;
			if(mnt>mbt){
				vv->SetPenSize(1);
				int	k=12000/(pensize+1);
				int	cnt=(mnt-mbt)/k;
				for(int i=1;i<=cnt;i++){
					double	t=rand();
					double	r=rand()&7;
					BPoint	cp((mbp.x*(cnt-i)+pt.x*i)/cnt,(mbp.y*(cnt-i)+pt.y*i)/cnt);
					BPoint	d(r*cos(t),r*sin(t));
					vv->StrokeLine(cp+d,cp+d);
				}
				mbt+=cnt*k;
				mbp=pt;
			}
		}
		vv->Sync();
		bm->RemoveChild(vv);
		bm->Unlock();
		BRect	vr=BRect(rr.left*scale,rr.top*scale,rr.right*scale,rr.bottom*scale);
		Draw(vr);
	}
}

void gpropview::btn_up(BPoint pt,uchar bt,input inp)
{
	if(!mdf)return;
	mdf=false;	mcf=true;

	if(now.mode==EXT){
		if(selm<0){
			if(pt.x<canvas.left)pt.x=canvas.left;
			if(pt.x>canvas.right)pt.x=canvas.right;
			if(pt.y<canvas.top)pt.y=canvas.top;
			if(pt.y>canvas.bottom)pt.y=canvas.bottom;
			sel_now.rect=BRect(mbp,pt);
			selm=1;
		}
	}else if(now.mode>=0x20){		//object
		if(selm<0){
			redraw(2);			//erase frame
			if(obj->create(RELEASE,pt)<0){	//create complete
				selm=0;
				redraw(5);
				delete obj;	obj=NULL;
			}else{
				redraw(2);		//write frame
			}
		}
	}else{
		sel_now.f=0;
		selm=0;
	}
}

void gpropview::btn_down(BPoint pt,uchar bt,input inp)
{
	if((inp.transit==2)||(inp.transit==3))return;
	mdf=true;
	mbp=pt;
	mbt=(uint32)inp.when;
	bps=((now.pen==0)&&(inp.flags&TABLET_PRESSURE))?0:now.pen;

	if(now.mode==EXT){
		if((selm)&&(sel_now.rect.Contains(pt))){	//drag
			redraw(2);					//erase-frame
			selm=0;	mdf=false;	sel_now.f=0;
			if(bmdd){delete bmdd;bmdd=NULL;}
			bmdd=new BBitmap(sel_now.rect,B_RGB_32_BIT);
			int		dy=bm->BytesPerRow()/4;
			int		w=sel_now.rect.IntegerWidth()+1;
			int		h=sel_now.rect.IntegerHeight()+1;
			uint32	*p=(uint32*)(bm->Bits())+(int)(sel_now.rect.top*dy+sel_now.rect.left);
			uint32	*q=(uint32*)(bmdd->Bits());
			for(int y=0;y<h;y++)for(int x=0;x<w;x++)*(q++)=*(p+dy*y+x);
			BMessage	*mes=ddmessage();
			BRect	vr=BRect(sel_now.rect.left*scale,sel_now.rect.top*scale,sel_now.rect.right*scale,sel_now.rect.bottom*scale);
			DragMessage(mes,vr);
		}else{
			redraw(2);					//erase-frame
			selm=-1;
			sel_now.f=1;
			sel_now.rect=BRect(pt,pt);
			redraw(2);					//write-frame
		}
	}else if(now.mode>=0x20){ 		//object
		if(selm==0){
			if(now.mode==RECT)obj=new obj_rect(pt,now);
			if(now.mode==ELLIPSE)obj=new obj_ellipse(pt,now);
			if(now.mode==LINE)obj=new obj_line(pt,now);
			if(now.mode==POLY)obj=new obj_polygon(pt,now);
			if(now.mode==PAINT)obj=new obj_paint(pt,now,bm);
			selm=-1;		//now create
		}else{
			redraw(2);					//erase-frame
		}
		int	stt=obj->create(bt==1?PRESS:CANSEL,pt);
		if(stt==-1)redraw(5);
		if(stt<0){selm=0;delete obj;obj=NULL;}		//complete
		else redraw(2);					//write-frame
	}else{
//		vv->MovePenTo(mbp);
		if(now.mode==STAMP){
			int	no=0;
			if(bt==B_PRIMARY_MOUSE_BUTTON)no=1;
			if(bt==B_SECONDARY_MOUSE_BUTTON)no=2;
			if(bt==B_TERTIARY_MOUSE_BUTTON)no=3;
			if(stbm[no]){
				vv->SetDrawingMode(B_OP_ALPHA);
				bm->Lock();
				bm->AddChild(vv);
				BRect	rr=stbm[no]->Bounds();
				rr.OffsetTo(pt.x-rr.Width()/2,pt.y-rr.Height()/2);
				vv->DrawBitmap(stbm[no],rr);
				vv->Sync();
				bm->RemoveChild(vv);
				bm->Unlock();
				BRect	vr=BRect(rr.left*scale,rr.top*scale,rr.right*scale,rr.bottom*scale);
				Draw(vr);
			}
		}
	}
}

BMessage* gpropview::ddmessage()
{
	BMessage	*msg=new BMessage(B_SIMPLE_DATA);
	msg->AddString("be:types","image/x-be-bitmap");
	for(int i=0;i<trc;i++){
		msg->AddString("be:types",((xlator*)xlt.ItemAt(i))->mime);
		msg->AddString("be:filetypes",((xlator*)xlt.ItemAt(i))->mime);			//for output
		msg->AddString("be:type_descriptions",((xlator*)xlt.ItemAt(i))->name);	//for menu
	}
	msg->AddString("be:types",B_FILE_MIME_TYPE);
	msg->AddInt32("be:actions",B_COPY_TARGET);
	msg->AddString("be:clip_name","Gprop_img");
	msg->AddString("source","gprop");
	msg->AddFloat("scale",scale);
	return(msg);
}

void gpropview::ddcopy(BMessage *msg)
{
	if(bmdd==NULL)return;
	BBitmapStream	strm(bmdd);
	entry_ref	dir;
	const char	*name,*mime;
	translator_id	tid;
	uint32	fmt;
	if(msg->FindRef("directory",&dir)==B_OK){
		msg->FindString("name",&name);
		msg->FindString("be:filetypes",&mime);
		BFile	*wf=new BFile();
		BDirectory(&dir).CreateFile(name,wf,false);
		select_trans(mime,&tid,&fmt);
		tr->Translate(tid,&strm,NULL,wf,fmt);
		BAppFileInfo	wfi(wf);
		wfi.SetType(mime);
		delete wf;
	}else{
		msg->FindString("be:types",&mime);
		BMallocIO	*dat=new BMallocIO;
		BMessage	*res=new BMessage(B_MIME_DATA);
		if(strcmp(mime,"image/x-be-bitmap")){
			select_trans(mime,&tid,&fmt);
			tr->Translate(tid,&strm,NULL,dat,fmt);
		}else{
			uchar	tbuf[1024];
			int32	tlen;
			while((tlen=strm.Read(tbuf,1024))>0)dat->Write(tbuf,tlen);
		}
		res->AddData(mime,B_MIME_DATA,dat->Buffer(),dat->BufferLength());
		msg->SendReply(res);
		delete dat;
		delete res;
	}
	bmdd=NULL;
}

void gpropview::select_trans(const char *mime,translator_id *tid,uint32 *fmt)
{
	for(int i=0;i<trc;i++){
		if(strcmp(((xlator*)xlt.ItemAt(i))->mime,mime))continue;
		*tid=((xlator*)xlt.ItemAt(i))->id;
		*fmt=((xlator*)xlt.ItemAt(i))->type;
		return;
	}
	*tid=0;
	*fmt=0;
}

void gpropview::newcanvas(BRect r,BBitmap *dbm)
{
	vcanvas=BRect(0,0,0,0);
	Window()->Zoom();
	if(obj){delete obj;obj=NULL;}
	if(vv){delete vv;vv=NULL;}
	if(bm){delete bm;bm=NULL;}
	r.OffsetTo(0,0);
	bm=new BBitmap(r,B_RGB_32_BIT,true);//////true...child_view
	if(dbm){
#if	BYTE_ORDER==__BIG_ENDIAN
//printf("colorspace %04x\n",bm->ColorSpace());
		if((dbm->ColorSpace()==B_RGB32_BIG)||(dbm->ColorSpace()==B_RGBA32_BIG)){
			uint32	*q=(uint32*)bm->Bits();
			uint32	*p=(uint32*)dbm->Bits();
			int	len=dbm->BitsLength()/4;
			for(int i=0;i<len;i++)*(q++)=B_SWAP_INT32(*(p++));
		}else
#endif
		memcpy(bm->Bits(),dbm->Bits(),bm->BitsLength());
	}else{
		memset(bm->Bits(),0,bm->BitsLength());
	}
	canvas=bm->Bounds();
	vcanvas=BRect(canvas.left*scale,canvas.top*scale,canvas.right*scale,canvas.bottom*scale);
	ConstrainClippingRegion(&BRegion(vcanvas));
	vv=new BView(canvas,"drawbitmap",B_NOT_RESIZABLE,B_WILL_DRAW);
	sel_now.f=0;
	selm=0;
	init();
	Window()->Zoom();
	Invalidate();
}

void gpropview::chgscale()
{
	vcanvas=BRect(canvas.left*scale,canvas.top*scale,canvas.right*scale,canvas.bottom*scale);
	ConstrainClippingRegion(&BRegion(vcanvas));
	Window()->Zoom();
	Invalidate();
}

void gpropview::init()
{
	now.mode=FREE;
	now.fc=0xffffffff;	now.bc=0xff000000;
	now.pen=0;
	be_plain_font->GetFamilyAndStyle(&now.fon.fam,&now.fon.sty);
	now.fos=20;
	now.stp[0]=0;
	scale=1;
//	initok=true;
	send2toolv();
	send2selv();
	char	s[128];
	sprintf(s,"%s(%s)",now.fon.fam,now.fon.sty);
	((gpropwindow*)Window())->markmenu(_T("Font"),s);
	((gpropwindow*)Window())->markmenu(_T("Stamp"),"default");
	((gpropwindow*)Window())->markmenu(_T("Scale"),"100%");
	setstpbmp();
}

void gpropview::send2toolv()
{
	BMessage *mes=new BMessage('Vchg');
	mes->AddInt8("mode",now.mode);
	BMessenger(((gpropwindow*)Window())->tv).SendMessage(mes);//Window()->PostMessage(mes,((gpropwindow*)Window())->tv);
}

void gpropview::send2selv()
{
	BMessage *mes=new BMessage('Vchg');
	mes->AddInt32("fc",now.fc);
	mes->AddInt32("bc",now.bc);
	mes->AddInt16("fos",now.fos);
	mes->AddInt16("pen",now.pen);
	BMessenger(((gpropwindow*)Window())->sv).SendMessage(mes);//Window()->PostMessage(mes,((gpropwindow*)Window())->sv);
}

void gpropview::setstpbmp()
{
	if(*now.stp){
		char	s[256];
		for(int i=0;i<4;i++){
			if(stbm[i]){delete stbm[i];stbm[i]=NULL;}
			sprintf(s,"%s/%s.%d",stpdir.Path(),now.stp,i);
			BFile	*rf=new BFile(s,O_RDONLY|O_BINARY);
			if(rf==NULL)continue;
			BBitmapStream	outstrm;
			BBitmap			*tbm=NULL;
			if(!tr->Translate(rf,NULL,NULL,&outstrm,B_TRANSLATOR_BITMAP))outstrm.DetachBitmap(&tbm);
			delete	rf;
			if(tbm==NULL)continue;
#if	BYTE_ORDER==__BIG_ENDIAN
//printf("colorspace %04x\n",bm->ColorSpace());
			if((tbm->ColorSpace()==B_RGB32_BIG)||(tbm->ColorSpace()==B_RGBA32_BIG)){
				BBitmap	*ttbm=new BBitmap(tbm->Bounds(),B_RGB_32_BIT);
				uint32	*q=(uint32*)ttbm->Bits();
				uint32	*p=(uint32*)tbm->Bits();
				int	len=tbm->BitsLength()/4;
				for(int j=0;j<len;j++)*(q++)=B_SWAP_INT32(*(p++));
				delete	tbm;
				tbm=ttbm;
			}
#endif
			uint32	*p=(uint32*)(tbm->Bits());
			int	len=tbm->BitsLength()/4;
			for(int j=0;j<len;j++){
				*p=(B_LENDIAN_TO_HOST_INT32(*p)&0xffffff)?B_HOST_TO_LENDIAN_INT32(now.fc):0;
				p++;
			}
			stbm[i]=tbm;
		}
	}else{
		for(int i=0;i<4;i++){
			if(stbm[i]){delete stbm[i];stbm[i]=NULL;}
			stbm[i]=new BBitmap(BRect(0,0,15,15),B_RGB_32_BIT);
			uint32	*p=(uint32*)(stbm[i]->Bits());
			for(int y=0;y<16;y++)for(int x=0;x<16;x++){
				*(p++)=(iconpat[8][y]&(0x8000>>x))?B_HOST_TO_LENDIAN_INT32(now.fc):0;
			}
		}
	}
}

void gpropview::setstpcol()
{
	for(int i=0;i<4;i++)if(stbm[i]){
		uint32	*p=(uint32*)(stbm[i]->Bits());
		int	len=stbm[i]->BitsLength()/4;
		for(int i=0;i<len;i++){
			*p=(*((uchar*)p+3))?B_HOST_TO_LENDIAN_INT32(now.fc):0;
			p++;
		}
	}
}

void gpropview::redraw(char f)
{
//printf("redraw %d\n",f);
	if(bm==NULL)return;
	if(f&1)if(obj)obj->draw(bm);				//write object on bitmap
	if(f&2){
		if(obj)obj->drawframe(this,scale);		//only write(erase) frame
		if(sel_now.f)drawframe(sel_now.rect);
	}
	if(f&4)Draw(Bounds());						//update screen
}

void gpropview::drawframe(BRect r)
{
	r=BRect(r.left*scale,r.top*scale,r.right*scale,r.bottom*scale);
	SetDrawingMode(B_OP_INVERT);
	StrokeRect(r,B_MIXED_COLORS);
	SetDrawingMode(B_OP_COPY);
}

void gpropview::load(entry_ref &eref)
{
	BFile	*rf=new BFile(&eref,O_RDONLY|O_BINARY);
	BBitmapStream	outstrm;
	BBitmap			*tbm=NULL;
	if(!tr->Translate(rf,NULL,NULL,&outstrm,B_TRANSLATOR_BITMAP))outstrm.DetachBitmap(&tbm);
	delete	rf;
	if(tbm){
		strcpy(title,eref.name);
		scale=1;
		newcanvas(tbm->Bounds(),tbm);
		delete	tbm;
	}
}

void gpropview::save(entry_ref &dir,char *name)
{
	BFile	*wf=new BFile();
	BDirectory(&dir).CreateFile(name,wf,false);
	BBitmapStream	instrm(bm);
	tr->Translate(&instrm,NULL,NULL,wf,((xlator*)xlt.ItemAt(xfno))->type);
	instrm.DetachBitmap(&bm);
	BAppFileInfo	wfi(wf);
	wfi.SetType(((xlator*)xlt.ItemAt(xfno))->mime);
	delete	wf;
}
//------------------------------------------------
object::object()
{
	pts=0;
	pt=NULL;
	cpts=0;
}
object::object(const BPoint &p,const s_mode &m,int points)
{
	if(points){
		pts=points;
		pt=new BPoint[pts];
		pt[0]=p;
		cpts=0;
	}else{	//for variable-points
		pts=1;
		pt=new BPoint[256];
		pt[0]=p;
		cpts=0;
	}
}

object::~object()
{
#if	__INTEL__
	if(pt)delete pt;
#endif
}

int object::create(const uchar &mf,const BPoint &mp)
{
	if((mf==PRESS)&&(cpts<pts)){
		pt[cpts]=mp;
		if(++cpts>=pts)cpts=-1;		//create complete
	}
	if(mf==CANSEL)cpts=-2;
	return(cpts);
}

void object::set_attr(const s_mode &m,const uint32 &f)
{
}

void object::draw(BBitmap *bm)
{
	uint32	*o=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	for(int i=0;i<pts;i++){
		uint32	*p=o+(int)(dy*pt[i].y+pt[i].x);
//printf("obj: i=%d  (%d,%d)\n",i,pt[i].x,pt[i].y);
		*p=0xffffffff;
	}
}

void object::drawframe(BView *v,float scale)
{
}

void object::ctrlp2form()
{
//set bound
}

void object::settext(const char *s,const uchar &f)
{
}

void object::setbitmap(const BRect &r,const uint32 *d)
{
}
//------------------------------------------------
obj_paint::obj_paint(const BPoint &p,const s_mode &m,const BBitmap *bm):object(p,m,1)
{
	dp.bm=new BBitmap(bm);
	set_attr(m);
}

obj_paint::~obj_paint()
{
	if(dp.bm)delete dp.bm;
}

int obj_paint::create(const uchar &mf,const BPoint &mp)
{
	uint32	*o=(uint32*)(dp.bm->Bits());
	int		dy=dp.bm->BytesPerRow()/4;
	int		w=dp.bm->Bounds().IntegerWidth()+1;
	int		h=dp.bm->Bounds().IntegerHeight()+1;

	struct paintpos{int l,r,y,f;}*pp;
	pp=new paintpos[10000];
	int		x,y,l,r,f;
	uint32	c,gc;
	x=mp.x;	y=mp.y;	c=B_HOST_TO_LENDIAN_INT32(dp.fc);	gc=*(o+dy*y+x);
	if(c==gc){cpts=-1;return(cpts);}
	l=x;while(l>0)if(*(o+dy*y+l-1)==gc)l--;else break;
	r=x;while(r<w-1)if(*(o+dy*y+r+1)==gc)r++;else break;
	f=0;		//up
	pp[0].l=l;pp[0].r=r;pp[0].y=y;pp[0].f=1;

	if(mf==PRESS){
		for(int sp=0;;sp--){
			if((y>=0)&&(y<h)){
				int	ll=l;
				if(*(o+dy*y+ll)==gc){
					while(ll>0)if(*(o+dy*y+ll-1)==gc)ll--;else break;
				}
				for(;ll<=r;ll++){
					if(*(o+dy*y+ll)!=gc)continue;
					int	rr=ll;
					while(rr<w-1)if(*(o+dy*y+rr+1)==gc)rr++;else break;
					if(ll<l-1){sp++;pp[sp].l=ll;pp[sp].r=l-1;pp[sp].y=y;pp[sp].f=f^1;}
					if(rr>r+1){sp++;pp[sp].l=r+1;pp[sp].r=rr;pp[sp].y=y;pp[sp].f=f^1;}
					sp++;pp[sp].l=ll;pp[sp].r=rr;pp[sp].y=y;pp[sp].f=f;
					for(x=ll;x<=rr;x++)*(o+dy*y+x)=c;
					ll=rr;
				}
			}
			if(sp<0)break;
			f=pp[sp].f;l=pp[sp].l;r=pp[sp].r;y=(f==0)?pp[sp].y-1:pp[sp].y+1;	
		}
	}else{
		for(int sp=0;;sp--){
			if((y>=0)&&(y<h)){
				int	ll=l;
				if(*(o+dy*y+ll)!=c){
					while(ll>0)if(*(o+dy*y+ll-1)!=c)ll--;else break;
				}
				for(;ll<=r;ll++){
					if(*(o+dy*y+ll)==c)continue;
					int	rr=ll;
					while(rr<w-1)if(*(o+dy*y+rr+1)!=c)rr++;else break;
					if(ll<l-1){sp++;pp[sp].l=ll;pp[sp].r=l-1;pp[sp].y=y;pp[sp].f=f^1;}
					if(rr>r+1){sp++;pp[sp].l=r+1;pp[sp].r=rr;pp[sp].y=y;pp[sp].f=f^1;}
					sp++;pp[sp].l=ll;pp[sp].r=rr;pp[sp].y=y;pp[sp].f=f;
					for(x=ll;x<=rr;x++)*(o+dy*y+x)=c;
					ll=rr;
				}
			}
			if(sp<0)break;
			f=pp[sp].f;l=pp[sp].l;r=pp[sp].r;y=(f==0)?pp[sp].y-1:pp[sp].y+1;	
		}
	}

	delete	pp;
	cpts=-1;
	return(cpts);
}

void obj_paint::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)dp.fc=m.fc;
	if(f&0x02)dp.bc=m.bc;
}

void obj_paint::draw(BBitmap *bm)
{
	if(cpts>=0)return;
	BView	*vv=new BView(canvas,"drawbitmap",B_NOT_RESIZABLE,B_WILL_DRAW);
	bm->Lock();
	bm->AddChild(vv);
	vv->DrawBitmap(dp.bm);
	vv->Sync();
	bm->RemoveChild(vv);
	bm->Unlock();
	delete	vv;
}
//------------------------------------------------
object_r::object_r():object()
{
}
object_r::object_r(const BPoint &p,const s_mode &m):object(p,m,4)
{
}

int object_r::create(const uchar &mf,const BPoint &mp)
{
	if((mf==PRESS)&&(cpts==0)){
		pt[0]=mp;
		pt[1]=pt[0];
		cpts=1;
	}
	if((mf==RELEASE)&&(cpts==1)){
		pt[1]=mp;
		cpts=-1;		//create complete
		ctrlp2form();
	}
	if((mf==PRESSMOVE)&&(cpts==1)){
		pt[1]=mp;
	}
	if(mf==CANSEL)cpts=-2;
	return(cpts);
}
//------------------------------------------------
object_l::object_l():object()
{
}
object_l::object_l(const BPoint &p,const s_mode &m):object(p,m,0)
{
}

int object_l::create(const uchar &mf,const BPoint &mp)
{
	if(mf==PRESS){
		if(cpts==0){
			cpts++;
			pt[pts++]=mp;	//next
		}else{
			BRect	rp(pt[cpts-1].x-2,pt[cpts-1].y-2,pt[cpts-1].x+2,pt[cpts-1].y+2);
			if(rp.Contains(mp)){	//create complete
				pts--;
				cpts=-1;
			}else{
				pt[cpts++]=mp;
				pt[pts++]=mp;	//next
			}
		}
	}
	if(mf==CANSEL){
		cpts--;pts--;
		if(pts<2){
			pts=0;cpts=-2;
		}else{
			pt[pts-1]=mp;
		}
	}
	if((mf==RELEASEMOVE)&&(cpts)){
		pt[pts-1]=mp;
	}
	return(cpts);
}
//------------------------------------------------
obj_rect::obj_rect():object_r()
{
}
obj_rect::obj_rect(const BPoint &p,const s_mode &m):object_r(p,m)
{
	set_attr(m);
}

void obj_rect::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)dr.fc=m.fc;
	if(f&0x02)dr.bc=m.bc;
	if(f&0x40)dr.pen=m.pen;
}

void obj_rect::draw(BBitmap *bm)
{
	if(cpts>=0)return;
	BView	*vv=new BView(canvas,"drawbitmap",B_NOT_RESIZABLE,B_WILL_DRAW);
	vv->SetHighColor((uchar)(dr.fc>>16),(uchar)(dr.fc>>8),(uchar)(dr.fc));
	vv->SetViewColor(0,0,0);
	vv->SetLowColor(0,0,0);
	vv->SetPenSize(dr.pen);
	bm->Lock();
	bm->AddChild(vv);
//	vv->StrokeRoundRect(dr.rec,dr.pen/2,dr.pen/2);
	vv->StrokeRect(dr.rec);
	vv->Sync();
	bm->RemoveChild(vv);
	bm->Unlock();
	delete	vv;
}

void obj_rect::drawframe(BView *v,float scale)
{
	if(cpts<0)return;
	v->SetDrawingMode(B_OP_INVERT);
	v->StrokeRect(BRect(pt[0].x*scale,pt[0].y*scale,pt[1].x*scale,pt[1].y*scale),B_MIXED_COLORS);
	v->SetDrawingMode(B_OP_COPY);
}

void obj_rect::ctrlp2form()
{
	float	f;
	if(pt[0].x>pt[1].x){f=pt[0].x;pt[0].x=pt[1].x;pt[1].x=f;}
	if(pt[0].y>pt[1].y){f=pt[0].y;pt[0].y=pt[1].y;pt[1].y=f;}
	dr.rec=BRect(pt[0],pt[1]);
}
//------------------------------------------------
obj_ellipse::obj_ellipse():object_r()
{
}
obj_ellipse::obj_ellipse(const BPoint &p,const s_mode &m):object_r(p,m)
{
	set_attr(m);
}

void obj_ellipse::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)de.fc=m.fc;
	if(f&0x02)de.bc=m.bc;
	if(f&0x40)de.pen=m.pen;
}

void obj_ellipse::draw(BBitmap *bm)
{
	if(cpts>=0)return;
	BView	*vv=new BView(canvas,"drawbitmap",B_NOT_RESIZABLE,B_WILL_DRAW);
	vv->SetHighColor((uchar)(de.fc>>16),(uchar)(de.fc>>8),(uchar)(de.fc));
	vv->SetViewColor(0,0,0);
	vv->SetLowColor(0,0,0);
	vv->SetPenSize(de.pen);
	bm->Lock();
	bm->AddChild(vv);
	vv->StrokeEllipse(de.rec);
	vv->Sync();
	bm->RemoveChild(vv);
	bm->Unlock();
	delete	vv;
}

void obj_ellipse::drawframe(BView *v,float scale)
{
	if(cpts<0)return;
	BPoint	p0,p1;
	p0=pt[0],p1=pt[1];
	float	f;
	if(p0.x>p1.x){f=p0.x;p0.x=p1.x;p1.x=f;}
	if(p0.y>p1.y){f=p0.y;p0.y=p1.y;p1.y=f;}
	v->SetDrawingMode(B_OP_INVERT);
	v->StrokeEllipse(BRect(p0.x*scale,p0.y*scale,p1.x*scale,p1.y*scale),B_MIXED_COLORS);
	v->SetDrawingMode(B_OP_COPY);
}

void obj_ellipse::ctrlp2form()
{
	float	f;
	if(pt[0].x>pt[1].x){f=pt[0].x;pt[0].x=pt[1].x;pt[1].x=f;}
	if(pt[0].y>pt[1].y){f=pt[0].y;pt[0].y=pt[1].y;pt[1].y=f;}
	de.rec=BRect(pt[0],pt[1]);
}
//------------------------------------------------
obj_text::obj_text():object_r()
{
	dt.str=NULL;
}
obj_text::obj_text(const BPoint &p,const s_mode &m):object_r(p,m)
{
	dt.str=NULL;
	set_attr(m);
}

obj_text::~obj_text()
{
	if(dt.str)delete dt.str;
}

void obj_text::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)dt.fc=m.fc;
	if(f&0x02)dt.bc=m.bc;
	if(f&0x10)dt.fon=m.fon;
	if(f&0x20)dt.fos=m.fos;
}

void obj_text::draw(BBitmap *bm)
{
	if(cpts>=0)return;
	BView	*vv=new BView(canvas,"drawbitmap",B_NOT_RESIZABLE,B_WILL_DRAW);
	vv->SetHighColor((uchar)(dt.fc>>16),(uchar)(dt.fc>>8),(uchar)(dt.fc));
	vv->SetViewColor(0,0,0);
//	vv->SetLowColor(0,0,0);
	vv->SetLowColor((uchar)(dt.fc>>16),(uchar)(dt.fc>>8),(uchar)(dt.fc),128);
	vv->SetDrawingMode(B_OP_ALPHA);
		BFont	wf;
		font_height	fh;
		wf.SetFamilyAndStyle(dt.fon.fam,dt.fon.sty);
		wf.SetSize(dt.fos);
		wf.GetHeight(&fh);
		vv->SetFont(&wf);
	bm->Lock();
	bm->AddChild(vv);
		vv->DrawString(dt.str,BPoint(dt.rec.left,dt.rec.top+fh.ascent));
	vv->Sync();
	bm->RemoveChild(vv);
	bm->Unlock();
	delete	vv;
}

void obj_text::ctrlp2form()
{
	dt.rec=BRect(pt[0],pt[1]);
}

void obj_text::settext(const char *s,const uchar &f)
{
	if(dt.str){delete dt.str;dt.str=NULL;}
	dt.str=new char[strlen(s)+1];
	strcpy(dt.str,s);
	if(f){
		BFont	wf;
		font_height	fh;
		int		w,h;
		wf.SetFamilyAndStyle(dt.fon.fam,dt.fon.sty);
		wf.SetSize(dt.fos);
		w=(int)wf.StringWidth(s);
		wf.GetHeight(&fh);
		h=(int)(fh.ascent+fh.descent);
		pt[1].x=pt[0].x+w-1;	pt[1].y=pt[0].y+h-1;
		cpts=-1;
	}
	ctrlp2form();
}
//------------------------------------------------
obj_bitmap::obj_bitmap():object_r()
{
	db.bm=NULL;
}
obj_bitmap::obj_bitmap(const BPoint &p,const s_mode &m):object_r(p,m)
{
	db.bm=NULL;
	set_attr(m);
}

obj_bitmap::~obj_bitmap()
{
	if(db.bm)delete db.bm;
}

void obj_bitmap::draw(BBitmap *bm)
{
	if(cpts>=0)return;
	BView	*vv=new BView(canvas,"drawbitmap",B_NOT_RESIZABLE,B_WILL_DRAW);
	bm->Lock();
	bm->AddChild(vv);
	vv->DrawBitmap(db.bm,db.rec);
	vv->Sync();
	bm->RemoveChild(vv);
	bm->Unlock();
	delete	vv;
}

void obj_bitmap::ctrlp2form()
{
	db.rec=BRect(pt[0],pt[1]);
}

void obj_bitmap::setbitmap(const BRect &rec,const uint32 *d)
{
	if(db.bm){delete db.bm;db.bm=NULL;}
	db.bm=new BBitmap(rec,B_RGB_32_BIT);
	memcpy(db.bm->Bits(),d,db.bm->BitsLength());
	pt[1].x=pt[0].x+rec.IntegerWidth();
	pt[1].y=pt[0].y+rec.IntegerHeight();
	cpts=-1;
	ctrlp2form();
}
//------------------------------------------------
obj_line::obj_line():object_l()
{
}
obj_line::obj_line(const BPoint &p,const s_mode &m):object_l(p,m)
{
	set_attr(m);
}

void obj_line::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)dl.fc=m.fc;
	if(f&0x02)dl.bc=m.bc;
	if(f&0x40)dl.pen=m.pen;
}

void obj_line::draw(BBitmap *bm)
{
	if(cpts>=0)return;
	BView	*vv=new BView(canvas,"drawbitmap",B_NOT_RESIZABLE,B_WILL_DRAW);
	vv->SetHighColor((uchar)(dl.fc>>16),(uchar)(dl.fc>>8),(uchar)(dl.fc));
	vv->SetViewColor(0,0,0);
	vv->SetLowColor(0,0,0);
	vv->SetPenSize(dl.pen);
	vv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	bm->Lock();
	bm->AddChild(vv);
	vv->MovePenTo(pt[0]);
	for(int i=1;i<pts;i++)vv->StrokeLine(pt[i]);
	vv->Sync();
	bm->RemoveChild(vv);
	bm->Unlock();
	delete	vv;
}

void obj_line::drawframe(BView *v,float scale)
{
	if(cpts<0)return;
	v->MovePenTo(pt[0].x*scale,pt[0].y*scale);
	v->SetDrawingMode(B_OP_INVERT);
	for(int i=1;i<pts;i++)v->StrokeLine(BPoint(pt[i].x*scale,pt[i].y*scale),B_MIXED_COLORS);
	v->SetDrawingMode(B_OP_COPY);
}
//------------------------------------------------
obj_polygon::obj_polygon():object_l()
{
}
obj_polygon::obj_polygon(const BPoint &p,const s_mode &m):object_l(p,m)
{
	set_attr(m);
}

void obj_polygon::set_attr(const s_mode &m,const uint32 &f)
{
	if(f&0x01)dp.fc=m.fc;
	if(f&0x02)dp.bc=m.bc;
	if(f&0x40)dp.pen=m.pen;
}

void obj_polygon::draw(BBitmap *bm)
{
	if(cpts>=0)return;
	BView	*vv=new BView(canvas,"drawbitmap",B_NOT_RESIZABLE,B_WILL_DRAW);
	vv->SetHighColor((uchar)(dp.fc>>16),(uchar)(dp.fc>>8),(uchar)(dp.fc));
	vv->SetViewColor(0,0,0);
	vv->SetLowColor(0,0,0);
	vv->SetPenSize(dp.pen);
	vv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	bm->Lock();
	bm->AddChild(vv);
	vv->MovePenTo(pt[pts-1]);
	for(int i=0;i<pts;i++)vv->StrokeLine(pt[i]);
	vv->Sync();
	bm->RemoveChild(vv);
	bm->Unlock();
	delete	vv;
}

void obj_polygon::drawframe(BView *v,float scale)
{
	if(cpts<0)return;
	v->SetDrawingMode(B_OP_INVERT);
	if(pts==2){
		v->StrokeLine(BPoint(pt[0].x*scale,pt[0].y*scale),BPoint(pt[1].x*scale,pt[1].y*scale),B_MIXED_COLORS);
	}else{
		v->MovePenTo(pt[pts-1].x*scale,pt[pts-1].y*scale);
		for(int i=0;i<pts;i++)v->StrokeLine(BPoint(pt[i].x*scale,pt[i].y*scale),B_MIXED_COLORS);
	}
	v->SetDrawingMode(B_OP_COPY);
}
