// gprox.cpp		ver.0.075
//copyright 1998-2004 Beer[Tsutsumi Hiroyuki]

#include	"gprox.h"

#define	VER		"ver.0.075"
#define	DATE	"2004. 7. 4"

int main(int argc,char **argv)
{
	if(!(tr=BTranslatorRoster::Default()))return(1);
	gprox	app(argc,argv);
	app.Run();
	return(0);
}
//------------------------------------------------
gprox::gprox(int argc,char **argv):BApplication("application/x-vnd.Beer-gprox")
{
#if	B_BEOS_VERSION>=0x0520
	app_info	ai;	be_app->GetAppInfo(&ai);
	BPath	ap(&ai.ref),dp;
	ap.GetParent(&dp);
	BPath	lp(dp);
	lp.Append("Language/Dictionaries");
	lp.Append("gpro");
	be_locale.LoadLanguageFile(lp.Path());
#endif

	BRect	frame(100,100,300,250);
	w=new gproxwindow(frame);
	if(argc>1){
		BMessage msg(B_SIMPLE_DATA);
		for(int i=1;i<argc;i++){
			BEntry	e(argv[i]);
			entry_ref	eref;
			e.GetRef(&eref);
			msg.AddRef("refs",&eref);
		}
		BMessenger(w->v).SendMessage(&msg);//w->PostMessage(&msg,w->v);
	}
}

void gprox::RefsReceived(BMessage *mes)
{
	uint32	type;
	int32	files;
	mes->GetInfo("refs",&type,&files);
	if(files>0){
		entry_ref	eref;
		BMessage msg(B_SIMPLE_DATA);
		for(int i=0;i<files;i++){
			mes->FindRef("refs",i,&eref);
			msg.AddRef("refs",&eref);
		}
		BMessenger(w->v).SendMessage(&msg);//w->PostMessage(&msg,w->v);
	}
}

void gprox::MessageReceived(BMessage *mes)
{
	switch(mes->what){
		case B_SAVE_REQUESTED:{
			entry_ref	dir;
			const char		*name;
			mes->FindRef("directory",&dir);
			mes->FindString("name",&name);
			BMessage msg(B_SAVE_REQUESTED);
			msg.AddRef("directory",&dir);
			msg.AddString("name",name);
			BMessenger(w->v).SendMessage(&msg);//w->PostMessage(&msg,w->v);
		}break;
		case B_CANCEL:{
			BMessenger(w->v).SendMessage(B_CANCEL);//w->PostMessage(B_CANCEL,w->v);
		}break;
		default:{
			BApplication::MessageReceived(mes);
		}break;
	}
}

void gprox::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"Gprox "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.wht.mmtr.or.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
} 
//------------------------------------------------
gproxwindow::gproxwindow(BRect frame):BWindow(frame,"gprox "VER,B_DOCUMENT_WINDOW,0)
{
	get_translator_for_output();
	sbv=sbh=NULL;
	BRect	viewframe;
	viewframe.Set(0,0,frame.Width()-B_V_SCROLL_BAR_WIDTH,frame.Height()-B_H_SCROLL_BAR_HEIGHT-20);
	viewframe.OffsetTo(0,20);
	v=new gproxview(viewframe);
	AddChild(v);
	setupmenus();
	BRect	sbvframe;
	sbvframe.Set(0,0,B_V_SCROLL_BAR_WIDTH,viewframe.Height()+2);
	sbvframe.OffsetTo(viewframe.Width()+1,20-1);
	sbv=new BScrollBar(sbvframe,"scrollv",(BView*)v,0,0,B_VERTICAL);
	AddChild(sbv);
	BRect	sbhframe;
	sbhframe.Set(0,0,viewframe.Width()+2,B_H_SCROLL_BAR_HEIGHT);
	sbhframe.OffsetTo(-1,viewframe.Height()+21);
	sbh=new BScrollBar(sbhframe,"scrollh",(BView*)v,0,0,B_HORIZONTAL);
	AddChild(sbh);
	FrameResized(frame.Width(),frame.Height());
	resizeview(0,0);
	Show();
	SetPulseRate(100000);
}

bool gproxwindow::QuitRequested()
{
	xlator	*xl;
	for(int i=0;xl=(xlator*)xlt.ItemAt(i);i++)delete xl;
	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);//be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void gproxwindow::FrameResized(float width,float height)
{
	float	rv,rh;
	rv=pic.Height()-sbv->Bounds().Height()+2;
	rh=pic.Width()-sbh->Bounds().Width()+2;
	sbv->SetRange(0,rv>0?rv:0);
	sbh->SetRange(0,rh>0?rh:0);
	sbv->SetProportion(sbv->Bounds().Height()/pic.Height());
	sbh->SetProportion(sbh->Bounds().Width()/pic.Width());
	sbv->SetSteps(10,sbv->Bounds().Height());
	sbh->SetSteps(10,sbh->Bounds().Width());
}

void gproxwindow::resizeview(int width,int height)
{
	if(width==0)width=200-B_V_SCROLL_BAR_WIDTH;
	if(height==0)height=150-B_H_SCROLL_BAR_HEIGHT-20;
	int	ww,hh;
	ww=width+B_V_SCROLL_BAR_WIDTH;
	hh=height+B_H_SCROLL_BAR_HEIGHT+20;
	SetSizeLimits(35,ww,35,hh);
	SetZoomLimits(ww,hh);
	ResizeTo(ww,hh);
	v->ResizeTo(width,height);
}

void gproxwindow::setupmenus()
{
	BMenuBar	*mb;
	BMenu		*m,*mm;
	BMenuItem	*mi;
	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mi=new BMenuItem(_T("Open"),new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Close"),new BMessage('ficl'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mm=new BMenu(_T("Save as"));
		for(int i=0;i<trc;i++){
			mes=new BMessage('fiwr');
			mes->AddInt16("format_no",i);
			mi=new BMenuItem(((xlator*)xlt.ItemAt(i))->name,mes);
			mi->SetTarget((BHandler*)v);
			mm->AddItem(mi);
		}
	 m->AddItem(mm);
	 mi=new BMenuItem(_T("Capture"),new BMessage('fica'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Print"),new BMessage('fipr'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	m=new BMenu(_T("Config"));
		for(int i=0;i<trc;i++){
			BView	*cv;
			BRect	cr;
			if(tr->MakeConfigurationView(((xlator*)xlt.ItemAt(i))->id,NULL,&cv,&cr))continue;
			mes=new BMessage('conf');
			mes->AddInt16("format_no",i);
			mi=new BMenuItem(((xlator*)xlt.ItemAt(i))->name,mes);
			mi->SetTarget((BHandler*)v);
			m->AddItem(mi);
		}
	mb->AddItem(m);
	AddChild(mb);
}

void gproxwindow::get_translator_for_output()
{
	BBitmap 			*tbm=new BBitmap(BRect(0,0,7,7),B_RGB_32_BIT);
	BBitmapStream		*instrm=new BBitmapStream(tbm);
	translator_info		*inf;
	const translation_format	*frm;
	int32				infs,frms;
	tr->GetTranslators(instrm,NULL,&inf,&infs);
	for(int i=0;i<infs;i++){
		tr->GetOutputFormats(inf[i].translator,&frm,&frms);
		for(int j=0;j<frms;j++){
//printf("%c%c%c%c %4.2f %4.2f\n",frm[j].type>>24,frm[j].type>>16,frm[j].type>>8,frm[j].type,frm[j].quality,frm[j].capability);
			if(frm[j].type=='bits')continue;		//standard bitmap
			if(frm[j].type=='mhi!')continue;		//progressive bitmap
			xlator	*xl=new xlator;
			xl->type=frm[j].type;
			xl->id=inf[i].translator;
			strcpy(xl->name,frm[j].name);
			strcpy(xl->mime,frm[j].MIME);
			if(frm[j].type=='TGA ')xlt.AddItem((void*)xl,0);else xlt.AddItem((void*)xl);
			trc++;
		}
	}
	delete inf;
}
//------------------------------------------------
gproxview::gproxview(BRect frame):BView(frame,"gproxview",B_FOLLOW_ALL_SIDES,B_WILL_DRAW|B_PULSE_NEEDED)
{
	bm=NULL;	bmdd=NULL;
	fp=NULL;
	xfno=0;
	mf=0;
	sel_old.f=sel_now.f=false;
	strcpy(title,"gprox "VER);
}

gproxview::~gproxview()
{
	if(bm)delete bm;
	if(bmdd)delete bmdd;
}

void gproxview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(0,0,0);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);
}

void gproxview::Draw(BRect rect)
{
	if(bm){
		DrawBitmap(bm,rect,rect);
	}
	if(!bm){
		SetFontSize(30);
		DrawString("Gprox",BPoint(45,50));
		SetFontSize(20);
		DrawString(VER,BPoint(75,80));
	}
}

void gproxview::Pulse()
{
	if(((sel_old.f)&&(!sel_now.f))||((sel_now.f)&&(sel_old.r!=sel_now.r)))eraseframe(sel_old);
	if(((!sel_old.f)&&(sel_now.f))||((sel_now.f)&&(sel_old.r!=sel_now.r)))drawframe(sel_now);
	sel_old=sel_now;
}

void gproxview::MouseDown(BPoint pt)
{
	SetMouseEventMask(B_POINTER_EVENTS);
	if(!pic.Contains(pt))return;
	mpt=pt-Bounds().LeftTop();
	if((sel_now.f)&&(sel_now.r.Contains(pt))){
		if(bmdd){delete bmdd;bmdd=NULL;}
		bmdd=new BBitmap(sel_now.r,B_RGB_32_BIT);
		int		dy=bm->BytesPerRow()/4;
		int		w=sel_now.r.IntegerWidth()+1;
		int		h=sel_now.r.IntegerHeight()+1;
		uint32	*p=(uint32*)(bm->Bits())+(int)(sel_now.r.top*dy+sel_now.r.left);
		uint32	*q=(uint32*)(bmdd->Bits());
		for(int y=0;y<h;y++)for(int x=0;x<w;x++)*(q++)=*(p+dy*y+x);
		BMessage	*mes=ddmessage();
		DragMessage(mes,sel_now.r);
		sel_now.f=false;
		mf=0;
	}else{
		int32	mt;					get_mouse_type(&mt);
		uint32	mk;					mk=modifiers();
		BPoint	mp;	uint32	mb;		GetMouse(&mp,&mb);
		mf=(uchar)mb;
		if(mf==B_PRIMARY_MOUSE_BUTTON){
			if(mk&B_SHIFT_KEY)mf=B_SECONDARY_MOUSE_BUTTON;
			if(mk&B_CONTROL_KEY)mf=B_TERTIARY_MOUSE_BUTTON;
		}
		sel_now.r.left=sel_now.r.right=pt.x;
		sel_now.r.top=sel_now.r.bottom=pt.y;
		sel_now.f=(mf<4);
	}
}

void gproxview::MouseUp(BPoint pt)
{
	BRect r=sel_now.r;
	if(r.left>r.right){sel_now.r.left=r.right;sel_now.r.right=r.left;}
	if(r.top>r.bottom){sel_now.r.top=r.bottom;sel_now.r.bottom=r.top;}
	if(mf==2){
		uint32	*p=(uint32*)(bm->Bits());
		int		dy=bm->BytesPerRow()/4;
		int		w=sel_now.r.right-sel_now.r.left+1;
		int		h=sel_now.r.bottom-sel_now.r.top+1;
		pic.Set(0,0,w-1,h-1);
		BBitmap	*nbm=new BBitmap(pic,B_RGB_32_BIT);
		uint32	*np=(uint32*)(nbm->Bits());
		p+=(int)(sel_now.r.top*dy+sel_now.r.left);
		for(int y=0;y<h;y++)for(int x=0;x<w;x++)*(np++)=*(p+dy*y+x);
		delete	bm;
		bm=nbm;
		sel_now.f=false;
		redraw();
	}
	mf=0;
}

void gproxview::MouseMoved(BPoint pt,uint32 code,const BMessage *msg)
{
	if(mf){
		if(mf==4){
			uint32	mb;		GetMouse(&pt,&mb,false);
			BRect	b=Bounds();
			BPoint	npt=pt-b.LeftTop();
			int	dx=mpt.x-npt.x;
			int	dy=mpt.y-npt.y;
			if(b.left+dx<pic.left)dx=pic.left-b.left;
			if(b.right+dx>pic.right)dx=pic.right-b.right;
			if(b.top+dy<pic.top)dy=pic.top-b.top;
			if(b.bottom+dy>pic.bottom)dy=pic.bottom-b.bottom;
			mpt=npt;
			sel_now.r.SetRightBottom(pt);
			ScrollBy(dx,dy);
		}else{
			if(pt.x<pic.left)pt.x=pic.left;
			if(pt.x>pic.right)pt.x=pic.right;
			if(pt.y<pic.top)pt.y=pic.top;
			if(pt.y>pic.bottom)pt.y=pic.bottom;
			sel_now.r.SetRightBottom(pt);
		}
	}
}

void gproxview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	static BPoint	dp;
	BPoint	dr_pt,dr_off;
	if((!msg->FindPoint("_drop_point_",&dr_pt))&&(!msg->FindPoint("_drop_offset_",&dr_off))){
		ConvertFromScreen(&dr_pt);
		float	sc;
		if(!msg->FindFloat("scale",&sc))dr_off=BPoint(dr_off.x/sc,dr_off.y/sc);	//for gprop
		dp=dr_pt-dr_off;
	}

	switch(msg->what){
		case B_COPY_TARGET:{	//drop(to external)
			ddcopy(msg);
		}break;
		case B_SIMPLE_DATA:{	//'DATA'(drop from external)
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){		//file
				for(int i=0;i<files;i++){
					entry_ref	eref;
					msg->FindRef("refs",i,&eref);
					load(eref);
					if(bm)break;
				}
				break;
			}
			const char	*name;
			if(!msg->FindString("be:clip_name",&name)){	//image
				BMessage	mes(B_COPY_TARGET);
				int32	idx=0;
				const char	*mime;
				while(!msg->FindString("be:types",idx++,&mime)){
					if(!strncmp(mime,"image",5)){
						mes.AddString("be:types",mime);
    					msg->SendReply(&mes,this);
						break;
					}
				}
				break;
			}
		}
		case 'MIME':{
			Char 	*mime;
			type_code	type;
			if(msg->GetInfo(B_MIME_TYPE,0,&mime,&type)==B_OK){
				long	bc;
				const void	*d;
				if(!strncmp(mime,"image",5)){			//image data
					if(!msg->FindData(mime,B_MIME_TYPE,&d,&bc)){
						BMemoryIO		mem(d,bc);
						BBitmapStream	strm;
						if(strcmp(mime,"image/x-be-bitmap")){
							tr->Translate(&mem,NULL,NULL,&strm,B_TRANSLATOR_BITMAP,0,mime);
						}else{
							uchar	tbuf[1024];
							int32	tlen;
							while((tlen=mem.Read(tbuf,1024))>0)strm.Write(tbuf,tlen);
						}
						BBitmap *bmp;
						strm.DetachBitmap(&bmp);
						bool	rf=false;
						uint32	*s_dat=(uint32*)(bmp->Bits());
						int		w=bmp->Bounds().IntegerWidth()+1;
						int		h=bmp->Bounds().IntegerHeight()+1;
						if(bm==NULL){
							dp=BPoint(0,0);
							pic.Set(0,0,w-1,h-1);
							bm=new BBitmap(pic,B_RGB_32_BIT);
							memset(bm->Bits(),0,bm->BitsLength());
							rf=true;
							strcpy(title,"no title");
						}
						uint32	*p=(uint32*)(bm->Bits());
						int		dy=bm->BytesPerRow()/4;
						int		l=dp.x;
						int		t=dp.y;
						p+=(int)t*dy+l;
						for(int y=0;y<h;y++)for(int x=0;x<w;x++){
							if(!pic.Contains(BPoint(l+x,t+y)))continue;
							*(p+dy*y+x)=*((uint32*)(s_dat)+w*y+x);
						}
						delete bmp;
						redraw(rf);
					}
				}
			}
		}break;
		case B_SAVE_REQUESTED:{		//save
			entry_ref	dir;
			char	*name;
			msg->FindRef("directory",&dir);
			msg->FindString("name",(const char**)&name);
			save(dir,name);
			fp=NULL;
		}break;
		case B_CANCEL:{				//save cansel
			fp=NULL;
		}break;
		case 'fiop':{
			if(fp==NULL){
				fp=new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		case 'fica':{				//capture
			Window()->Hide();
			delete bm;
			BScreen	*bs=new BScreen(Window());
			pic=bs->Frame();
			delete bs;
			bm=new BBitmap(pic,B_RGB_32_BIT);
			_get_screen_bitmap_(bm,pic,false);
#if	__POWERPC__
			uint32	*p=(uint32*)bm->Bits();
			int	len=bm->BitsLength()/4;
			for(int i=0;i<len;i++)*(p++)|=0x000000ff;
#endif
			Window()->Show();
			redraw();
		}break;
		case 'ficl':{
			if(bm){
				delete bm;bm=NULL;
				redraw();
			}
		}break;
		case 'fiwr':{
			if(bm){
				if(fp==NULL){
					msg->FindInt16("format_no",&xfno);
					fp=new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false);
					fp->Window()->SetTitle(((xlator*)xlt.ItemAt(xfno))->name);
					fp->Show();
				}
			}
		}break;
		case 'fipr':{				//printout
			if(bm){
				BPrintJob	prt("gprox");
				prt.ConfigPage();
				prt.ConfigJob();
				BRect		pr=prt.PrintableRect();
				prt.BeginJob();
				prt.DrawView(this,pic,BPoint(0,0));
				prt.SpoolPage();
				prt.CommitJob();
			}
		}break;
		case 'conf':{
			int16	no;
			msg->FindInt16("format_no",&no);
			if(!cwin){
				cwin=TRUE;
				configwindow *window=new configwindow(((xlator*)xlt.ItemAt(no))->id,((xlator*)xlt.ItemAt(no))->name);
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

BMessage* gproxview::ddmessage()
{
	BMessage	*msg=new BMessage(B_SIMPLE_DATA);
	msg->AddString("be:types","image/x-be-bitmap");
	for(int i=0;i<trc;i++){
		msg->AddString("be:types",((xlator*)xlt.ItemAt(i))->mime);
		msg->AddString("be:filetypes",((xlator*)xlt.ItemAt(i))->mime);			//for output
		msg->AddString("be:type_descriptions",((xlator*)xlt.ItemAt(i))->name);	//for menu
	}
	msg->AddString("be:types",B_FILE_MIME_TYPE);
	msg->AddInt32("be:actions",B_COPY_TARGET);
	msg->AddString("be:clip_name","Gprox_img");
	msg->AddString("source","gprox");
	return(msg);
}

void gproxview::ddcopy(BMessage *msg)
{
	if(bmdd==NULL)return;
	BBitmapStream	strm(bmdd);
	entry_ref	dir;
	const char	*name,*mime;
	translator_id	tid;
	uint32	fmt;
	if(msg->FindRef("directory",&dir)==B_OK){
		msg->FindString("name",&name);
		msg->FindString("be:filetypes",&mime);
		BFile	*wf=new BFile();
		BDirectory(&dir).CreateFile(name,wf,false);
		select_trans(mime,&tid,&fmt);
		tr->Translate(tid,&strm,NULL,wf,fmt);
		BAppFileInfo	wfi(wf);
		wfi.SetType(mime);
		delete wf;
	}else{
		msg->FindString("be:types",&mime);
		BMallocIO	*dat=new BMallocIO;
		BMessage	*res=new BMessage(B_MIME_DATA);
		if(strcmp(mime,"image/x-be-bitmap")){
			select_trans(mime,&tid,&fmt);
			tr->Translate(tid,&strm,NULL,dat,fmt);
		}else{
			uchar	tbuf[1024];
			int32	tlen;
			while((tlen=strm.Read(tbuf,1024))>0)dat->Write(tbuf,tlen);
		}
		res->AddData(mime,B_MIME_DATA,dat->Buffer(),dat->BufferLength());
		msg->SendReply(res);
		delete dat;
		delete res;
	}
	bmdd=NULL;
}

void gproxview::select_trans(const char *mime,translator_id *tid,uint32 *fmt)
{
	for(int i=0;i<trc;i++){
		if(strcmp(((xlator*)xlt.ItemAt(i))->mime,mime))continue;
		*tid=((xlator*)xlt.ItemAt(i))->id;
		*fmt=((xlator*)xlt.ItemAt(i))->type;
		return;
	}
	*tid=0;
	*fmt=0;
}

void gproxview::redraw(bool rf)
{
	if(bm){
		SetViewColor(B_TRANSPARENT_32_BIT);
		pic=bm->Bounds();
		if(rf)((gproxwindow*)Window())->resizeview(pic.Width(),pic.Height());
		char	s[64];
		sprintf(s,"%s[%dx%d]",title,pic.IntegerWidth()+1,pic.IntegerHeight()+1);
		Window()->SetTitle(s);
		Draw(Bounds());
	}else{
		Hide();
		SetViewColor(0,0,0);
		pic=BRect(-1,-1,-1,-1);
		if(rf)((gproxwindow*)Window())->resizeview(0,0);
		Window()->SetTitle("gprox "VER);
		Show();
	}
}

void gproxview::drawframe(const s_sel &fr)
{
	BRect	r;
	r=fr.r;
	if(r.left>r.right){r.left=fr.r.right;r.right=fr.r.left;}
	if(r.top>r.bottom){r.top=fr.r.bottom;r.bottom=fr.r.top;}
	StrokeRect(r,B_MIXED_COLORS);
}

void gproxview::eraseframe(const s_sel &fr)
{
	BRect	r,rr;
	r=fr.r;
	if(r.left>r.right){r.left=fr.r.right;r.right=fr.r.left;}
	if(r.top>r.bottom){r.top=fr.r.bottom;r.bottom=fr.r.top;}
	rr.Set(r.left,r.top,r.right,r.top);			DrawBitmap(bm,rr,rr);
	rr.Set(r.left,r.bottom,r.right,r.bottom);	DrawBitmap(bm,rr,rr);
	rr.Set(r.left,r.top,r.left,r.bottom);		DrawBitmap(bm,rr,rr);
	rr.Set(r.right,r.top,r.right,r.bottom);		DrawBitmap(bm,rr,rr);
}

void gproxview::load(entry_ref &eref)
{
	BFile	*rf=new BFile(&eref,O_RDONLY|O_BINARY);
	strcpy(title,eref.name);
	if(bm){delete bm;bm=NULL;}
	BBitmapStream	outstrm;
	if(!tr->Translate(rf,NULL,NULL,&outstrm,B_TRANSLATOR_BITMAP))outstrm.DetachBitmap(&bm);
	delete	rf;

#if	BYTE_ORDER==__BIG_ENDIAN
//printf("colorspace %04x\n",bm->ColorSpace());
	if((bm->ColorSpace()==B_RGB32_BIG)||(bm->ColorSpace()==B_RGBA32_BIG)){
		BBitmap	*tbm=bm;
		bm=new BBitmap(tbm->Bounds(),B_RGB_32_BIT);
		uint32	*q=(uint32*)bm->Bits();
		uint32	*p=(uint32*)tbm->Bits();
		int	len=tbm->BitsLength()/4;
		for(int i=0;i<len;i++)*(q++)=B_SWAP_INT32(*(p++));
		delete	tbm;
	}
#endif

	redraw();
}

void gproxview::save(entry_ref &dir,char *name)
{
	BFile	*wf=new BFile();
	BDirectory(&dir).CreateFile(name,wf,false);
	BBitmapStream	instrm(bm);
	tr->Translate(&instrm,NULL,NULL,wf,((xlator*)xlt.ItemAt(xfno))->type);
	instrm.DetachBitmap(&bm);
	BAppFileInfo	wfi(wf);
	wfi.SetType(((xlator*)xlt.ItemAt(xfno))->mime);
	delete	wf;
}
//------------------------------------------------
configwindow::configwindow(const translator_id &id,const char *title):BWindow(BRect(100,100,100,100),title,B_TITLED_WINDOW,B_NOT_RESIZABLE|B_NOT_ZOOMABLE)
{
	BView	*cview;
	BRect	r;
	if(!tr->MakeConfigurationView(id,NULL,&cview,&r)){
		AddChild(cview);
		ResizeTo(r.Width(),r.Height());
		Show();
	}else{
		cwin=false;
		delete this;
	}
}

bool configwindow::QuitRequested()
{
	cwin=false;
	return(true);
}
