// gprox.h		ver.0.075
//copyright 1998-2004 Beer[Tsutsumi Hiroyuki]

#include	<Be.h>
#if	B_BEOS_VERSION>=0x0520
#include	<Locale.h>
typedef	const char	Char;
#else
#define	_T(str)	str
typedef	char		Char;
#endif

typedef struct{
		bool	f;
		BRect	r;
}s_sel;

class gproxview:public BView
{
	public:
		gproxview(BRect frame);
		~gproxview();
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	Pulse();
		void	MouseDown(BPoint pt);
		void	MouseUp(BPoint pt);
		void	MouseMoved(BPoint pt, uint32 code, const BMessage *msg);
		void	MessageReceived(BMessage *msg);
		BMessage*	ddmessage();		//for drag&drop
		void	ddcopy(BMessage *msg);	//for drag&drop
		void	select_trans(const char *mime,translator_id *tid,uint32 *fmt);
		void	redraw(bool rf=true);
		void	drawframe(const s_sel &fr);
		void	eraseframe(const s_sel &fr);
		void	load(entry_ref &eref);
		void	save(entry_ref &dir,char *name);
	private:
		friend void	_get_screen_bitmap_(BBitmap*,BRect,bool);
		BBitmap		*bm,*bmdd;	//canvas,drag&drop
		BFilePanel	*fp;
		int			mf;
		BPoint		mpt;
		s_sel		sel_old,sel_now;
		int16		xfno;
		char		title[64];
};

class gproxwindow:public BWindow
{
	public:
		gproxwindow(BRect frame);
		bool	QuitRequested();
		void	FrameResized(float width,float height);
		void	resizeview(int width,int height);
		void	setupmenus();
		void	get_translator_for_output();
		gproxview	*v;
		BScrollBar	*sbv,*sbh;
};

class gprox:public BApplication
{
	public:
		gprox(int argc,char **argv);
		void	RefsReceived(BMessage *mes);
		void	MessageReceived(BMessage *mes);
		void	AboutRequested();
		gproxwindow	*w;
};

class configwindow:public BWindow
{
	public:
		configwindow(const translator_id &id,const char *title);
		bool	QuitRequested();
};


BRect				pic;
bool				cwin=false;
BTranslatorRoster	*tr;
int32				trc=0;
BList				xlt;

struct xlator{
	translator_id		id;
	uint32				type;
	char				name[251];
	char				mime[251];
};
